package JavaQuat20;

import java.awt.*;
import java.util.*;
import java.awt.event.*;
import java.awt.image.ImageObserver;

public class ColorEditor extends Panel implements ColorConsumerWithLabel, ActionListener 
{
  ColorMapEditor parent;

  Swatch swatch;
  Label topLabel1;
  FlickerlessScrollbar bar1;
  WatchedTextField sideText1;
  Label botLabel1;
  WatchedTextField botText1;
    
  Label topLabel2;
  FlickerlessScrollbar bar2;
  WatchedTextField sideText2;
  Label botLabel2;
  WatchedTextField botText2;
    
  Label topLabel3;
  FlickerlessScrollbar bar3;
  WatchedTextField sideText3;
  Label botLabel3;
  WatchedTextField botText3;
    
  Label filler;
  Button toggle;
    
  // Logical Collections
  WatchedTextField [] sideText;
  WatchedTextField [] botText;
  String [] RGBStrings = {"Red", "Green", "Blue", "RGB"};
  String [] HSBStrings = {"Hue", "Saturation", "Brightness", "HSB"};
  String [] HSBShortStrings = {"Hue", "Sat.", "Bright.", "HSB"};
  Label [] topLabels;
  Label [] botLabels;
  FlickerlessScrollbar [] bars;
  SliderColorControls sliderControls;
  RGBColorControls rgbControls;
  HSBColorControls hsbControls;
  boolean RGB_p;
  boolean swatchUnlabeled_p_ = true;
  
  static int CREAM = 0xFFFF99;
  Color cream;

  
  
  public ColorEditor (ColorMapEditor target) 
  {
    parent = target;
    Color theColor = new Color(0, 0, 0);
    RGB_p = true;
    Vector smallAlpha = new Vector(10);

    
    // Make the basic components of this editor.
    swatch = new Swatch(50);
    swatch.setBackground(theColor);

    topLabel1 = new Label("Red");
    topLabel1.setAlignment(Label.CENTER);
    smallAlpha.addElement(topLabel1);
    bar1 = 
      new FlickerlessScrollbar(Scrollbar.HORIZONTAL, theColor.getRed(), 1, 0, 255);
    sideText1 = new WatchedTextField(3);
    smallAlpha.addElement(sideText1);
    botLabel1 = new Label("Hue");
    botLabel1.setAlignment(Label.CENTER);
    smallAlpha.addElement(botLabel1);
    botText1 = new WatchedTextField(3);
    smallAlpha.addElement(botText1);
    
    topLabel2 = new Label("Green");
    topLabel2.setAlignment(Label.CENTER);
    smallAlpha.addElement(topLabel2);
    bar2 = 
      new FlickerlessScrollbar(Scrollbar.HORIZONTAL, theColor.getGreen(), 0, 0, 255);
    sideText2 = new WatchedTextField(3);
    smallAlpha.addElement(sideText2);
    botLabel2 = new Label("Saturation");
    botLabel2.setAlignment(Label.CENTER);
    smallAlpha.addElement(botLabel2);
    botText2 = new WatchedTextField(3);
    smallAlpha.addElement(botText2);
    
    topLabel3 = new Label("Blue");
    topLabel3.setAlignment(Label.CENTER);
    smallAlpha.addElement(topLabel3);
    bar3 = 
      new FlickerlessScrollbar(Scrollbar.HORIZONTAL, theColor.getBlue(), 0, 0, 255);
    sideText3 = new WatchedTextField(3);
    smallAlpha.addElement(sideText3);
    botLabel3 = new Label("Brightness");
    botLabel3.setAlignment(Label.CENTER);
    smallAlpha.addElement(botLabel3);
    botText3 = new WatchedTextField(3);
    smallAlpha.addElement(botText3);
    
    filler = new Label("sliders");
    filler.setAlignment(Label.CENTER);
    smallAlpha.addElement(filler);
    cream = new Color(CREAM); 
    toggle = new Button("RGB");
    smallAlpha.addElement(toggle);
    toggle.setBackground(cream);
    toggle.addActionListener(this);
    
    // Logical Collections
    sideText = new WatchedTextField[3];
    sideText[0] = sideText1; sideText[1] = sideText2; sideText[2] = sideText3;
    botText = new WatchedTextField[3];
    botText[0] = botText1; botText[1] = botText2; botText[2] = botText3;
    topLabels = new Label[3];
    topLabels[0] = topLabel1; topLabels[1] = topLabel2; topLabels[2] = topLabel3;
    botLabels = new Label[3];
    botLabels[0] = botLabel1; botLabels[1] = botLabel2; botLabels[2] = botLabel3;
    bars = new FlickerlessScrollbar[3];
    bars[0] = bar1; bars[1] = bar2; bars[2] = bar3;
    sliderControls = new SliderColorControls(this, bars, theColor);
    rgbControls = new RGBColorControls(this, sideText, theColor);
    hsbControls = new HSBColorControls(this, botText, theColor);

    // Lay out the components
    Panel [] outerSliderBox = new Panel[3];
    for (int i = 0; i < 3; i++) {
      Panel innerSlider = new Panel();
      innerSlider.setLayout(new BorderLayout(2, 2));
      innerSlider.add("West", bars[i]);
      innerSlider.add("Center", sideText[i]);
      outerSliderBox[i] = new Panel();
      outerSliderBox[i].setLayout(new GridLayout(2, 1, 2, 2));
      outerSliderBox[i].add(topLabels[i]);
      outerSliderBox[i].add(innerSlider);
    }
    
    //Panel topBox = new Panel();
    //topBox.setLayout(new GridLayout(2, 1, 2, 2));
    //topBox.add(swatch);
    //topBox.add(outerSliderBox[0]);
    
    //Panel sliderBox = new Panel();
    //sliderBox.setLayout(new GridLayout(2, 1, 2, 2));
    //sliderBox.add(outerSliderBox[1]);
    //sliderBox.add(outerSliderBox[2]);
    
    // Now do the bottom labels and text, and RGB/HSB toggle button
    Panel [] bottomBoxes = new Panel[4]; // Extra one for toggle
    for (int j = 0; j < 3; j++) {
      bottomBoxes[j] = new Panel();
      bottomBoxes[j].setLayout(new BorderLayout(2, 2));
      bottomBoxes[j].add("Center", botLabels[j]);
      bottomBoxes[j].add("South", botText[j]);
    }
      
    bottomBoxes[3] = new Panel();
    bottomBoxes[3].setLayout(new BorderLayout(2, 2));
    bottomBoxes[3].add("Center", filler);
    bottomBoxes[3].add("South", toggle);
    
    Panel botBox = new Panel();
    botBox.setLayout(new GridLayout(1, 4, 2, 2));
    botBox.add(bottomBoxes[0]);
    botBox.add(bottomBoxes[1]);
    botBox.add(bottomBoxes[2]);
    botBox.add(bottomBoxes[3]);
    
    //setLayout(new BorderLayout(2, 2));
    //add("North", topBox);
    //add("South", botBox);
    //add("Center", sliderBox);
    
    setLayout(new GridLayout(5, 1, 0, 0));
    add(swatch);
    add(outerSliderBox[0]);
    add(outerSliderBox[1]);
    add(outerSliderBox[2]);
    //add(topBox);
    //add(sliderBox);
    add(botBox);
    
    sliderControls.setBars(bars);
    rgbControls.setColor(theColor); //So next line has a color to get.
    set_rgb_configuration();
    
    String [] preferredFonts = {"Courier", "courier", 
                                  "Dialog", "dialog", 
                                  "Times", "times"};
    FontSetter setter = new FontSetter(preferredFonts, Font.BOLD, 9);
    setter.setComponentFonts(smallAlpha);
  }
  
//  public Insets insets ()
//  {
//    return new Insets(10, 10, 10, 10);
//  }

  private Color contrastingColor(Color c)
  {
    int fRed = (c.getRed() > 128) ? 0 :255;
    int fGreen = (c.getGreen() > 128) ? 0 : 255;
    int fBlue = (c.getBlue() > 128) ? 0 : 255;
    return new Color(fRed, fGreen, fBlue);
  }

  public void setLabel (String labelString)
  {
    if (swatchUnlabeled_p_) {
      Vector bigAlpha = new Vector(2);
      bigAlpha.addElement(swatch);
      String [] preferredFonts = {"Courier", "courier", 
                                  "Dialog", "dialog", 
                                  "Times", "times"};
      FontSetter setter = new FontSetter(preferredFonts, Font.BOLD, 20);
      setter.setComponentFonts(bigAlpha);
      swatchUnlabeled_p_ = false;
    }
    Color bColor = swatch.getBackground();
    swatch.setForeground(contrastingColor(bColor));
    swatch.setText(labelString);
  } 

  void set_rgb_configuration ()
  {
    Color c = rgbControls.getColor();
    rgbControls.setTextFields(sideText);
    rgbControls.setColor(c);
    hsbControls.setTextFields(botText);
    hsbControls.setColor(c);
    sliderControls.setColor(c);
    for (int i = 0; i < topLabels.length; i++) {
      topLabels[i].setText(RGBStrings[i]);
      botLabels[i].setText(HSBShortStrings[i]);
    }
    toggle.setLabel(RGBStrings[3]);
  }
  
  void set_hsb_configuration ()
  {
    Color c = rgbControls.getColor();
    rgbControls.setTextFields(botText);
    rgbControls.setColor(c);
    hsbControls.setTextFields(sideText);
    hsbControls.setColor(c);
    sliderControls.setColor(c);
    for (int i = 0; i < topLabels.length; i++) {
      topLabels[i].setText(HSBStrings[i]);
      botLabels[i].setText(RGBStrings[i]);
    }
    toggle.setLabel(HSBStrings[3]);
  }
  
  void shareValue (ColorProducer in, boolean parentTooP)
  {
    Color c = in.getColor();
    if (in != rgbControls) {
      rgbControls.setColor(c);
    }
    if (in != hsbControls) {
      hsbControls.setColor(c);
    }
    if (in != sliderControls) {
      sliderControls.setColor(c);
    }
    swatch.setBackground(c);
    swatch.setForeground(contrastingColor(c));
    swatch.repaint();
    if (parentTooP) {
      parent.setColor(c);
    }
  }
  
  public void setColor (Color c)
  {
    rgbControls.setColor(c);
    hsbControls.setColor(c);
    sliderControls.setColor(c);
    swatch.setBackground(c);
    swatch.setForeground(contrastingColor(c));
    swatch.repaint();
  }
  
  public void actionPerformed(ActionEvent event)
  {
    RGB_p = !RGB_p;
    if (RGB_p) {
      set_rgb_configuration();
    } else {
      set_hsb_configuration();
    }
  }
}


class Swatch extends Label
{
  int height;
  
  Swatch (int height1)
  {
    super("-1", Label.CENTER);
    height = height1;
  }
  
  public Dimension getMinimumSize ()
  {
    return new Dimension(250, height);
  }
  
  public Dimension getPreferredSize ()
  {
    return new Dimension(250, height);
  }
}

class FlickerlessScrollbar extends Scrollbar implements AdjustmentListener
{
  int previous_value = -1;
  ColorProducer watcher;
  ColorEditor parent;
  int lastValueToOutsideWorld = -1;
  boolean mouseInside = false;
  
  FlickerlessScrollbar (int  orientation, int  value, int  visible, int  minimum, int  maximum)
  {
    super(orientation, value, visible, minimum, maximum);
    watcher = null;
    addAdjustmentListener(this);
  }
   
  void setWatcherAndParent (ColorProducer w, ColorEditor p)
  {
    watcher = w; // This is the FractalMaker4d.
    parent = p;  // This is the ColorMapEditor.
  }
    
  public void setValues (int value, int visible, int min, int max)
  {
//    System.out.println("Flickerless.setValueS entry lastValueToOutsideWorld =" + 
//                       lastValueToOutsideWorld + " value=" + value);
     super.setValues(value, visible, min, max);
     if (!mouseInside) { // If someone else is setting our value rather than us indirectly,
       lastValueToOutsideWorld = value;  // then it is the last value known by the outside world.
     }
  }  
  
  public void adjustmentValueChanged(AdjustmentEvent e)
    //  This is for adjustment of the scroll bar.
  {
    int newValue = e.getValue();
            
//      System.out.println("Flickerless.handleEvent newValue=" + newValue + " last2world = " + 
//                         lastValueToOutsideWorld + " tell =" + tellOutsideWorld);
    if (newValue != previous_value) {
      previous_value = newValue;
      parent.shareValue(watcher, true); // Second arg is probably extraneous.
    }
  }

  
/* ******* mac-cafe and sun applet viewers do not generate a mouseUp event inside scrollbars *** */
//  public boolean mouseUp (Event event, int x, int y)
//  {
//     System.out.println("Flickerless MouseUP!.");
//     return true;
//    if (event.target instanceof Scrollbar) { 
//      if (watcher != null) {
//        previous_value = getValue();
//        parent.shareValue(watcher, true);
//      }
//      return true;
//    } else {
//      return super.handleEvent(event);
//    }
//  }
    

  public Dimension getMinimumSize ()
  {
    return new Dimension(192, 15);
  }
  
  public Dimension getPreferredSize ()
  {
    return new Dimension(192, 15);
  }
} 


class WatchedTextField extends TextField implements ActionListener
  // With the new AWT this class is superfluous.  So REMOVE THIS.
{
  ColorProducer watcher;
  ColorEditor parent;
  
  WatchedTextField (int cols)
  {
    watcher = null;
    addActionListener(this);
  }
  
  void setWatcherAndParent (ColorProducer w, ColorEditor p)
  {
    watcher = w;
    parent = p;
  }

  public void actionPerformed(ActionEvent event) 
  {
    if (watcher == null) {
      System.out.println("WatchedTextField lacks a watcher.");
    }
    parent.shareValue(watcher, true);
  }

  public Dimension getMinimumSize ()
  {
    return new Dimension(40, 15);
  }
  
  public Dimension getPreferredSize ()
  {
    return new Dimension(40, 15);
  }
} 
  


class SliderColorControls implements ColorProducer
{
  FlickerlessScrollbar f1, f2, f3;
  ColorEditor parent;
  
  SliderColorControls (ColorEditor target, FlickerlessScrollbar [] bars, Color color)
  {
    this.parent = target;
    f1 = bars[0];
    f2 = bars[1];
    f3 = bars[2];
    setColor(color);
  }
  
//  public void update ()
//  {
//    parent.shareValue(this, false);
//  }
  
  public Color getColor ()
  {
    int partR = f1.getValue();
    int partG = f2.getValue();
    int partB = f3.getValue();
    if (parent.RGB_p)
      return new Color(partR, partG, partB);
    return Color.getHSBColor((float)partR / 360, (float)partG / 100, (float)partB / 100);
  }
  
  public void setColor (Color c)
  {
    if (parent.RGB_p) {
      if (f1.getMaximum() == 225) {
        f1.setValue(c.getRed());
        f2.setValue(c.getGreen());
        f3.setValue(c.getBlue());
      } else {
        f1.setValues(c.getRed(), 5, 0, 255);
        f2.setValues(c.getGreen(), 5, 0, 255);
        f3.setValues(c.getBlue(), 5, 0, 255);
      }
    } else {
      float[] hsb = Color.RGBtoHSB(c.getRed(), c.getGreen(), c.getBlue(), (new float[3]));
      if (f1.getMaximum() == 359) {
        f1.setValue((int)(hsb[0] * 359));
        f2.setValue((int)(hsb[1] * 100));
        f3.setValue((int)(hsb[2] * 100));
      } else {
        f1.setValues((int)(hsb[0] * 359), 18 ,0 ,359);
        f2.setValues((int)(hsb[1] * 100), 5 ,0, 100);
        f3.setValues((int)(hsb[2] * 100), 5 ,0, 100); 
      }      
    }
  }
  
  void setBars (FlickerlessScrollbar [] bars)
  {
    f1 = bars[0];
    f2 = bars[1];
    f3 = bars[2];
    f1.setWatcherAndParent(this,parent);
    f2.setWatcherAndParent(this,parent);
    f3.setWatcherAndParent(this,parent);
  }    
}


class HSBColorControls implements ColorProducer
  // This class does no layout, but controls the display in the HSB text fields.
{
  WatchedTextField f1, f2, f3;
  ColorEditor parent;
  
  HSBColorControls(ColorEditor target, WatchedTextField [] textFields, Color color)
  {
    parent = target;
    setTextFields(textFields);
    setColor(color);
  }
  
  void setTextFields (WatchedTextField [] textFields)
  {
    f1 = textFields[0];
    f2 = textFields[1];
    f3 = textFields[2];
    f1.setWatcherAndParent(this,parent);
    f2.setWatcherAndParent(this,parent);
    f3.setWatcherAndParent(this,parent);
  }    
  
  public Color getColor ()
  {
    String s1 = f1.getText();
    String s2 = f2.getText();
    String s3 = f3.getText();
    int v1, v2, v3;
    try {
      v1 = Integer.parseInt(s1);
    } catch (NumberFormatException e) {
      v1 = 0;
    }
    try {
      v2 = Integer.parseInt(s2);
    } catch (NumberFormatException e) {
      v2 = 0;
    }
    try {
      v3 = Integer.parseInt(s3);
    } catch (NumberFormatException e) {
      v3 = 0;
    }
    return Color.getHSBColor((float)v1 / 360, (float)v2 / 100, (float)v3 / 100);
  }
  
  public void setColor (Color c)
  {
    float[] hsb = Color.RGBtoHSB(c.getRed(), c.getGreen(), c.getBlue(), (new float[3]));
    hsb[0] *= 360;
    hsb[1] *= 100;
    hsb[2] *= 100;
    f1.setText(String.valueOf((int)hsb[0]));
    f2.setText(String.valueOf((int)hsb[1]));
    f3.setText(String.valueOf((int)hsb[2]));
  }
  
//  public Insets insets ()
//  {
//    return new Insets(10, 10, 0, 0);
//  }
}
  
  
class RGBColorControls implements ColorProducer
  // This class does no layout, but controls the display in the RGB text fields.
{
  WatchedTextField f1, f2, f3;
  ColorEditor parent;
  
  RGBColorControls(ColorEditor target, WatchedTextField [] textFields, Color color)
  {
    parent = target;
    setTextFields(textFields);
  }
  
  void setTextFields (WatchedTextField [] textFields)
  {
    f1 = textFields[0];
    f2 = textFields[1];
    f3 = textFields[2];
    f1.setWatcherAndParent(this,parent);
    f2.setWatcherAndParent(this,parent);
    f3.setWatcherAndParent(this,parent);
  }    
  
  public Color getColor ()
  {
    String s1 = f1.getText();
    String s2 = f2.getText();
    String s3 = f3.getText();
    int v1, v2, v3;
    try {
      v1 = Integer.parseInt(s1);
      f1.setForeground(Color.black);
    } catch (NumberFormatException e) {
      v1 = 0;
      f1.setForeground(Color.red);
    }
    try {
      v2 = Integer.parseInt(s2);
    } catch (NumberFormatException e) {
      v2 = 0;
    }
    try {
      v3 = Integer.parseInt(s3);
    } catch (NumberFormatException e) {
      v3 = 0;
    }
    return new Color(v1, v2, v3);
  }
  
  public void setColor (Color c)
  {
    f1.setText(String.valueOf(c.getRed()));
    f2.setText(String.valueOf(c.getGreen()));
    f3.setText(String.valueOf(c.getBlue()));
  }
}
  
  
  
/*
  public Dimension getMinimumSize ()
  {
    return new Dimension(290, height);
  }
  
  public Dimension getPreferredSize ()
  {
    return new Dimension(290, height);
  }
 */ 
  
  
  
  
  
  
  
  
  
   
      
      
      
      
      
      
      
      
      
