package JavaQuat20;

import java.awt.*;
import java.awt.image.ImageObserver;
import java.awt.event.*;
import JavaQuat20.GIFDecoderPkg.*;
import java.io.*;
import java.util.Vector;

public class ColorMapEditor extends Frame implements ColorConsumer, ColorMapOwner
{
  static int CREAM = 0xFFFF99;
  final int ROT_HUE = 0;
  final int MULT_SAT = 1;
  final int MULT_BRI = 2;

  ColorEditor colorEditor; 
  ColorMapBox mapBox;
//  CE_BtnBx buttonBox;
  private ColorMapEditor self_;

  int colorMapIndex = 0;
  int offsetIntoColorMap = 0; // What was this for?  Unused at present.
  
  private int rotHuePointsNeeded = 0;
  private int rotHueDegrees_ = 0;
  private double satBriMult_ = 1;
  private int whichRotHuePtAction_ = ROT_HUE; // could be MULT_SAT or MULT_BRI also.
  
  private int rampPointsNeeded = 0;
  int firstRampIndex = 0;
  Color firstRampColor = null;
  Color cream = new Color(CREAM);
  Color [] alertColors3 = {cream, Color.yellow, Color.pink};
  String [] rampLabels = {"Ramp Colors", "2nd Color", "1st Color"};
  String [] copyColorLabels = {"Copy Color", "Mouse Destination", "Mouse Source"};
  
  private int copyColorPointsNeeded = 0;
  Color firstCopyColor = null;
  
  JQCentral parent;
  int numberOfColors; //Now currently used.
  boolean updateCanvas_p = true;
  
  Color [] [] savedColors_;
  
  boolean reverseRampP_ = false;
  //boolean debug = true;
  
  private Menu sortKeyMenu_ = null;
  private int sortKeyToSet_ = 1;
  private Cmp [] threeSortKeys_ = null;
  private Vector sortCheckBoxes_ = null;
  private int firstSortKeyPosition_ = 0;
  private int sortPointsNeeded = 0;
  private int firstSortIndex = 0;
  
  String [] hex = {"0", "1", "2", "3", "4", "5", "6", "7", "8","9", "A", "B", "C","D", "E", "F"};

  
  ColorMapEditor (JQCentral p, int colorCount) //CONSTRUCTOR
  {
    super("Color Map Editor");
    self_ = this;
    parent = p;
    numberOfColors = colorCount; // Unused
    
    sortCheckBoxes_ = new Vector(9);
    threeSortKeys_ = new Cmp [3];

    Color theColor = new Color(1, 1, 1);
    setLayout(new GridLayout(1, 2, 2, 2));
  
    // Color Editor Controls
    colorEditor = new ColorEditor(this);
    
    Color black = new Color(0, 0, 0);
    savedColors_ = new Color [5][256];
    for (int map = 0; map < 5; map++) {
      for (int index = 0; index < 256; index++) {
        savedColors_[map][index] = black;
      }
    }
        
    // Color Map Squares
    mapBox = new ColorMapBox(this, 16, 16, 300);
    
    add(mapBox);
    add(colorEditor);
    
    /* ****************** MENUS ********************** */
    MenuBar menuBar = new MenuBar();
    setMenuBar(menuBar);
    
    /* --------------- File Menu ---------------- */
    Menu fileMenu = new Menu("File", true); // true for tearoff.
    menuBar.add(fileMenu);

    MenuItem readMI = new MenuItem("Read GIF Colors");
    readMI.addActionListener(new readLNR());
    readMI.setShortcut(new MenuShortcut(KeyEvent.VK_G));
    fileMenu.add(readMI);

    MenuItem closeMI = new MenuItem("Close");
    closeMI.addActionListener(new closeLNR());
    closeMI.setShortcut(new MenuShortcut(KeyEvent.VK_W));
    fileMenu.add(closeMI);

    /* --------------- Tools Menu ---------------- */
    Menu toolsMenu = new Menu("Tools", true); // true for tearoff.
    menuBar.add(toolsMenu);
    
    MenuItem generalMI = new MenuItem("Copy Color");
    generalMI.addActionListener(new copyLNR());
    generalMI.setShortcut(new MenuShortcut(KeyEvent.VK_K));
    toolsMenu.add(generalMI);

    generalMI = new MenuItem("Ramp Colors");
    generalMI.addActionListener(new rampLNR());
    generalMI.setShortcut(new MenuShortcut(KeyEvent.VK_R));
    toolsMenu.add(generalMI);
    
    generalMI = new MenuItem("Reverse Ramp Colors");
    generalMI.addActionListener(new revrampLNR());
    //rampMI.setShortcut(new MenuShortcut(KeyEvent.VK_R));
    toolsMenu.add(generalMI);
    
    toolsMenu.addSeparator();
    
    
    generalMI = new MenuItem("Rotate Selected Hues");
    generalMI.addActionListener(new rotHueLNR());
    //generalMI.setShortcut(new MenuShortcut(KeyEvent.VK_R));
    toolsMenu.add(generalMI);
    
    generalMI = new MenuItem("Multiply Selected Saturations");
    generalMI.addActionListener(new SatLNR());
    //generalMI.setShortcut(new MenuShortcut(KeyEvent.VK_R));
    toolsMenu.add(generalMI);
    
    generalMI = new MenuItem("Multiply Selected Brightnesses");
    generalMI.addActionListener(new BriLNR());
    //generalMI.setShortcut(new MenuShortcut(KeyEvent.VK_R));
    toolsMenu.add(generalMI);
    
    toolsMenu.addSeparator();
    
    Menu getMapMenu = new Menu("Restore Color Map", true); // true for tearoff.
    toolsMenu.add(getMapMenu);
   
      MenuItem mem1MI = new MenuItem("Get Mem 1");
      mem1MI.addActionListener(new memLNR(1, false));
      mem1MI.setShortcut(new MenuShortcut(KeyEvent.VK_1));
      getMapMenu.add(mem1MI);

      MenuItem mem2MI = new MenuItem("Get Mem 2");
      mem2MI.addActionListener(new memLNR(2, false));
      mem2MI.setShortcut(new MenuShortcut(KeyEvent.VK_2));
      getMapMenu.add(mem2MI);

      MenuItem mem3MI = new MenuItem("Get Mem 3");
      mem3MI.addActionListener(new memLNR(3, false));
      mem3MI.setShortcut(new MenuShortcut(KeyEvent.VK_3));
      getMapMenu.add(mem3MI);

      MenuItem mem4MI = new MenuItem("Get Mem 4");
      mem4MI.addActionListener(new memLNR(4, false));
      mem4MI.setShortcut(new MenuShortcut(KeyEvent.VK_4));
      getMapMenu.add(mem4MI);

      MenuItem mem5MI = new MenuItem("Get Mem 5");
      mem5MI.addActionListener(new memLNR(0, false));
      mem5MI.setShortcut(new MenuShortcut(KeyEvent.VK_5));
      getMapMenu.add(mem5MI);

    Menu saveMapMenu = new Menu("Save Color Map", true); // true for tearoff.
    toolsMenu.add(saveMapMenu);
    
      MenuItem memS1MI = new MenuItem("Save to Mem 1");
      memS1MI.addActionListener(new memLNR(1, true));
      //mem2MI.setShortcut(new MenuShortcut(KeyEvent.VK_1));
      saveMapMenu.add(memS1MI);
      
      MenuItem memS2MI = new MenuItem("Save to Mem 2");
      memS2MI.addActionListener(new memLNR(2, true));
      //mem2MI.setShortcut(new MenuShortcut(KeyEvent.VK_2));
      saveMapMenu.add(memS2MI);

      MenuItem memS3MI = new MenuItem("Save to Mem 3");
      memS3MI.addActionListener(new memLNR(3, true));
      //mem3MI.setShortcut(new MenuShortcut(KeyEvent.VK_3));
      saveMapMenu.add(memS3MI);

      MenuItem memS4MI = new MenuItem("Save to Mem 4");
      memS4MI.addActionListener(new memLNR(4, true));
      //mem4MI.setShortcut(new MenuShortcut(KeyEvent.VK_4));
      saveMapMenu.add(memS4MI);

      MenuItem memS5MI = new MenuItem("Save to Mem 5");
      memS5MI.addActionListener(new memLNR(0, true));
      //mem5MI.setShortcut(new MenuShortcut(KeyEvent.VK_5));
      saveMapMenu.add(memS5MI);
      
    /* ********************** Sort Menu ******************* */
    
    int checkBoxCount = 0;
    Menu sortMenu = new Menu("Sort", true); // true for tearoff.
    menuBar.add(sortMenu);
    
    Menu currentMenu = new Menu("Set Key #");
    sortMenu.add(currentMenu);
        currentMenu.add(newKeyNumCheckbox(checkBoxCount++));
        currentMenu.add(newKeyNumCheckbox(checkBoxCount++));
        currentMenu.add(newKeyNumCheckbox(checkBoxCount++));
        
    sortKeyMenu_ = new Menu("Set Key");
    sortKeyToSet_ = 1;
    sortMenu.add(sortKeyMenu_);
      firstSortKeyPosition_ = checkBoxCount;
       threeSortKeys_[0] = new HueCmp(checkBoxCount);
        CheckboxMenuItem hue = newKeyCheckbox("Hue", checkBoxCount++);
        hue.setState(true);
        sortKeyMenu_.add(hue);
        threeSortKeys_[1] = new SatCmp(checkBoxCount);
        sortKeyMenu_.add(newKeyCheckbox("Saturation", checkBoxCount++));
        threeSortKeys_[2] = new BriCmp(checkBoxCount);    
        sortKeyMenu_.add(newKeyCheckbox("Brightness", checkBoxCount++));
        sortKeyMenu_.add(newKeyCheckbox("Red", checkBoxCount++));
        sortKeyMenu_.add(newKeyCheckbox("Green", checkBoxCount++));
        sortKeyMenu_.add(newKeyCheckbox("Blue", checkBoxCount++));
      
    MenuItem MI = new MenuItem("Sort All Colors.");
    MI.addActionListener(new sortLNR());
    sortMenu.add(MI);
    
    MI = new MenuItem("Sort Color Range.");
    MI.addActionListener(new ssortLNR());
    sortMenu.add(MI);
    
    /* --------------- Windows Menu ---------------- */
    Menu windowsMenu = new Menu("Windows", true); // true for tearoff.
    menuBar.add(windowsMenu);
    
    MenuItem parmsMI = new MenuItem("Parameters");
    parmsMI.addActionListener(new parmsLNR());
    windowsMenu.add(parmsMI);
    
    MenuItem msgMI = new MenuItem("Messages");
    msgMI.addActionListener(new msgLNR());
    windowsMenu.add(msgMI); 
    
     
    msgMI.setShortcut(new MenuShortcut(KeyEvent.VK_M));
    parmsMI.setShortcut(new MenuShortcut(KeyEvent.VK_EQUALS));


    //setIndexAndColor(0, theColor, true);  - THIS WAS A 1.4 STATEMENT, BUT UNNECESSARY I BELIEVE.
    addWindowListener(new MyWinLNR());
    setSize(450, 250);
    setResizable(false);
  }
  
  
  public boolean debugP ()
  {
    return parent.debugP();
  }
//  void initColorMapBox*************

  private CheckboxMenuItem newKeyNumCheckbox (int key)
  {
    CheckboxMenuItem cmi = new CheckboxMenuItem("Key " + (key + 1));
    cmi.addItemListener(new keyNumLNR(key));
    cmi.setState(key == 0);
    sortCheckBoxes_.addElement(cmi);
    return cmi;
  }

  private CheckboxMenuItem newKeyCheckbox (String name, int boxPosition)
  {
    CheckboxMenuItem cmi = new CheckboxMenuItem(name);
    cmi.addItemListener(new keyLNR(name, boxPosition));
    cmi.setState(false);
    sortCheckBoxes_.addElement(cmi);
    return cmi;
  }

  private void setSortMenuCheckboxes (int caller)
  {
    for (int i = 0; i < sortCheckBoxes_.size(); i++) {
      if (i < firstSortKeyPosition_ && caller < firstSortKeyPosition_) {
        ((CheckboxMenuItem)sortCheckBoxes_.elementAt(i)).setState(i == caller);
      } else if (i >= firstSortKeyPosition_ && i != caller) {
        ((CheckboxMenuItem)sortCheckBoxes_.elementAt(i)).setState(false);
      }
    }
    if (caller < firstSortKeyPosition_) {
      int selectedCmp = threeSortKeys_[caller].idNumber();
      ((CheckboxMenuItem)sortCheckBoxes_.elementAt(selectedCmp)).setState(true);
    }
  }
  
  public void setIndexAndColor (int i, Color c, boolean completely_p)
    // Called from the ColorMapBox.  completely_p makes this the color being edited.
  {
    if (rampPointsNeeded > 0) {
      i -= offsetIntoColorMap;
      if (rampPointsNeeded == 1) {
        rampPointsNeeded = 0;
        mapBox.rampColors(firstRampIndex, firstRampColor, i, c, colorMapIndex, colorEditor.RGB_p,
                          reverseRampP_);
      } else {
        firstRampIndex = i;
        firstRampColor = c;
        rampPointsNeeded = 1;
        parent.message(rampLabels[1], false);
      }
    } else if (rotHuePointsNeeded > 0) {
      i -= offsetIntoColorMap;
      if (rotHuePointsNeeded == 1) {
        rotHuePointsNeeded = 0;
        if (whichRotHuePtAction_ == ROT_HUE) {
          mapBox.rotateHues(firstRampIndex, i, colorMapIndex, rotHueDegrees_);
        } else if (whichRotHuePtAction_ == MULT_SAT) {
          mapBox.multiplySaturation(firstRampIndex, i, colorMapIndex, satBriMult_);
        } else if (whichRotHuePtAction_ == MULT_BRI) {
          mapBox.multiplyBrightness(firstRampIndex, i, colorMapIndex, satBriMult_);
        }
      } else {
        firstRampIndex = i;
        rotHuePointsNeeded = 1;
        parent.message(rampLabels[1], false);
      }

    } else if (copyColorPointsNeeded > 0) {
      i -= offsetIntoColorMap;
      if (copyColorPointsNeeded == 1) {
        copyColorPointsNeeded = 0;
        mapBox.setColorAt(i,firstCopyColor);
        parent.setIndexAndColor(i, firstCopyColor, true); //3rd arg ignored
      } else {
        firstCopyColor = c;
        copyColorPointsNeeded = 1;
        parent.message(copyColorLabels[1], false);
      }
    } else if (sortPointsNeeded > 0) {
      i -= offsetIntoColorMap;
      if (sortPointsNeeded == 1) {
        sortPointsNeeded = 0;
        Cmp rcomp = new Cmp3(threeSortKeys_[0], threeSortKeys_[1], threeSortKeys_[2]);
        int [] pixelMap = mapBox.sortColors(firstSortIndex, i, rcomp);
        self_.parent.remapPixelIndices(pixelMap);
      } else {
        firstSortIndex = i;
        sortPointsNeeded = 1;
        parent.message(rampLabels[1], false);
      }
    } else {
      colorMapIndex = i;
      updateCanvas_p = completely_p;
      setColor(c); //Set appropriate mapBox entry and notify parent.
      updateCanvas_p = true;
      if (completely_p) {
        colorEditor.setColor(c); // Notify colorEditor of color.
        colorEditor.setLabel(makeLabel(i));
      }
    }
  }
    
  private String makeLabel(int i)
  {
    String hiChar = hex[i / 16];
    String loChar = hex[i % 16];
    return hiChar + loChar;
  }
    
  public void setColor (Color c)
    // This is called from the ColorEditor.  It must set the color in
    //   the ColorMapBox and in the fractal image.
  {
    if (parent.debugP()) { System.out.println("cMapEd.setColor Entry");}
    mapBox.setColorAt(colorMapIndex - offsetIntoColorMap, c);
    if (parent.debugP()) { System.out.println("cMapEd.setColor Mid");}
    parent.setIndexAndColor(colorMapIndex, c, updateCanvas_p); //3rd arg controls canvas repaint.
    if (parent.debugP()) { System.out.println("cMapEd.setColor Exit");}
  }

/* **********************************
  public Dimension getMinimumSize ()
  {
    return new Dimension(290, height);
  }
  
  public Dimension getPreferredSize ()
  {
    return new Dimension(290, height);
  }
  *********************************** */
  
  public void loadGIFColorMap ()
  {
    GIFDecoder gifDecoder = null;
    InputStream stream1 = null;
    FractalSpec args = null;
    String pathname = null;
    boolean is_url_p = false;
    JQIO inUtility = new JQIO((Messenger)parent, this);
    
    // Get the pathname if none was passed in.
    if (pathname == null) {
      if (is_url_p) {
        pathname = inUtility.urlStringFromDialog();
      } else {
        pathname = inUtility.pathFromDialog(true); // true => use read dialog
      }
    }
    if (pathname == null || pathname.length() == 0) {
      parent.message("No action taken.", false);
      return;
    }

    // Here we try to open the stream and extract the arguments only.
    try {
      stream1 = inUtility.toInputStream(pathname, is_url_p, false); // false => create stream.
      if (stream1 == null)
        throw new IOException("NOT FOUND: " + pathname);
      gifDecoder = new GIFDecoder(stream1, true);
      RGBxSizeSequence colorTabel1 = gifDecoder.globalRGBTable();
      if (colorTabel1 != null) {
        int length1 = colorTabel1.byteTable.length / 3;
        int i = 0;
        for (i = 0; i < length1; i++) {
        int ix3 = i * 3;
          int red1 = colorTabel1.byteTable[ix3];
          if (red1 < 0)
            red1 += 256;
          int green1 = colorTabel1.byteTable[ix3 + 1];
          if (green1 < 0)
            green1 += 256;
          int blue1 = colorTabel1.byteTable[ix3 + 2];
          if (blue1 < 0)
            blue1 += 256;
          Color color1 = new Color(red1, green1, blue1);
          setIndexAndColor(i, color1, (i == length1 - 1));
        }
      }
    } catch (Throwable e) {
      parent.message((e.getMessage() == null ? e.toString() : e.getMessage()), false);
      // e.printStackTrace();  // NEXT LINE FOR DEBUG ONLY
    } finally {
      if (stream1 != null)
        try {
          stream1.close(); // In case we didn't close it above.
        } catch (Throwable e) {}
    }  
  }

  public void receiveMemoryColor(int map, int index, Color color_)
    // This is called repeatedly by jQCentral (parent_ here) when 'this' calls sendColorMapToMemory
    // which takes the 'map' value as an argument.
  {
    savedColors_[map][index] = new Color( color_.getRed(), color_.getGreen(), color_.getBlue());
  }
  


  /* ********************* LISTENERS ******************** */
  
  class MyWinLNR implements WindowListener
  {
    public void windowOpened (WindowEvent e)
    {
      //self_.parent.message("ColorMapEditor$MyWindowLNR.windowOpened", false);
      parent.setAwaitingPoint(true);
    }

    public void windowClosing (WindowEvent e)
    {
      parent.setAwaitingPoint(false);
      self_.setVisible(false);
      //self_.parent.message("ColorMapEditor$MyWindowLNR.windowClosing", false);
    }

    public void windowClosed (WindowEvent e)
    {
      //self_.parent.message("ColorMapEditor$MyWindowLNR.windowClosed", false);
      parent.setAwaitingPoint(false);
    }

    public void windowIconified (WindowEvent e)
    {
      //self_.parent.message("ColorMapEditor$MyWindowLNR.windowIconified", false);
      parent.setAwaitingPoint(false);
    }

    public void windowDeiconified (WindowEvent e)
    {
      //self_.parent.message("ColorMapEditor$MyWindowLNR.windowDeiconified", true);
      parent.setAwaitingPoint(true);
    }

    public void windowActivated (WindowEvent e)
    {
      //self_.parent.message("ColorMapEditor$MyWindowLNR.windowActivated", false);
      parent.setAwaitingPoint(true);
    }

    public void windowDeactivated (WindowEvent e)
    {
      //parent.setAwaitingPoint(false);
      //self_.parent.message("ColorMapEditor$MyWindowLNR.windowDeactivated", false);
    }
  }


    // closeLNR copyLNR getMapLNR rampLNR  readLNR
    
  class readLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      self_.loadGIFColorMap();
    }
  }    
    
  class closeLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      self_.setVisible(false);
      parent.setAwaitingPoint(false);
    }
  }

  class copyLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
      // Real action is in setIndexAndColor.
    {
      self_.rampPointsNeeded = 0;
      self_.sortPointsNeeded = 0;
      self_.copyColorPointsNeeded = 2;
      self_.rotHuePointsNeeded = 0;
      self_.parent.message(self_.copyColorLabels[2], false);
    }
  }

  class rampLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
      // Real action is in setIndexAndColor.
    {
      self_.copyColorPointsNeeded = 0;
      self_.sortPointsNeeded = 0;
      self_.rampPointsNeeded = 2;
      self_.rotHuePointsNeeded = 0;
      self_.reverseRampP_ = false;
      self_.parent.message(self_.rampLabels[2], false);
    }
  }

  class revrampLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
      // Real action is in setIndexAndColor.
    {
      self_.copyColorPointsNeeded = 0;
      self_.sortPointsNeeded = 0;
      self_.rampPointsNeeded = 2;
      self_.rotHuePointsNeeded = 0;
      self_.reverseRampP_ = true;
      self_.parent.message(self_.rampLabels[2], false);
    }
  }
  
  class rotHueLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
      // Real action is in setIndexAndColor.
    {
      self_.copyColorPointsNeeded = 0;
      self_.rampPointsNeeded = 0;
      self_.rotHuePointsNeeded = 2;
      whichRotHuePtAction_ = ROT_HUE;
      IntDialog dialog = new IntDialog("Degrees shift:", self_, String.valueOf(rotHueDegrees_) );
      try {
        rotHueDegrees_ = dialog.getValue();
        self_.parent.message(self_.rampLabels[2], false);
      } catch (NumberFormatException except) {
        parent.message("Illegal # of degrees: " + except,true);
        parent.message(except.getMessage() == null ? 
                       except.toString() : except.getMessage(), true);
        self_.parent.message("Aborted", true);
      }
    }
  }
  
  class SatLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
      // Real action is in setIndexAndColor.
    {
      self_.copyColorPointsNeeded = 0;
      self_.rampPointsNeeded = 0;
      self_.rotHuePointsNeeded = 2;
      whichRotHuePtAction_ = MULT_SAT;
      IntDialog dialog = new IntDialog("Saturation Multiplier:", self_, String.valueOf(satBriMult_) );
      try {
        satBriMult_ = dialog.getDoubleValue();
        self_.parent.message(self_.rampLabels[2], false);
      } catch (NumberFormatException except) {
        parent.message("Illegal # of degrees: " + except,true);
        parent.message(except.getMessage() == null ? 
                       except.toString() : except.getMessage(), true);
        self_.parent.message("Aborted", true);
      }
    }
  }
  
  class BriLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
      // Real action is in setIndexAndColor.
    {
      self_.copyColorPointsNeeded = 0;
      self_.rampPointsNeeded = 0;
      self_.rotHuePointsNeeded = 2;
      whichRotHuePtAction_ = MULT_BRI;
      IntDialog dialog = new IntDialog("Brightness Multiplier::", self_, String.valueOf(satBriMult_) );
      try {
        satBriMult_ = dialog.getDoubleValue();
        self_.parent.message(self_.rampLabels[2], false);
      } catch (NumberFormatException except) {
        parent.message("Illegal # of degrees: " + except,true);
        parent.message(except.getMessage() == null ? 
                       except.toString() : except.getMessage(), true);
        self_.parent.message("Aborted", true);
      }
    }
  }
  
  /* *************** Sorting **************** */
  
  class CmpBase
  {
    protected int idNumber_ = -1;
    
    public CmpBase (int id)
    {
      idNumber_ = id;
    }
    
    public int idNumber ()
    {
      return idNumber_;
    }
  }
  
  class RedCmp extends CmpBase implements Cmp
  {
    public RedCmp (int id)
    {
      super(id);
    }
    
    public int cmp (Object a, Object b)
    {
      int ra = ((Color)a).getRed();
      int rb = ((Color)b).getRed();
      return ra - rb;
    }
  }
  
  class GreenCmp extends CmpBase implements Cmp
  {
    public GreenCmp (int id)
    {
      super(id);
    }
    
    public int cmp (Object a, Object b)
    {
      int ra = ((Color)a).getGreen();
      int rb = ((Color)b).getGreen();
      return ra - rb;
    }
  }
  
  class BlueCmp extends CmpBase implements Cmp
  {
    public BlueCmp (int id)
    {
      super(id);
    }
    
    public int cmp (Object a, Object b)
    {
      int ba = ((Color)a).getBlue();
      int bb = ((Color)b).getBlue();
      return ba - bb;
    }
  }
  
  class HueCmp extends CmpBase implements Cmp
  {
    public HueCmp (int id)
    {
      super(id);
    }
    
    public int cmp (Object a, Object b)
    {
      int ra = ((Color)a).getRed();
      int rb = ((Color)b).getRed();
      int ga = ((Color)a).getGreen();
      int gb = ((Color)b).getGreen();
      int ba = ((Color)a).getBlue();
      int bb = ((Color)b).getBlue();
      float [] hsba = Color.RGBtoHSB(ra, ga, ba, (new float[3]));
      float [] hsbb = Color.RGBtoHSB(rb, gb, bb, (new float[3]));
      return (int)(3600 * (hsba[0] - hsbb[0]));
    }
  }
  
  class SatCmp extends CmpBase implements Cmp
  {
    public SatCmp (int id)
    {
      super(id);
    }
    
    public int cmp (Object a, Object b)
    {
      int ra = ((Color)a).getRed();
      int rb = ((Color)b).getRed();
      int ga = ((Color)a).getGreen();
      int gb = ((Color)b).getGreen();
      int ba = ((Color)a).getBlue();
      int bb = ((Color)b).getBlue();
      float [] hsba = Color.RGBtoHSB(ra, ga, ba, (new float[3]));
      float [] hsbb = Color.RGBtoHSB(rb, gb, bb, (new float[3]));
      return (int)(1000 * (hsba[1] - hsbb[1]));
    }
  }
  
  class BriCmp extends CmpBase implements Cmp
  {
    public BriCmp (int id)
    {
      super(id);
    }
    
    public int cmp (Object a, Object b)
    {
      int ra = ((Color)a).getRed();
      int rb = ((Color)b).getRed();
      int ga = ((Color)a).getGreen();
      int gb = ((Color)b).getGreen();
      int ba = ((Color)a).getBlue();
      int bb = ((Color)b).getBlue();
      float [] hsba = Color.RGBtoHSB(ra, ga, ba, (new float[3]));
      float [] hsbb = Color.RGBtoHSB(rb, gb, bb, (new float[3]));
      return (int)(1000 * (hsba[2] - hsbb[2]));
    }
  }
  
  class Cmp3 implements Cmp
  {
    Cmp key1_;
    Cmp key2_;
    Cmp key3_;
    
    public Cmp3 (Cmp key1, Cmp key2, Cmp key3)
    {
      key1_ = key1; key2_ = key2; key3_ = key3;
    }
    
    public int idNumber ()
    {
      return -1;
    }
        
    public int cmp (Object a, Object b)
    {
       int delta = key1_.cmp(a, b);
       if (delta != 0) return delta;
       delta = key2_.cmp(a, b);
       if (delta != 0) return delta;
       return key3_.cmp(a, b);
    }
  }
  
  class keyNumLNR implements ItemListener 
  {
    int key_; // This doubles as the position in the vector of sort menu check boxes.
    
    public keyNumLNR (int key)
    {
      key_ = key;
    }
    
    public void itemStateChanged(ItemEvent event)
    {
      if (event.getStateChange() == ItemEvent.SELECTED) {
        setSortMenuCheckboxes(key_); // this is all 0 based.
        sortKeyMenu_.setLabel("Set Key " + (key_ + 1));
        parent.message("ColorMapEditor$keyNumLNR string=" + (key_ + 1), true);
//        sortKeyMenu_.setName("Set Key " + (key_ + 1));
        sortKeyToSet_ = key_;
      }
    }
  }
  
  class keyLNR implements ItemListener 
  {
    Cmp key_;
    int positionInVector_; // Position in the vector of sort menu check boxes.
    
    public keyLNR (String key, int position)
    {
      positionInVector_ = position;
      if (key.equals("Hue")) key_ = new HueCmp(position);
      else if (key.equals("Saturation")) key_ = new SatCmp(position);
      else if (key.equals("Brightness")) key_ = new BriCmp(position);
      else if (key.equals("Red")) key_ = new RedCmp(position);
      else if (key.equals("Green")) key_ = new GreenCmp(position);
      else if (key.equals("Blue")) key_ = new BlueCmp(position);
      else System.err.println("Error in keyLNR constructor");
    }
    
    public void itemStateChanged(ItemEvent event)
    {
      if (event.getStateChange() == ItemEvent.SELECTED) {
        threeSortKeys_[sortKeyToSet_] = key_;
        setSortMenuCheckboxes(positionInVector_);
      }
    }
  }
  
  class sortLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      Cmp rcomp = new Cmp3(threeSortKeys_[0], threeSortKeys_[1], threeSortKeys_[2]);
      int [] pixelMap = mapBox.sortColors(0, 255, rcomp);
      self_.parent.remapPixelIndices(pixelMap);
    }
  }
  
  class ssortLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      self_.copyColorPointsNeeded = 0;
      self_.sortPointsNeeded = 2;
      self_.rampPointsNeeded = 0;
      self_.rotHuePointsNeeded = 0;
      self_.reverseRampP_ = true;
      self_.parent.message(self_.rampLabels[2], false);
    }
  }

  /* *************** End Sorting **************** */
  
  class parmsLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
      // Show the parameters window for the active fractal window.
    {
      parent.showParmFrame();
    }
  }

  
 
  class memLNR implements ActionListener
  {
    int id_;
    boolean saveP_;
    
    memLNR (int id, boolean saveP)
    {
      id_ = id;
      saveP_ = saveP;
    }
    
    public void actionPerformed (ActionEvent e)
    {
      if (saveP_) {
        // Put the current color map in memory.
        parent.sendColorMapToMemory(id_);
        parent.message("Color map saved to memory space " + id_ , false);
      } else {
        // Get saved color map and apply it to the current image.
        Color color;
        for (int i = 0; i < 256; i++) {
          color = savedColors_[id_][i];
          color = new Color(color.getRed(), color.getGreen(), color.getBlue());
          mapBox.setColorAt(i, color);
          parent.setIndexAndColor(i, color, i == 255); //3rd arg controls canvas repaint.
        }
        parent.message("Saved color map " + id_ + " retrieved.", false);  
      }
    }
  }

  class msgLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
      //Display the message window.
    {
      parent.message("", true);
    }
  }

}
 
  
  
  
  
  
  
  
  
  
  
   
      
      
      
      
      
      
      
      
      
