package JavaQuat20.FractalLoops;

import JavaQuat20.*;
import java.math.*;

public class Cpx2AxisTrapOnly extends JQLooper
{
  public int loop (FastQuaternion point, FastQuaternion coeff, FastQuaternion trans, int depth)
   // Returns value in range [1, depth] inclusive.
   // Exits when near the vertical line R = coeff.j or the horizontal line i = coeff.k.  Near
   //  is determined by trans.k
   // Also exits in the normal Mandelbrot way.
  {
    double bound = trans.k;
    FastQuaternion add = coeff.times(point).plus(trans);
    double z_r = point.r;
    double z_i = point.i;
    double add_r = add.r;
    double add_i = add.i;
    double real;
    double zrsq = z_r * z_r;
    double zisq = z_i * z_i;
    double magnitude;
    double temp;
    for (int i = 1; i < depth; i++) {
      real = zrsq - zisq + add_r;
      z_i = 2 * z_r * z_i + add_i;
      z_r = real;
      zrsq = z_r * z_r;
      zisq = z_i * z_i;
//      if (zrsq + zisq > 4)
//        return i;
      temp = (z_r - coeff.j) * (z_r - coeff.j);
      if (i > trans.j) {
        if (temp < bound) {
          return (int)((temp * depth)/bound);
        }
        temp = (z_i - coeff.k) * (z_i - coeff.k);
        if (temp < bound) {
          return (int)((temp * depth)/bound);
        }
      }
    }
    return depth;
  }
}     

