package JavaQuat20.FractalLoops;

import JavaQuat20.*;

public class Cross2 extends JQLooper
  // A 4D space.  (-0,75, 0, -0.75, 0), (1, 1, 1, 1), (0, 0, 0, 0) should behave like the mandelbrot set
  // except that the scan would have to be on axes ((1, 0, 1, 0) and (0, 1, 0, 1) I think.
{
  public int loop (FastQuaternion point, FastQuaternion coeff, FastQuaternion trans, int depth)
   // Returns value in range [1, depth] inclusive.
  {
    double add_r = point.r * coeff.r + trans.r;
    double add_i = point.i * coeff.i + trans.i;
    double add_j = point.j * coeff.j + trans.j;
    double add_k = point.k * coeff.k + trans.k;
    double rr, rj;
    FastQuaternion Q0 = new FastQuaternion(point);
    for (int i = 1; i < depth; i++) {
      rr = Q0.r * Q0.r - Q0.i * Q0.i + add_r;
      rj = (Q0.r + Q0.j);
      Q0.i = Q0.i * rj + add_j;
      Q0.j = Q0.j * Q0.j - Q0.k * Q0.k + add_j;
      Q0.k = Q0.k * rj + add_k;
      Q0.r = rr;
      if (Q0.magnitude_sq() > 10)
        return i;
    }
    return depth;
  }
  
}

