package JavaQuat20.FractalLoops;

import JavaQuat20.*;
import java.math.*;
// This is an base class to unite the various fractal algorithms.

public abstract class JQLooper
{
  public abstract int loop (FastQuaternion point, FastQuaternion coeff, FastQuaternion trans, int depth);
  
  public int bigLoop (BigQuaternion point, BigQuaternion coeff, BigQuaternion trans, int depth)
  {
    return loop(point.fastQuaternionValue(),
                coeff.fastQuaternionValue(),
                trans.fastQuaternionValue(),
                depth);
  }
  
  public boolean bigLoop_p () {return false;}
  
  public boolean acceptsTrapGif () {return false;}
  
  public int trapLoop (FastQuaternion point, FastQuaternion coeff, FastQuaternion trans, int depth, TrapFrame tf)
  { return 0;}
  
  /* These are strings to label the parameters window */
  /* 10 chars fit. Obsolete*/
  public String rString () {return "real";}
  public String iString () {return "i";}
  public String jString () {return "j";}
  public String kString () {return "k";}

  /* 15 chars fit */
  public String q1String () {return "Q(0)";}
  public String q2String () {return "Q2";}
  public String q3String () {return "Q3";}
  
  public String formulaString () {return "Q(n+1) = Q(n)^2 + Q2*Q(0) + Q3";}
  public FastQuaternion q1Init () {return new FastQuaternion(0,0,0,0);}
  public FastQuaternion q2Init () {return new FastQuaternion(0,0,0,0);}
  public FastQuaternion q3Init () {return new FastQuaternion(0,0,0,0);}
  public String docString () {return "There is no documentation on this loop.";}
  public boolean outputsColorIndexP () {return false;}
  
}
