package JavaQuat20.FractalLoops;

import JavaQuat20.*;

public class Loop22T extends JQLooper
  //Differs from Loop22 by the last 2 line, "add_r = ..."
{
  public int loop (FastQuaternion point, FastQuaternion coeff, FastQuaternion trans, int depth)
   // Returns value in range [1, depth] inclusive.
  {
    FastQuaternion add = coeff.times(point).plus(trans);
    double z_r = point.r;
    double z_i = point.i;
    double add_r = add.r;
    double add_i = add.i;
    double real;
    double zrsq = z_r * z_r;
    double zisq = z_i * z_i;
    double magnitude;
    for (int i = 1; i < depth; i++) {
      real = zrsq - zisq + add_r;
      z_i = 2 * z_r * z_i + add_i;
      z_r = real;
      zrsq = z_r * z_r;
      zisq = z_i * z_i;
      if (zrsq + zisq > 4)
        return i;
      add_r = coeff.r * (add_r + z_r) + coeff.i * (add_i + z_i);
      add_i = coeff.i * (add_r + z_r) + coeff.r * (add_i + z_i);
    }
    return depth;
  }
}

