package JavaQuat20.FractalLoops;

import JavaQuat20.*;

public class Loop22_23 extends JQLooper
{
  public int loop (FastQuaternion Q1, FastQuaternion Q2, FastQuaternion Q3, int depth)
   // Returns value in range [1, depth] inclusive.
   // This is Loop32 in the r-i plane and Loop22 in the j-k plane.  Hoping for something
   //  interesting in some mix of those planes.
  {
    FastQuaternion add = Q2.times(Q1).plus(Q3);
    double z_r = Q1.r;
    double z_i = Q1.i;
    double add_r = add.r;
    double add_i = add.i;
    double real;
    double zrsq = z_r * z_r;
    double zisq = z_i * z_i;
    
    double z_j = Q1.j;
    double z_k = Q1.k;
    double add_j = add.j;
    double add_k = add.k;
    double jay;
    double zjsq = z_j * z_j;
    double zksq = z_k * z_k;

    double magnitude;
    for (int i = 1; i < depth; i++) {
      real = zrsq * z_r - 3 * z_r * zisq + add_r;
      z_i = 3 * zrsq * z_i - z_i * zisq + add_i;
      z_r = real;
      zrsq = z_r * z_r;
      zisq = z_i * z_i;
      
      jay = zjsq - zksq + add_j;
      z_k = 2 * z_j * z_k + add_k;
      z_j = jay;
      zjsq = z_j * z_j;
      zksq = z_k * z_k;

      if (zrsq + zisq + zjsq + zksq > 4)
        return i;
    }
    return depth;
  }
}

