package JavaQuat20.FractalLoops;

import JavaQuat20.*;

public class Loop32 extends JQLooper
// This is a 3D space where real is ident., ij = ji = -1, ii = j, jj = i.
{
  public int loop (FastQuaternion point, FastQuaternion coeff, FastQuaternion trans, int depth)
   // Returns value in range [1, depth] inclusive.
  {
    FastQuaternion add = coeff.times(point).plus(trans);
    double z_r = point.r;
    double z_i = point.i;
    double z_j = point.j;
    double real;
    double imag;
    double zrsq = z_r * z_r;
    double zisq = z_i * z_i;
    double zjsq = z_j * z_j;
    for (int i = 1; i < depth; i++) {
      real = zrsq - 2 * z_i * z_j + add.r;
      imag = zjsq + 2 * z_r * z_i + add.i;
      z_j =  zisq + 2 * z_r * z_j + add.j;
      z_r = real;
      z_i = imag;
      zrsq = z_r * z_r;
      zisq = z_i * z_i;
      zjsq = z_j * z_j;
      if (zrsq + zisq + zjsq > 4)
        return i;
    }
    return depth;
  }
}

