package JavaQuat20.FractalLoops;

import JavaQuat20.*;

public class Loop324 extends JQLooper
{
  public int loop (FastQuaternion point, FastQuaternion coeff, FastQuaternion trans, int depth)
   // Returns value in range [1, depth] inclusive.
  {
    FastQuaternion add = new FastQuaternion(point);
    add.assign_from(unique_times_equal(add, coeff).plus(trans));
    FastQuaternion Q0 = new FastQuaternion(point);
    for (int i = 1; i < depth; i++) {
      if (Q0.magnitude_sq() > 10)
        return i;
      unique_times_equal(Q0, Q0).plus_equal(add);
    }
    return depth;
  }
  
  private FastQuaternion unique_times_equal (FastQuaternion self, FastQuaternion point)
  {
    double rr, ii, jj;
    rr =  self.r * point.r + self.i * point.j - self.j * point.i;
    ii =  self.r * point.i + self.i * point.r - self.j * point.j;
    jj =  self.r * point.j + self.i * point.i + self.j * point.r;
    self.r = rr;
    self.i = ii;
    self.j = jj;
    return self;
  }
  
  /*  Times table
  _____________________
  324*||  r |  i |  j |
  =====================
  | r ||  r |  i |  j |
  _____________________
  | i ||  i |  j |  r |
  _____________________
  | j ||  j | -r | -i |
  _____________________

 */
  
}

