package JavaQuat20.FractalLoops;

import JavaQuat20.*;

public class Loop42C extends JQLooper
{
  public int loop (FastQuaternion point, FastQuaternion coeff, FastQuaternion trans, int depth)
   // Returns value in range [1, depth] inclusive.
  {
    FastQuaternion add = new FastQuaternion(point);
    add.assign_from(unique_times_equal(add, coeff).plus(trans));
    FastQuaternion Q0 = new FastQuaternion(point);
    for (int i = 1; i < depth; i++) {
      if (Q0.magnitude_sq() > 10)
        return i;
      unique_sq_self(Q0).plus_equal(add);
    }
    return depth;
  }
  
  private FastQuaternion unique_times_equal (FastQuaternion self, FastQuaternion point)
  {
    double rr, ii, jj, kk;
    rr = self.r * point.r - self.i * point.j + self.j * point.i - self.k * point.k;
    ii = self.r * point.i + self.i * point.r ;
    jj = self.r * point.k - self.i * point.i + self.j * point.j - self.k * point.r;
    kk =                                       self.j * point.k + self.k * point.j;
    self.r = rr;
    self.i = ii;
    self.j = jj;
    self.k = kk;
    return self;
  }
  
   private FastQuaternion unique_sq_self (FastQuaternion self)
  {
    double rr, ii, jj, kk;
    rr = self.r * self.r - self.k * self.k;
    ii = 2 * self.r * self.i;
    jj = self.j * self.j - self.i * self.i;
    kk = 2 * self.j * self.k;
    self.r = rr;
    self.i = ii;
    self.j = jj;
    self.k = kk;
    return self;
  }
   
 
  
  /*
  __________________________
  42C*||  r |  i |  j |  k |
  ==========================
  | r ||  r |  i |  0 |  j |
  __________________________
  | i ||  i | -j | -r |  0 |
  __________________________
  | j ||  0 |  r |  j |  k |
  __________________________
  | k ||  j |  0 |  k | -r | 
  __________________________
  */
  
}

