package JavaQuat20.FractalLoops;

import JavaQuat20.*;
import java.math.*;

public class LoopTetraQ extends Tetra
{
  int count = 0;
    
  public int loop (FastQuaternion point, FastQuaternion coeff, FastQuaternion trans, int depth)
   // Returns value in range [1, depth] inclusive.
  {
    FastQuaternion add1 = new FastQuaternion(point);
    add1.assign_from(unique_times_equal(add1, coeff));
    FastQuaternion add2 = coeff.times(point);
    // add.times_equal(coeff).plus_equal(trans);
    FastQuaternion Q0 = new FastQuaternion(point);
    for (int i = 1; i < depth; i++) {
      if (Q0.magnitude_sq() > 10)
        return i;
      unique_sq_self(Q0).plus_equal(add1);
      Q0.minus_equal(trans);
      Q0.times_equal(Q0).plus_equal(add2);
      Q0.plus_equal(trans);
    }
    return depth;
  }
     
  /*  Times table
  __________________________
  428*||  r |  i |  j |  k |
  ==========================
  | r ||  r |  i |  j |  k |
  __________________________
  | i ||  i | -j |  k |  r |
  __________________________
  | j ||  j | -k | -r |  i |
  __________________________
  | k ||  k | -r | -i | -j | 
  __________________________
  */
  
}

