package JavaQuat20.FractalLoops;

import JavaQuat20.*;

public class Seq3DSq extends JQLooper
{
  public int loop (FastQuaternion point, FastQuaternion coeff, FastQuaternion trans, int depth)
   // Returns value in range [1, depth] inclusive.
  {
    FastQuaternion add = coeff.times(point).plus(trans);
    double z_r = point.r;
    double z_i = point.i;
    double z_j = point.j;
    double add_r = add.r;
    double add_i = add.i;
    double add_j = add.j;
    double real;
    double zrsq = z_r * z_r;
    double zisq = z_i * z_i;
    double zjsq = z_j * z_j;
    double magnitude;
    for (int i = 1; i < depth; i++) {
      // move in ri plane
      real = zrsq - zisq;
      z_i = 2 * z_r * z_i + add_i;
      z_r = real;
      zrsq = z_r * z_r;
      // move in rj plane
      real = zrsq - zjsq + add_r;
      z_j = 2 * z_r * z_j + add_j;
      z_r = real;
      //compute squares - magnitude
      zrsq = z_r * z_r;
      zisq = z_i * z_i;
      zjsq = z_j * z_j;
      if (zrsq + zisq + zjsq > 10)
        return i;
    }
    return depth;
  }
}

