package JavaQuat20.FractalLoops;

import JavaQuat20.*;

public class Swirl extends JQLooper
{
  public int loop (FastQuaternion point, FastQuaternion coeff, FastQuaternion trans, int depth)
   // Returns value in range [1, depth] inclusive.
  {
    FastQuaternion add = coeff.times(point).plus(trans);
    double z_r = point.r;
    double z_i = point.i;
    double add_r = add.r;
    double add_i = add.i;
    double real;
    double zrsq = z_r * z_r;
    double zisq = z_i * z_i;
    double delta_r;
    double delta_i;
    double twist_r;
    double twist_i;
    double swirl_r = point.j;
    double swirl_i = point.k;
    double magnitude;
    for (int i = 1; i < depth; i++) {
      real = zrsq - zisq + add_r;
      z_i = 2 * z_r * z_i + add_i;
      z_r = real;
      // Introduce swirl.
      delta_r = z_r - swirl_r;
      delta_i = z_i - swirl_i;
      magnitude = delta_r * delta_r + delta_i * delta_i;
      if (magnitude < coeff.j && coeff.j > 0) {
//        System.out.println("z_r = " + z_r + " z_i = " + z_i);
//        System.out.println("delta_r = " + delta_r + " delta_i = " + delta_i);
//        System.out.println("magnitude = " + magnitude);
        magnitude = 2 * Math.PI * (coeff.j - magnitude) / coeff.j;
        twist_r = Math.cos(magnitude);
        twist_i = Math.sin(magnitude);
//        System.out.println("magnitude = " + magnitude +
//                           " twist_r = " + twist_r + " twist_i = " + twist_i);
        z_r = delta_r * twist_r - delta_i * twist_i + swirl_r;
        z_i = delta_r * twist_i + delta_i * twist_r + swirl_i;
//        System.out.println("z_r = " + z_r + " z_i = " + z_i);
      }
      zrsq = z_r * z_r;
      zisq = z_i * z_i;
      if (zrsq + zisq > 100)
        return i;
    }
    return depth;
  }
}

