package JavaQuat20.FractalLoops;

import JavaQuat20.*;
import java.math.*;

public class Tetra2AxisTrap extends Tetra
{
  //static final double bound = 0.2;
  public int loop (FastQuaternion point, FastQuaternion coeff, FastQuaternion trans, int depth)
   // Returns value in range [1, depth] inclusive.
  {
    double bound = trans.k;
    trans.k = 0;
    FastQuaternion add = new FastQuaternion(point);
    add.assign_from(unique_times_equal(add, coeff).plus(trans));
    FastQuaternion Q0 = new FastQuaternion(point);
    boolean traceit = point.r == point.i;
    for (int i = 1; i < depth; i++) {
      if (traceit) System.out.print("Tetra2AxisTrap i = " + i + " Q0 = " + Q0 + " ");
      boolean othersSmall = Math.abs(Q0.j) + Math.abs(Q0.k) < bound;
      if (othersSmall && Math.abs(Q0.r + 0.1) < bound) {
        if (traceit) System.out.println("Tetra2AxisTrap success R i = " + i + " Q0 = " + Q0);
        return (int)Math.abs((Q0.r + 0.1) * depth / bound);
      }
      if (othersSmall && Math.abs(Q0.i + 0.1) < bound) {
        if (traceit) System.out.println("Tetra2AxisTrap success I i = " + i + " Q0 = " + Q0);
        return (int)Math.abs((Q0.i + 0.1) * depth / bound);
      }
      if (Q0.magnitude_sq() > 10) {
        if (traceit) System.out.println("Tetra2AxisTrap MAG exit1 i = " + i + " Q0 = " + Q0);
        return i;
      }
      unique_sq_self(Q0).plus_equal(add);
    }
    if (traceit) System.out.println("Tetra2AxisTrap exit Bottom.");
    return depth;
  }
     
  /*  Times table
  __________________________
  428*||  r |  i |  j |  k |
  ==========================
  | r ||  r |  i |  j |  k |
  __________________________
  | i ||  i | -j |  k |  r |
  __________________________
  | j ||  j | -k | -r |  i |
  __________________________
  | k ||  k | -r | -i | -j | 
  __________________________
  */
  
}

