package JavaQuat20;

import java.awt.*;
import java.awt.event.*;


class IntDialog extends Dialog
  // This is to get user comments when a picture is saved to disk or URL.
{
  TextField textArea_;
  
  public IntDialog (String title, Frame jQFrame, String initialString)
  {
    super(jQFrame, title, true);
    setLayout(new BorderLayout(4, 10));
    textArea_ = new WatchedText(initialString, 45, this);
    Panel buttonBox = new Panel();
    buttonBox.setLayout(new GridLayout(1, 3, 4, 0));
      buttonBox.add(new Label());
      buttonBox.add(new Label());
      Button oK = new Button("DONE");
      oK.addActionListener(new OKLNR());
      buttonBox.add(oK);
    add("South", buttonBox);
    add("Center", textArea_);
    setSize(200, 60);
    show();
  }
  
  public int getValue () throws NumberFormatException
  {
    if (textArea_.getText().length() == 0) {
      System.out.println("IntDialog giving 0 length 0.");
      return 0;
    }
    return Integer.valueOf(textArea_.getText()).intValue();
  }
  
  public double getDoubleValue () throws NumberFormatException
  {
    if (textArea_.getText().length() == 0) {
      System.out.println("IntDialog giving 0 length 0.");
      return 0;
    }
    return Double.valueOf(textArea_.getText()).doubleValue();
  }
  
  /* -------------- Listeners ------------------ */
  
  class OKLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      setVisible(false);
    } 
  }
  
  class WatchedText extends TextField implements ActionListener
    // With the new AWT this class is superfluous.  So REMOVE THIS.
  {
    IntDialog watcher_;
    
    WatchedText (String initialValue, int cols, IntDialog watcher)
    {
      super(initialValue, cols);
      watcher_ = watcher;
      addActionListener(this);
    }
 
    public void actionPerformed(ActionEvent event) 
    {
//      System.out.println("IntDialog.actionPerformed commandString = " + 
//                         event.getActionCommand() );
      watcher_.setVisible(false);
    }
  } 
}
