package JavaQuat20;

import java.awt.*;
import java.io.*;
import java.util.*;
import JavaQuat20.FractalLoops.*;

public class JQCentral extends Frame implements Messenger, ColorMapOwnerParent
{
  public final static String version = "JavaQuat20";
  
  private final static int NOTHING = 0; // These for awaiting_
  private final static int COLOR_EDITOR_INPUT = 2;
  private final static int MOUSE_H_AXIS_NEEDS_2_PTS = 3;
  private final static int MOUSE_H_AXIS_NEEDS_1_PT = 4;
  private final static int MOUSE_V_AXIS_NEEDS_2_PTS = 5;
  private final static int MOUSE_V_AXIS_NEEDS_1_PT = 6;
  
  public final static int IMAGE_FRAME = 0; // These for lastActiveWindow_ & lastImageWindow_
  public final static int PARM_FRAME = 1;
  public final static int COLOR_FRAME = 2;
  public final static int TRAP_FRAME = 3;
  
  private int awaiting_ = NOTHING;
  
  private FastQuaternion firstPoint = new FastQuaternion();
  private Vector frameList_ = new Vector(10);
  private Vector fractalHistory_ = new Vector(100);
  private int frameNumber_ = 1;
  static private MsgFrame msgFrame_;
  private Vector loopers_ = new Vector(50, 12);
  private JQFrame activeFrame_ = null;
  private JQCanvas activeCanvas_ = null;
  private ParmFrame parmFrame_ = null;
  private TrapFrame trapFrame_ = null;
//  private FractalSpec centralSpec_;
  private int lastWidth_ = 400;
  private int lastHeight_ = 400;
  private int lastActiveWindow_ = IMAGE_FRAME;
  private int lastImageWindow_ = IMAGE_FRAME; // This is either the trap frame or drawing frame.
  private ColorMapEditor colorMapEditor_ = null;
  private boolean updatingColorMapEditorP_ = false; // This to prevent needless recursion plus
                                                    // other prob. c refresher update on file read
                                                    // when the colorMapEditor is visible.
  private boolean parmFrameNeverInitializedP_ = true;
  private boolean logging_ = false;
  private boolean write2URLP_ = false;
  private boolean userWantsToAddCOmmentP_ = false;
  private String logPathname_ = null;
  private int logEntryNumber_ = 0;
  private boolean setColorMapWhenReadingTrapImageP_ = true;
  
  private int enlargePixels_; // For Adjust menu
  private int rightPixels_;   // For Adjust menu
  private int downPixels_;    // For Adjust menu
  private int onWPixels_;    // For Adjust menu

  //private boolean disableFurtherMouseReactionP_ = false;
  private boolean retainPreviousColorMapOnActivationP_ = false;
  private boolean runAsApplet_ = false;
  
  private Date last_time_;
  private int last_color_map_index_ = -1; // -1 never happens, so first given does not look like
                                          // a repeat.
  private String trapPathname_;
  
  private boolean debugP_ = false;
  
  public JQCentral (String [] args)
  {  
    msgFrame_ = new MsgFrame("Messages", 400, 150); // This should be first for msgs from rest
    parmFrame_ = new ParmFrame(this);
    parmFrame_.setVisible(false);

//    centralSpec_ = new FractalSpec();
    activeFrame_ = new JQFrame(this, 400, 400);
    activeCanvas_ = activeFrame_.canvas();
    frameList_.addElement(activeFrame_);
    
    loopers_.addElement(new Loop22());
    last_time_ = new Date();
    
    // Set an initial value into the    
  }
  
  // ---------------- Accessors and Mutators ---------------
  
  Vector fractalHistory () 
  {
    return fractalHistory_;
  }
  
  public boolean setDebugP (boolean value)
  {
    boolean was = debugP_;
    debugP_ = value;
    return was;
  }
  
  public boolean debugP ()
  {
    return debugP_;
  }
  
  public void setAwaitingPoint (boolean arg)
  {
    //message("JQCentral.setAwaitingPoint arg=" + arg, false);
    if (arg) {
      awaiting_ = COLOR_EDITOR_INPUT;
      //disableFurtherMouseReactionP_ = false;
    } else {
      awaiting_ = NOTHING;
    }
  }
  
  public int getAwaiting ()
  {
    return awaiting_;
  }
  
  public void setAwaiting (int arg)
  {
    //message("JQCentral.setAwaiting arg=" + arg, false);
    awaiting_ = arg;
  }
  
  public void setWrite2URLP (boolean val)
  {
    write2URLP_ = val;
  }
  
  public boolean write2URLP ()
  {
    return write2URLP_;
  }
  
  public void setUserWantsToAddCOmmentP (boolean val)
  {
    userWantsToAddCOmmentP_ = val;
  }
  
  public boolean userWantsToAddCOmmentP ()
  {
    return userWantsToAddCOmmentP_;
  }
  
  public int enlargePixels ()
  {
    return enlargePixels_;
  }
  
  public void setEnlargePixels (int val)
  {
    enlargePixels_ = val;
  }
   
  public int rightPixels ()
  {
    return rightPixels_;
  }
  
  public void setRightPixels (int val)
  {
    rightPixels_ = val;
  }
   
  public int downPixels ()
  {
    return downPixels_;
  }
  
  public void setDownPixels (int val)
  {
    downPixels_ = val;
  }
   
  public int onWPixels ()
  {
    return onWPixels_;
  }
  
  public void setOnWPixels (int val)
  {
    onWPixels_ = val;
  }

  
  // ----------------- Functionality -----------------------
  
  public boolean activeCanvasP (JQCanvas candidate)
    // Used by a JQCanvas to see whether to respond to a click when the colorMapEditor is up.
  {
    return candidate == activeCanvas_;
  }
  
    /* --------- Parm Frame related methods ----------- */

  public void readParms(boolean is_url_p, int argsNum)
    // Loads an argument set and returns it, setting parmsFrame_.  argsNum is the
    // number of the argument set, -1 means just take the first.
  {
    activeFrame_.readParms(is_url_p, argsNum);
  }
  
  public boolean writeParms (boolean is_url_p, String pathname)
  {
    return activeFrame_.writeParms(is_url_p, pathname);
  }

  public void setLoooper4ParmFrame (String which1)
  {
    if (parmFrame_ != null)
      parmFrame_.setLooper(which1);
  }
  
//  public void setCheckBoxValues4ParmFrame (FractalSpec spec)
//  {
//    parmFrame_.setCheckBoxValues(spec, false);
//  }
  
  public boolean toggleLogging (boolean newState)
  {
    logging_ = newState;
    if (logging_) {
      JQIO outUtility = new JQIO(this, activeFrame_);
      logPathname_ = outUtility.pathFromDialog(false); // false => use write dialog
      if (logPathname_ == null) {
        logging_ = false;
        parmFrame_.setLogging(false);
        message("Logging toggled back off.", false);
        return false;
      }
    }
    return true;
  }
  
  public boolean loggingP ()
  {
    return logging_;
  }
  
  public void writeToLog (FractalSpec spec)
  {
    String userComment = null;
    if (userWantsToAddCOmmentP()) {
      userComment = activeFrame_.getUserComment();
    }

    JQIO outUtility = new JQIO(this, activeFrame_);
    OutputStream stream1 = null;
    try {
      stream1 = outUtility.toAppendStream(logPathname_);
      if (stream1 == null)
        throw new IOException("NOT FOUND: " + logPathname_);
      OutputStreamWriter strStream = new OutputStreamWriter(stream1);
      String answer = spec.toString(logEntryNumber_++, userComment);
      if (logEntryNumber_ > 1) {
        strStream.write("\n\n", 0, 2); // Skip a line.
      }
      strStream.write(answer, 0, answer.length());
      strStream.flush();
      strStream.close();
      message("Parameters logged.", false);
    } catch (Throwable e) {
      message("Error on stream or encode: " + e,true);
      message(e.getMessage() == null ? e.toString() : e.getMessage(), true);
    } finally {
      try {
        if (stream1 != null)
          stream1.flush();
          stream1.close();
      } catch (Throwable e) {}
    }
  }
  
  /* ---------- Active frame Axes Menu Item communication to parmframe --------- */
  
  public void swapHV ()
  {
     parmFrame_.swapHV();  
  }
  
  public void rotate90R ()
  {
    parmFrame_.rotate90R();
  }

  public void rotate90L ()
  {
    parmFrame_.rotate90L();
  }

  public void w2H ()
  {
    parmFrame_.w2H();
  }
  
  public void w2V ()
  {
    parmFrame_.w2V();
  }

  public void h2MemH ()
  {
    parmFrame_.h2MemH();
  }

  public void v2MemV ()
  {
    parmFrame_.v2MemV();
  }
  
  public void memH2H ()
  {
    parmFrame_.memH2H();
  }

  public void memV2V ()
  {
    parmFrame_.memV2V();
  }
  
    /* --------- Active Frame related methods ----------- */
  
  public void drawActiveCanvas ()
  // Called from the ParmFrame Draw menu.
  {
    activeFrame_.draw();
  }
  
  public void openImage ()
  {
    activeFrame_.openImage();
  }
  
  public void saveImage ()
  {
    activeFrame_.saveImage();
  }

  public void pauseActiveCanvas ()
  // Called from the ParmFrame Draw menu.
  {
    activeCanvas_.stop();
  }
  
  public void setCheckBoxValues4Frame (FractalSpec spec)
  {
    activeFrame_.setCheckBoxValues(spec, false);
  }
  
  public void sendColorMapToMemory (int memorySlot)
  {
    if (lastImageWindow_ == TRAP_FRAME) {
      for (int i = 0; i < 256; i++) {
        colorMapEditor_.receiveMemoryColor(memorySlot, i, trapFrame_.getColorAt(i));
      }
    } else {
      for (int i = 0; i < 256; i++) {
        colorMapEditor_.receiveMemoryColor(memorySlot, i, activeCanvas_.getColorAt(i));
      }
    }
  }
  
  public void remapPixelIndices (int [] pixelMap)
    //This is called from the colorMapEditor when colors have been sorted.
  {
    if (lastImageWindow_ == TRAP_FRAME) {
      trapFrame_.remapPixelIndices(pixelMap);
    } else {
      activeCanvas_.remapPixelIndices(pixelMap);
    }
  }
  
  /*  -------- Adjust Menu communication from ParmFrame to Drawing frame. ----- */
  
  public void adjustEnlarge (int percent)
  {
    activeFrame_.adjustEnlarge(percent);
  }
  
  public void adjustCenterRight (int pixels)
  {
    activeFrame_.adjustCenterRight(pixels);
  }
  
  public void adjustCenterUp (int pixels)
  {
    activeFrame_.adjustCenterUp(pixels);
  }
  
  public void adjustCenterOnW (int pixels)
  {
    activeFrame_.adjustCenterOnW(pixels);
  }  

  
    /* --------- Misc. methods ----------- */
    
  public void setTrapPathname (String pathname)
    // this is called from the trarFrame when trap image is written out under a this new pathname.
  {
    trapPathname_ = pathname;
  }
    
  public void openTrapImage ()
    // This sets the image that will be passed to Loopers that take a gif image 
    // in the form of a TrapGif for the sake of fancy orbit trap loop algorithms.
  {
    if (trapFrame_ == null) {
      trapFrame_ = new TrapFrame(this);
    }
    trapFrame_.openGIFImage(null, write2URLP_, setColorMapWhenReadingTrapImageP_);
    if (activeCanvas_ != null) {
      activeCanvas_.set_other_change_requires_redraw_p(true);
    }
  }
  
  public void setColorMapFromTrap (boolean value)
  {
    setColorMapWhenReadingTrapImageP_ = value;
  }

  public TrapFrame getTrapFrame ()
  {
    if (trapFrame_ != null && trapFrame_.readyP()) {
      return trapFrame_;
    }
    return null;
  }
  
  void timeToQuit ()
  {
    System.exit(0);
  }
  
  int activeFrames () // Currently unused.
  {
    return frameList_.size();
  }
  
  int frameCount ()
  {
    return frameNumber_;
  }
  
  synchronized int incFrameCount ()
  {
    return frameNumber_++;
  }
  
  void removeFrame (Frame toRemove)
  {
    if (frameList_.size() > 1  || runAsApplet_) {
      frameList_.removeElement(toRemove);
      if (activeFrame_ == toRemove) {
        FractalSpec spec = new FractalSpec();
        activeFrame_.getCheckBoxValues(spec);
        activeFrame_ = (JQFrame)frameList_.firstElement();
        activeFrame_.setCheckBoxValues(spec, false);
      }
      toRemove.dispose();
      try {
        activateMe(activeFrame_);
      } catch (Throwable exc) {}
    }
  }
  
  void makeNewFrame (JQFrame requester)
  {
    JQFrame newFrame;
    if (requester != null) {
      Dimension size = requester.getSize();
      lastWidth_ = size.width;
      lastHeight_ = size.height;
      frameList_.addElement((newFrame = (new JQFrame(this, lastWidth_, lastHeight_))));
      //message("activeFrame_= " + activeFrame_ + "new= " + newFrame + " requester= " + requester);
      newFrame.canvas().set256ColorMapFromCanvas(requester.canvas());
    } else {
      JQFrame oldFrame = activeFrame_;
      frameList_.addElement((newFrame = (new JQFrame(this, lastWidth_, lastHeight_))));
      if (oldFrame != null) {
        newFrame.canvas().set256ColorMapFromCanvas(oldFrame.canvas());
      }
    }
  }
  
  public void message (String newMessage, boolean show_p)
  {
    msgFrame_.addMessageLn(newMessage);
    if (show_p && !msgFrame_.isVisible())
      msgFrame_.setVisible(true);
  }
  
  boolean messagesVisible_p ()
  {
    return msgFrame_.isVisible();
  }
    
  public void setMessagesVisible (boolean arg)
  {
    if (!arg && msgFrame_.isVisible())
      msgFrame_.setVisible(arg);
    else if (arg && !msgFrame_.isVisible())
      msgFrame_.setVisible(arg);
  }
  
  public String translateLoopName (String strIN)
    // Returns real name of looper, as a class.
  {
    if (strIN.equals("CpxPower2"))
      return ("Loop22");
    if (strIN.equals("CpxPower3"))
      return ("Loop23");
    if (strIN.equals("CpxPower4"))
      return ("Loop24");
    if (strIN.equals("CpxPower5"))
      return ("Loop25");
    if (strIN.equals("TetPower2"))
      return ("LoopTetra2");
    if (strIN.equals("HcxPower2")) // Yes, the same.
      return ("HcxPower2");  
    return strIN;
  }

  public JQLooper findLoopObject (String looperName)
  {
    looperName = translateLoopName(looperName);
  
    // TRY TO FIND IT
    for (int i = 0; i < loopers_.size(); i++) {
      if (looperName.equals(((JQLooper)loopers_.elementAt(i)).getClass().toString())) {
        return (JQLooper)loopers_.elementAt(i);
      }
    }
    
//    message("JQCentral.findLoopObject name = " + 
//                       ((JQLooper)loopers_.elementAt(0)).getClass().toString(), false);
    
    // COULDN'T FIND IT, TRY TO CREATE IT.
    JQLooper creation = null;
    try {
      Class looperClass = Class.forName(version + ".FractalLoops." + looperName);
      
      // Check that it extends JQLooper
      Class JQLooperClass = Class.forName(version + ".FractalLoops.JQLooper");
      Class superClass = looperClass;
      boolean found_p = false;
      while (superClass != null) {
        if (superClass == JQLooperClass) {
          found_p = true;
          break;
        }
        superClass = superClass.getSuperclass();
      }

      if (found_p) {      
        creation = (JQLooper)looperClass.newInstance();
        loopers_.addElement(creation);
        return creation;
      } else {
        message("Class " + looperName + 
                " does not implement the JQLooper interface.", true);
      }
    } catch (InstantiationException h) {
      message("JQCentral.findLoopObject says: Error instantiating class " + 
                         looperName, true);
    } catch (IllegalAccessException f) {
      message("JQCentral.findLoopObject says: Illegal access to class " +
                         looperName, true);
    } catch (ClassNotFoundException g) {
      message("JQCentral.findLoopObject says: Class " + looperName + 
                         " not found.", true);
    } catch (Throwable e) {
      message("JQCentral.findLoopObject says: " + 
                         (e.getMessage() == null ? e.toString() : e.getMessage()), true);
    }
    return null;
  }
  
  private boolean checkParameters ()
  {
    message("JQCentral.checkParameters stub called", false);
    return true;
  }
  
  public boolean parametersToCanvas (JQCanvas destination)
    // Convert the user provided parameters text to numbers and put
    // it into one of the Fractal drawing areas.  This method is called
    // when the user presses the 'DRAW' button in the Fractal_Panel.  
    // No draw is done if this returns false.
  {
    if (checkParameters()) {
      FractalSpec vals = new FractalSpec(destination.spec()); // Make a copy

      destination.setParameters(vals); // Checks for equality, else adjusts.
                                                        // passes them back.
      return true;
    }
    return false;
  }
  
  public void setParameters (FractalSpec arg) //- in ParmFrame
  // Called in mouse release for JQCanvas JQFrame.stepAdvance, and JQFrame.loadArgsThenGIF, at least.
  {
    if (arg == null) {
      // This happens when the parmFrame's Settings menu item "Show Settings" is chosen.
      arg = activeCanvas_.spec();
      message("Format " + activeCanvas_.spec().version, false);
    }
    parmFrame_.takeValuesFrom(arg);
    parmFrameNeverInitializedP_ = false;
  }
  
  //             getParameters - from parmFrame
  public boolean parmsToSpec (FractalSpec spec)
    // Use the method above by the same name if you want to prep a canvas
    // since it does the necessary setParameters.  Returns null if parm window has junk.
  {
    if (parmFrameNeverInitializedP_) {
      // Take whatever's in the spec.  this will be standard Mandelbrot if spec was new.
      // put it in the parmFrame and try to get it back below.
      setParameters(spec);
    }
    if (parmFrame_.copyToSpec(spec))
      return true;
    return false;
  }
  
  public FastQuaternion parmsDAxis ()
  {
    return parmFrame_.dAxis();
  }
  
  public FastQuaternion parmsWAxis ()
  {
    return parmFrame_.wAxis();
  }
  
  public void showParmFrame ()
  // This is for the ColorMapOwnerParent interface.
  {
    showParmFrameFor(activeFrame_);
  }
  
  public void showParmFrameFor (JQFrame frame1)
    // Bring up the Parameters window for the arg.
    // The arg is null if this is called from the colorMapEditor, and in that
    // case we use the current canvas, activeCanvas_, which shouldn't be null.
  {
    parmFrameNeverInitializedP_ = false;
    if (frame1 == null)
      frame1 = activeFrame_;
    JQCanvas canvas1 = frame1.canvas();
    if (canvas1 == null) {
      message("JQCentral.showParmFramdFor: activeCanvas_ == null.", true);
      return;
    }
    parmFrame_.takeValuesFrom(canvas1);
    parmFrame_.setVisible(true);
  }
    
  /* ******************* Click on response ****************** */
  
  // Next 4 methods associated with setting lastActiveWindow_
  
  public void setTrapFrameIsTargetP ()
    // This is called by the trapFrame itself.
  {
    lastActiveWindow_ = TRAP_FRAME;
    lastImageWindow_ = TRAP_FRAME;
  }
  
  public void activateParmFrame ()
    // This is called when someone clicks on the parmFrame
  {
    if (lastActiveWindow_ != PARM_FRAME) {
      // Copy the parmFrame check box values into the new frame's checkboxes.
      FractalSpec spec = new FractalSpec();
      activeFrame_.getCheckBoxValues(spec);
      parmFrame_.setCheckBoxValues(spec, false);
      lastActiveWindow_ = PARM_FRAME;
    }
  }
  
  public void activateColorFrame () //NOT YET CALLED, and maybe shouldn't be.
  {
     lastActiveWindow_ = COLOR_FRAME;
  }
  
  public void activateMe (JQFrame frameClickedOn)
  {
//    message("JQCentral.activateMe awaiting_ = " + awaiting_, true);
    boolean activateP = true;
    if (awaiting_ == COLOR_EDITOR_INPUT) {
      if (activeFrame_ != frameClickedOn || lastActiveWindow_ == TRAP_FRAME) {
        //disableFurtherMouseReactionP_ = true; // Logic related to this variable escapes me. Fix later.
        lastImageWindow_ = IMAGE_FRAME; // If ColorMapEd feeds back direct it to drawing frame.
        updatingColorMapEditorP_ = true;
        frameClickedOn.canvas().transferColorMapTo(colorMapEditor_); //Updates activeCanvas_
        updatingColorMapEditorP_ = false;
        //message("activateMe COLOR_EDITOR_INPUT branch taken, sub true.", false);
      } else {
        //message("activateMe COLOR_EDITOR_INPUT branch taken, sub false.", false);
        // Do nothing probably
        if (colorMapEditor_ != null && !colorMapEditor_.isVisible()) {
          awaiting_ = NOTHING;
        } else {
          activateP = false;
        }
      }
    } 
    if (activateP) {
      //message("activateMe activateP branch taken.", false);
      FractalSpec spec = new FractalSpec();
      if (lastActiveWindow_ == IMAGE_FRAME && activeFrame_ != null && 
          activeFrame_ != frameClickedOn) {
        activeFrame_.getCheckBoxValues(spec);
        frameClickedOn.setCheckBoxValues(spec, false);
      }
      // Unmark old frame, mark new frame
      if (activeFrame_ != null && activeFrame_.getTitle().charAt(0) == '*') {
        activeFrame_.setTitle(activeFrame_.getTitle().substring(2));
      }
      if (frameClickedOn.getTitle().charAt(0) != '*') {
        frameClickedOn.setTitle("* " + frameClickedOn.getTitle());
      }
      
      activeFrame_ = frameClickedOn;
      activeCanvas_ = activeFrame_.canvas();
      
      if (lastActiveWindow_ == PARM_FRAME) {
        // Copy the parmFrame check box values into the new frame's checkboxes.
        parmFrame_.getCheckBoxValues(spec);
        activeFrame_.setCheckBoxValues(spec, false);
      }
      lastActiveWindow_ = IMAGE_FRAME;
    }
  }
  
  public void setActiveCanvas (JQCanvas canvas)
    // this is called when the mouse is released on canvas.
    // The following two methods may also be called if the click is
    // in the fractal image.  the next two methods are receivePoint and 
    // setFocusOfColorMapEditor.
  {
    //message("JQCentral.setActiveCanvas DID NOT EXPECT TO BE CALLED.", false);
//    if (!disableFurtherMouseReactionP_) {
      activeCanvas_ = canvas;
      activeFrame_ = canvas.parent();
      if (colorMapEditor_ != null) {
        updatingColorMapEditorP_ = true;
        activeCanvas_.transferColorMapTo(colorMapEditor_);
        updatingColorMapEditorP_ = false;
//        message("JQCentral.setActiveCanvas if clause", false);
      }
//    }
  }
  
  public boolean receivePoint (JQCanvas canvas, FractalSpec arg)
    // this and setFocusOfColorMapEditor are called when we click on a fractal image point.
    // Returns true if awaiting NOTHING so the click centers the image, or picks color, false otherwise.
  {
    //message("JQCentral.receivePoint - awaiting_ = " + awaiting_, false);
    //message("JQCentral.receivePoint - disableFurtherMouseReactionP_ = " + 
    //        disableFurtherMouseReactionP_, false);
    lastImageWindow_ = IMAGE_FRAME;
    if (canvas != activeCanvas_) {
      //message("Canvas mismatch", true); // DEBUG
      return false; // False meaning point was not used.
    }
//    if (disableFurtherMouseReactionP_) {
//      //message("JQCentral.receivePoint disableFurtherMouseReactionP_", false);
//      //disableFurtherMouseReactionP_ = false; // Disables colorMapEd from changing things too early.
//      return false;
//    } else 
    if (awaiting_ == COLOR_EDITOR_INPUT) {
      //message("JQCentral.receivePoint COLOR_EDITOR_INPUT", false);
      return false;
    } else if (awaiting_ == MOUSE_H_AXIS_NEEDS_2_PTS) {
      firstPoint.assign_from(arg.centralCoordinates().fastQuaternionValue());
      awaiting_ = MOUSE_H_AXIS_NEEDS_1_PT;
    } else if (awaiting_ == MOUSE_H_AXIS_NEEDS_1_PT) {
      FastQuaternion secondPoint = arg.centralCoordinates().fastQuaternionValue();
      secondPoint.minus_equal(firstPoint).normalize_n();
      if (secondPoint.magnitude() != 0) {  
        double dot_prod = arg.vx.dot(secondPoint);
        if (dot_prod < 0) {
          arg.vy.normalizePerpendicularTo(secondPoint);
          parmFrame_.setHandVAxes(secondPoint, arg.vy.times_scalar_n(-1));
        } else if (dot_prod > 0) {
          arg.vy.normalizePerpendicularTo(secondPoint);
          parmFrame_.setHandVAxes(secondPoint, arg.vy);
        } else {
          dot_prod = arg.vy.dot(secondPoint);
          if (dot_prod < 0) {
            arg.vx.normalizePerpendicularTo(secondPoint);
            parmFrame_.setHandVAxes(secondPoint, arg.vx);
          } else {
            arg.vx.normalizePerpendicularTo(secondPoint);
            parmFrame_.setHandVAxes(secondPoint, arg.vx.times_scalar_n(-1));
          }
        }
      }
      if (colorMapEditor_ != null && colorMapEditor_.isVisible()) {
        awaiting_ = COLOR_EDITOR_INPUT;
      } else {
        awaiting_ = NOTHING;
      }
    } else if (awaiting_ == MOUSE_V_AXIS_NEEDS_2_PTS) {
      firstPoint.assign_from(arg.centralCoordinates().fastQuaternionValue());
      awaiting_ = MOUSE_V_AXIS_NEEDS_1_PT;
    } else if (awaiting_ == MOUSE_V_AXIS_NEEDS_1_PT) {
      FastQuaternion secondPoint = arg.centralCoordinates().fastQuaternionValue();
      secondPoint.minus_equal(firstPoint).normalize_n();
      if (secondPoint.magnitude() != 0) {        
        double dot_prod = arg.vy.dot(secondPoint);
        if (dot_prod < 0) {
          arg.vx.normalizePerpendicularTo(secondPoint);
          parmFrame_.setHandVAxes(arg.vx.times_scalar_n(-1), secondPoint);
        } else if (dot_prod > 0) {
          arg.vx.normalizePerpendicularTo(secondPoint);
          parmFrame_.setHandVAxes(arg.vx, secondPoint);
        } else {
          dot_prod = arg.vx.dot(secondPoint);
          if (dot_prod < 0) {
            arg.vy.normalizePerpendicularTo(secondPoint);
            parmFrame_.setHandVAxes(arg.vy, secondPoint);
          } else {
            arg.vy.normalizePerpendicularTo(secondPoint);
            parmFrame_.setHandVAxes(arg.vy.times_scalar_n(-1), secondPoint);
          }
        }
      }
      if (colorMapEditor_ != null && colorMapEditor_.isVisible()) {
        awaiting_ = COLOR_EDITOR_INPUT;
      } else {
        awaiting_ = NOTHING;
      }
    } else if (awaiting_ == NOTHING) { 
      parmFrame_.takeValuesFrom(arg);
      return true;
    }
    return false;
  }
  
  
  public void setParmFramePanelFields (int num_panels, int h_panel, int v_panel)
  {
    parmFrame_.setPanelFields(num_panels, h_panel, v_panel);
  }
  
  public void setParmFrameRange (double newRange)
  {
    parmFrame_.setRange(newRange);
  }
  
  public void scaleVAxis (double scale_factor)
  {
    parmFrame_.scaleVAxis(scale_factor);
  }
  
  public int parmFramePanels ()
  {
    return parmFrame_.numberOfPanels();
  }
  
  public int parmFramePixelsWide ()
  {
    return parmFrame_.pixelsWide();
  }
  
  public int parmFramePixelsHigh ()
  {
    return parmFrame_.pixelsHigh();
  }
  
  public void mouseNewVAxis ()
  {
    awaiting_ = MOUSE_V_AXIS_NEEDS_2_PTS;
  }
  
  
  public void mouseNewHAxis ()
  {
    awaiting_ = MOUSE_H_AXIS_NEEDS_2_PTS;
  }
  
   public void setHVRatio (Dimension ratio1)
  {
    parmFrame_.setHVRatio(ratio1);
  }
  
  public Dimension getHVRatio ()
    // This is called by new JQCanvases as they start up.
  {
    return parmFrame_.getHVRatio();
  }

 
  
  
  public void setFocusOfColorMapEditor (int color_map_index, Color c, boolean completely_p)
  {
    if ( //!disableFurtherMouseReactionP_ && 
        awaiting_ == COLOR_EDITOR_INPUT &&
        colorMapEditor_ != null) {
//      message("JQCentral.setFocusOfColorMapEditor if passed", false);
      updatingColorMapEditorP_ = true;
      colorMapEditor_.setIndexAndColor(color_map_index, c, true);
      updatingColorMapEditorP_ = false;
      colorMapEditor_.show();
    }
  }
  
  public void setIndexAndColor (int color_map_index, Color c, boolean repaint_p)
    // When we have adjusted the color on the color map this updates the
    // picture.  We do this no more often that once a second because of problems
    // with the imageProducer running out of memory.  If the index
    // changes we do it anyway.  Problem was with running color scroll bars in
    // color map editor.
  {
    if (debugP()) {
      System.out.print("JQCentral.setIndexAndColor repaint_p=" + repaint_p);
    }
    if ((lastImageWindow_ == TRAP_FRAME) ||
        (activeCanvas_ != null && !updatingColorMapEditorP_) ) {
      if (color_map_index != last_color_map_index_) {
        if (lastImageWindow_ == TRAP_FRAME) {
          trapFrame_.setColorAtIndex(color_map_index, c, repaint_p);
        } else {
          activeCanvas_.setColorAtIndex(color_map_index, c, repaint_p);
        }
        last_color_map_index_ = color_map_index;
        return;
      }
      Date now = new Date();
      long millisecs_since_last_call = now.getTime() - last_time_.getTime();
//      message("JQCentral.setIndexAndColor millisecs_since_last_call=" + millisecs_since_last_call,
//              false);
      if (millisecs_since_last_call > 1000) {
        if (lastImageWindow_ == TRAP_FRAME) {
          trapFrame_.setColorAtIndex(color_map_index, c, repaint_p);
        } else {
          activeCanvas_.setColorAtIndex(color_map_index, c, repaint_p);
        }
        last_time_ = now;
      }
    }
  }
  
  /* ********************** ColorMapOwnerParent implementation ******************* */

  public void updateColorMapEd (boolean showEditor, TransferCMap source)
    // This is called to update the colorMapEditor
  {
//    message("JQCentral.updateColorMap called", false);
    if (!showEditor && (colorMapEditor_ == null || !colorMapEditor_.isVisible())) {
      return;
    }
    if (colorMapEditor_ == null) {
      colorMapEditor_ = new ColorMapEditor(this, 256);
    }
    if (source == null) {
      if (lastImageWindow_ == TRAP_FRAME) {
        source = trapFrame_;
      } else if (activeCanvas_ != null) {
        source = activeCanvas_;
      }
      if (source == null) {
        message("No source for color map.", true);
        return;
      }
    }
    
    updatingColorMapEditorP_ = true;
    source.transferColorMapTo(colorMapEditor_);
    updatingColorMapEditorP_ = false;
    
    if (!colorMapEditor_.isVisible()) {
      colorMapEditor_.show();
    }
  }
  
  // ********** Other than color map stuff.
  
  public void showTrapFrame ()
  {
    if (trapFrame_ != null) {
      trapFrame_.show();
    }
  }
  
  public String trapPathname ()
  {
    if (trapFrame_ != null) {
      return trapFrame_.pathname();
    }
    return null;
  }
    
  
  /* ********************* Loading images from an applet *********************** */
  
    public void loadInitialImage (String urlString, String trapString)
    // This is called from the top level applet or frame to load a first picture.
    {
      runAsApplet_ = true;
      if (trapString != null) {
        if (trapFrame_ == null) {
          trapFrame_ = new TrapFrame(this);
        }
        trapFrame_.openGIFImage(trapString, true, false);
        trapFrame_.setVisible(false);
      }
      activeFrame_.loadArgsThenGIF(true, urlString);
    }
}
