package JavaQuat20;

import java.awt.*;
import java.awt.event.*;

class MsgFrame extends Frame
{

  private TextArea textArea_;
  private MsgFrame self_;
  final static int maxLength = 1000;
  final static int minLength = 500;

  public MsgFrame (String title, int width, int height)
  {
    super(title);
    setSize(width, height);
    self_ = this;
    addWindowListener(new MyWindowLNR());
 
    // -------------- Menu -----------------------------------
    MenuBar menuBar = new MenuBar();
    setMenuBar(menuBar);
    
    Menu fileMenu = new Menu("File", true); // true for tearoff.
    menuBar.add(fileMenu);
    
    MenuItem clearMI = new MenuItem("Clear");
    clearMI.addActionListener(new clearLNR());
    clearMI.setShortcut(new MenuShortcut(KeyEvent.VK_Z));
    fileMenu.add(clearMI);
    
    MenuItem closeMI = new MenuItem("Close");
    closeMI.addActionListener(new closeLNR());
    closeMI.setShortcut(new MenuShortcut(KeyEvent.VK_W));
    fileMenu.add(closeMI);
    
    // ------------- Frame Layout ----------------------------
    
    textArea_ = new TextArea();
    textArea_.setEditable(false);
    setLayout(new BorderLayout(0, 0));
    add("Center", textArea_);

  }

  void addMessage (String message)
  {
    String contents = textArea_.getText();
    int length1 = contents.length();
    if (length1 > maxLength) {
      contents = contents.substring(message.length() + length1 - minLength, length1);
      textArea_.setText(contents);
    }
    textArea_.append(message);
//    int length2 = textArea_.getText().length();
//    try {
//      textArea_.setCaretPosition(length2 );
//    } catch (Throwable e) {
//      System.err.println("MsgFrame.addMdssage: Error on setCaretPosition(" +
//                          length2 + ")");
//    }
  }
  
  void addMessageLn (String message)
  {
    String contents = textArea_.getText();
    int length1 = contents.length();
    if (length1 > maxLength) {
      contents = contents.substring(message.length() + length1 - minLength, length1);
      textArea_.setText(contents);
    }
    textArea_.append(message + "\n");
//    int length2 = textArea_.getText().length();
//    try {
//      textArea_.setCaretPosition(length2);
//    } catch (Throwable e) {
//      System.err.println("MsgFrame.addMdssageLn: Error on setCaretPosition(" +
//                          length2 + ")");
//    }
  }
  
  // ---------------- Listeners --------------------
  
  class clearLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      textArea_.setText("");
    }
  }
  
  class closeLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      setVisible(false);
    }
  }
  
  class MyWindowLNR implements WindowListener
  {
    public void windowOpened (WindowEvent e)
    {
      
    }

    public void windowClosing (WindowEvent e)
    {   
      self_.setVisible(false);
    }

    public void windowClosed (WindowEvent e)
    {
      
    }

    public void windowIconified (WindowEvent e)
    {
      
    }

    public void windowDeiconified (WindowEvent e)
    {
      
    }

    public void windowActivated (WindowEvent e)
    {
      
    }

    public void windowDeactivated (WindowEvent e)
    {
      
    }
  }
}
