package JavaQuat20;

import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.util.*;
import JavaQuat20.FractalLoops.JQLooper;

public class ParmFrame extends Frame
{

  final FastQuaternion unitR = new FastQuaternion(1, 0, 0, 0);
  final FastQuaternion unitI = new FastQuaternion(0, 1, 0, 0);
  final FastQuaternion unitJ = new FastQuaternion(0, 0, 1, 0);
  final FastQuaternion unitK = new FastQuaternion(0, 0, 0, 1);
  
  final String strH = "H";
  final String strV = "V";
  final String strD = "D";
  final String strMemH = "MemH";
  final String strMemV = "MemV";
  final String strP1 = "P1";
  final String strP2 = "P2";

  JQCentral jQCentral_;
  private ParmFrame self_;
  
  FastQuaternion firstPerp_;
  FastQuaternion secondPerp_;
  FastQuaternion memH_;
  FastQuaternion memV_;
  double dAxisDegrees_ = 0;
  double wAxisDegrees_ = 0;
  
  private CheckboxMenuItem colorMapFromTrapP_;
  private CheckboxMenuItem fastMI_;
  private CheckboxMenuItem c256MI_;
  private CheckboxMenuItem Q1MI_;
  private CheckboxMenuItem Q2MI_;
  private CheckboxMenuItem Q3MI_;
  private CheckboxMenuItem ppp1MI_;
  private CheckboxMenuItem ppp2MI_;
  private CheckboxMenuItem ppp4MI_;
  private CheckboxMenuItem ppp9MI_;
  private Dimension hVRatio_;
  private CheckboxMenuItem loggingMI_;
  private CheckboxMenuItem userCommentMI_;
  private CheckboxMenuItem write2URLMI_;
  
  private int scanOn_ = FractalSpec.CENTER;
  private int ppp_ = 1;
  
  private boolean dAndWUpdating_p_ = false;
  private boolean disableDMutualUpdating_p_ = false;
  private boolean disableWMutualUpdating_p_ = false;
  
  // CardLayout cardLayout_; // To switch between Pivot Manager and expansion marker.
  
  // These can be set by the JQLooper
  Label labelQ1_;
  Label labelQ2_;
  Label labelQ3_;
//  Label labelR_;
//  Label labelI_;
//  Label labelJ_;
//  Label labelK_;
  Label formula_;
  
  
  
  LabeledTextField viewLTF;
  LabeledTextField widthLTF;
  LabeledTextField heightLTF;
  LabeledTextField depthLTF;
  LabeledTextField ColorCyclesLTF;
  LabeledTextField panelsLTF;
  LabeledTextField hPanelLTF;
  LabeledTextField vPanelLTF;
  LabeledTextField Q1R;
  LabeledTextField Q1i;
  LabeledTextField Q1j;
  LabeledTextField Q1k;
  LabeledTextField Q2R;
  LabeledTextField Q2i;
  LabeledTextField Q2j;
  LabeledTextField Q2k;
  LabeledTextField Q3R;
  LabeledTextField Q3i;
  LabeledTextField Q3j;
  LabeledTextField Q3k;
  LabeledTextField HR;
  LabeledTextField Hi;
  LabeledTextField Hj;
  LabeledTextField Hk;
  LabeledTextField VR;
  LabeledTextField Vi;
  LabeledTextField Vj;
  LabeledTextField Vk;
  LabeledTextField DR;
  LabeledTextField Di;
  LabeledTextField Dj;
  LabeledTextField Dk;
  LabeledTextField WR;
  LabeledTextField Wi;
  LabeledTextField Wj;
  LabeledTextField Wk;
  
  TextField looperText_; 
  LabeledTextField MHR;
  LabeledTextField MHi;
  LabeledTextField MHj;
  LabeledTextField MHk;
  LabeledTextField MVR;
  LabeledTextField MVi;
  LabeledTextField MVj;
  LabeledTextField MVk;
  
  Scrollbar dScrollbar_;
  TextField dText_;
  Scrollbar wScrollbar_;
  TextField wText_;
  Choice wLeft_;
  Choice wRight_;
  
  HVTextLNR hVAxisListener_ = null;


  public ParmFrame (JQCentral jQCentralArg)
  {
    super("Parameters");
    Vector smallAlpha = new Vector(45);
    jQCentral_ = jQCentralArg;
    self_ = this;
    addWindowListener(new MyWindowLNR());
    
    /* --------------- Menu Bar ---------------- */
    MenuBar menuBar = new MenuBar();
    setMenuBar(menuBar);
    
    /* --------------- File Menu ---------------- */
    Menu fileMenu = new Menu("File", true); // true for tearoff.
    
    MenuItem newFrameMI = new MenuItem("New Window");
    newFrameMI.addActionListener(new newFrameLNR());
    fileMenu.add(newFrameMI);
    
    fileMenu.addSeparator();
    
    MenuItem openFileMI = new MenuItem("Open JQ Image...");
    openFileMI.addActionListener(new openFileLNR());
    fileMenu.add(openFileMI);
    
    MenuItem openParmMI = new MenuItem("Open JQ Parms...");//8888888
    openParmMI.addActionListener(new openParmLNR());
    fileMenu.add(openParmMI);
    
    MenuItem openLogMI = new MenuItem("Open Log Entry...");//88888888
    openLogMI.addActionListener(new openLogLNR());
    fileMenu.add(openLogMI);
    
    MenuItem trapFileMI = new MenuItem("Open Trap GIF...");
    trapFileMI.addActionListener(new trapFileLNR());
    fileMenu.add(trapFileMI);
    
    fileMenu.addSeparator();
    
    MenuItem saveAsFileMI = new MenuItem("Save Image...");
    saveAsFileMI.addActionListener(new saveAsFileLNR());
    fileMenu.add(saveAsFileMI);
    
    MenuItem saveParamsFileMI = new MenuItem("Save Params...");//88888
    saveParamsFileMI.addActionListener(new saveArgsFLNR());
    fileMenu.add(saveParamsFileMI);
    
    fileMenu.addSeparator();

    loggingMI_ = new CheckboxMenuItem("Logging");
    loggingMI_.addItemListener(new loggingLNR());
    loggingMI_.setState(false);
    fileMenu.add(loggingMI_);
    
    write2URLMI_ = new CheckboxMenuItem("IO to URL?"); //88888888
    write2URLMI_.addItemListener(new write2URLLNR());
    write2URLMI_.setState(false);
    fileMenu.add(write2URLMI_);
    
    colorMapFromTrapP_ = new CheckboxMenuItem("Set Colors From Trap");
    colorMapFromTrapP_.addItemListener(new ClrFmTrap());
    colorMapFromTrapP_.setState(true);
    fileMenu.add(colorMapFromTrapP_);
      
    userCommentMI_ = new CheckboxMenuItem("Comment on Save?");//888888
    userCommentMI_.addItemListener(new usrComLNR());
    userCommentMI_.setState(false);
    fileMenu.add(userCommentMI_);
    
    fileMenu.addSeparator();
    
    MenuItem closeMI = new MenuItem("Close");
    closeMI.addActionListener(new closeLNR());
    fileMenu.add(closeMI);
    
    MenuItem quitMI = new MenuItem("Quit"); //8888888888
    quitMI.addActionListener(new quitLNR());
    fileMenu.add(quitMI);
    
    /* --------------- Draw Menu ---------------- */
    Menu drawMenu = new Menu("Draw", true); // true for tearoff.
    
    MenuItem startDrawMI = new MenuItem("Start");
    startDrawMI.addActionListener(new startDrawLNR());
    drawMenu.add(startDrawMI);
    
    MenuItem stopDrawMI = new MenuItem("Pause");
    stopDrawMI.addActionListener(new stopDrawLNR());
    drawMenu.add(stopDrawMI);
    
     /* --------------- Settings Menu ---------------- */
    Menu settingsMenu = new Menu("Settings", true); // true for tearoff.
    
    fastMI_ = new CheckboxMenuItem("Draw Fast?");
    fastMI_.setState(true);
    settingsMenu.add(fastMI_);
    
    c256MI_ = new CheckboxMenuItem("256 Colors?");
    c256MI_.setState(true);
    settingsMenu.add(c256MI_);
    
    settingsMenu.addSeparator();
    
    Menu scanOnMenu = new Menu("Scan On", true); // true for tearoff.
    settingsMenu.add(scanOnMenu);
    
      Q1MI_ = new CheckboxMenuItem("Q1");
      Q1MI_.addItemListener(new soQ1LNR());
      Q1MI_.setState(true);
      scanOnMenu.add(Q1MI_);
      
      Q2MI_ = new CheckboxMenuItem("Q2");
      Q2MI_.addItemListener(new soQ2LNR());
      Q2MI_.setState(false);
      scanOnMenu.add(Q2MI_);
      
      Q3MI_ = new CheckboxMenuItem("Q3");
      Q3MI_.addItemListener(new soQ3LNR());
      Q3MI_.setState(false);
      scanOnMenu.add(Q3MI_);
    
    Menu ptsPerPixelMenu = new Menu("Pts/Pixel", true); // true for tearoff.
    settingsMenu.add(ptsPerPixelMenu);
    
      ppp1MI_ = new CheckboxMenuItem("1");
      ppp1MI_.addItemListener(new ppp1LNR());
      ppp1MI_.setState(true);
      ptsPerPixelMenu.add(ppp1MI_);
      
      ppp2MI_ = new CheckboxMenuItem("2");
      ppp2MI_.addItemListener(new ppp2LNR());
      ppp2MI_.setState(false);
      ptsPerPixelMenu.add(ppp2MI_);
      
      ppp4MI_ = new CheckboxMenuItem("4");
      ppp4MI_.addItemListener(new ppp4LNR());
      ppp4MI_.setState(false);
      ptsPerPixelMenu.add(ppp4MI_);
    
      ppp9MI_ = new CheckboxMenuItem("9");
      ppp9MI_.addItemListener(new ppp9LNR());
      ppp9MI_.setState(false);
      ptsPerPixelMenu.add(ppp9MI_);
      
    
    MenuItem hVRatioMI = new MenuItem("W/H Ratio...");
    hVRatioMI.addActionListener(new HVRatioLNR());
    settingsMenu.add(hVRatioMI);
    
    settingsMenu.addSeparator();

    MenuItem displayParmsMI = new MenuItem("Show Arguments");
    displayParmsMI.addActionListener(new dsplyParmsLNR());
    settingsMenu.add(displayParmsMI);
    
    MenuItem defaultMI = new MenuItem("Default Arguments");
    defaultMI.addActionListener(new defaultLNR());
    settingsMenu.add(defaultMI);
    
    MenuItem docMI = new MenuItem("Loop documentation");
    docMI.addActionListener(new docLNR());
    settingsMenu.add(docMI);
    
    
      /* --------------- Adjust Menu ---------------- */
  // EnlargeLNR EnlrgAgnLNR RightLNR RightAgnLNR UpLNR UpAgnLNR  88888888
  
    Menu adjustMenu = new Menu("Adjust", true); // true for tearoff.
    
    MenuItem enlargeMI_ = new MenuItem("Zoom...");
    enlargeMI_.addActionListener(new EnlargeLNR());
    adjustMenu.add(enlargeMI_);

    MenuItem enlrgAgnMI_ = new MenuItem("Zoom again");
    enlrgAgnMI_.addActionListener(new EnlrgAgnLNR());
    adjustMenu.add(enlrgAgnMI_);

    adjustMenu.addSeparator();

    MenuItem rightMI_ = new MenuItem("Right shift...");
    rightMI_.addActionListener(new RightLNR());
    adjustMenu.add(rightMI_);

    MenuItem rightAgnMI_ = new MenuItem("Right shift again");
    rightAgnMI_.addActionListener(new RightAgnLNR());
    adjustMenu.add(rightAgnMI_);

    MenuItem downMI_ = new MenuItem("Down shift...");
    downMI_.addActionListener(new DownLNR());
    adjustMenu.add(downMI_);

    MenuItem downAgnMI_ = new MenuItem("Down shift again");
    downAgnMI_.addActionListener(new DownAgnLNR());
    adjustMenu.add(downAgnMI_);

    adjustMenu.addSeparator();

    MenuItem onWMI_ = new MenuItem("W axis shift...");
    onWMI_.addActionListener(new OnWLNR());
    adjustMenu.add(onWMI_);

    MenuItem onWAgnMI_ = new MenuItem("W axis shift again");
    onWAgnMI_.addActionListener(new OnWAgnLNR());
    adjustMenu.add(onWAgnMI_);
    
 // enlargeMI_ enlrgAgnMI_ rightMI_ rightAgnMI_ downMI_ downAgnMI_ onWMI_ onWAgnMI_

   /* --------------- Axis Menu ---------------- */
    Menu axisMenu = new Menu("Axis", true); // true for tearoff.
    
    MenuItem swapHVMI = new MenuItem("H <=> V");
    swapHVMI.addActionListener(new swapHVLNR());
    axisMenu.add(swapHVMI);
    
    MenuItem rot90LeftMI = new MenuItem("Rot. 90 left");
    rot90LeftMI.addActionListener(new Rotate90LLNR());
    axisMenu.add(rot90LeftMI);
    
    MenuItem rot90RightMI = new MenuItem("Rot. 90 right");
    rot90RightMI.addActionListener(new Rotate90RLNR());
    axisMenu.add(rot90RightMI);
    
    axisMenu.addSeparator();
    
    MenuItem w2HMI = new MenuItem("W => H");
    w2HMI.addActionListener(new W2HLNR());
    axisMenu.add(w2HMI);

    MenuItem w2VMI = new MenuItem("W => V");
    w2VMI.addActionListener(new W2VLNR());
    axisMenu.add(w2VMI);

    axisMenu.addSeparator();
    
    MenuItem h2MemHMI = new MenuItem("H => Mem H");
    h2MemHMI.addActionListener(new H2MemHLNR());
    axisMenu.add(h2MemHMI);
    
    MenuItem v2MemVMI = new MenuItem("V => Mem V");
    v2MemVMI.addActionListener(new V2MemVLNR());
    axisMenu.add(v2MemVMI);
    
    MenuItem memH2HMI = new MenuItem("Mem H => H");
    memH2HMI.addActionListener(new MemH2HLNR());
    axisMenu.add(memH2HMI);
    
    MenuItem memV2VMI = new MenuItem("Mem V => V");
    memV2VMI.addActionListener(new MemV2VLNR());
    axisMenu.add(memV2VMI);
    
    axisMenu.addSeparator();
    
    MenuItem scaleVMI = new MenuItem("Scale V-axis");
    scaleVMI.addActionListener(new ScaleVLNR());
    axisMenu.add(scaleVMI);
        
    MenuItem mouseV2MI = new MenuItem("Mouse V-axis");
    mouseV2MI.addActionListener(new mouseV2LNR());
    axisMenu.add(mouseV2MI);
    
    MenuItem mouseH2MI = new MenuItem("Mouse H-axis");
    mouseH2MI.addActionListener(new mouseH2LNR());
    axisMenu.add(mouseH2MI);
    
    /* --------------- Windows Menu ---------------- */
    Menu windowsMenu = new Menu("Windows", true); // true for tearoff.
    
    MenuItem colorMapMI = new MenuItem("Color Map Editor");
    colorMapMI.addActionListener(new ColorMapLNR());
    windowsMenu.add(colorMapMI);
    
    MenuItem msgMI = new MenuItem("Message Window");
    msgMI.addActionListener(new MsgLNR());
    windowsMenu.add(msgMI);
    
    MenuItem trapMI = new MenuItem("Trap GIF Window");
    trapMI.addActionListener(new TrapLNR());            
    windowsMenu.add(trapMI);
    
    
    
    /* SortCuts and adding menus */
    
    newFrameMI.setShortcut(new MenuShortcut(KeyEvent.VK_N));
    openFileMI.setShortcut(new MenuShortcut(KeyEvent.VK_O));
    saveAsFileMI.setShortcut(new MenuShortcut(KeyEvent.VK_S));
    trapFileMI.setShortcut(new MenuShortcut(KeyEvent.VK_T));
    closeMI.setShortcut(new MenuShortcut(KeyEvent.VK_W));
    startDrawMI.setShortcut(new MenuShortcut(KeyEvent.VK_D));
    stopDrawMI.setShortcut(new MenuShortcut(KeyEvent.VK_P));
    hVRatioMI.setShortcut(new MenuShortcut(KeyEvent.VK_R));
    colorMapMI.setShortcut(new MenuShortcut(KeyEvent.VK_E));
    msgMI.setShortcut(new MenuShortcut(KeyEvent.VK_M));

    menuBar.add(fileMenu);
    menuBar.add(drawMenu);
    menuBar.add(settingsMenu);
    menuBar.add(adjustMenu);
    menuBar.add(axisMenu);
    menuBar.add(windowsMenu);

    
    /* --------------- END Menu Bar ---------------- */
    
    //final int QsHeight = 130;
    //final int leftWidth = 150;
    //final int rightWidth = 350;
    
    setLayout(new GridLayout(4, 1, 5, 5));
    Panel topGroup = new Panel();
    add(topGroup);
    topGroup.setLayout(new GridLayout(2, 1, 0, 0));
    Panel row1 = new Panel();
    topGroup.add(row1);
    row1.setLayout(new GridLayout(1, 4, 0, 0));
    Panel row2 = new Panel();
    topGroup.add(row2);
    row2.setLayout(new GridLayout(1, 4, 0, 0));
    
    // topGroup
    depthLTF = 
      new LabeledTextField("Depth", LabeledTextField.IS_INT, LabeledTextField.VERTICAL);
    row1.add(depthLTF);
    viewLTF = 
      new LabeledTextField("Horiz. View", LabeledTextField.IS_DOUBLE, LabeledTextField.VERTICAL);
    row1.add(viewLTF);
    heightLTF = 
      new LabeledTextField("Height", LabeledTextField.IS_INT, LabeledTextField.VERTICAL);
    row1.add(heightLTF);
    widthLTF = 
      new LabeledTextField("Width", LabeledTextField.IS_INT, LabeledTextField.VERTICAL);
    row1.add(widthLTF);
    ColorCyclesLTF = 
      new LabeledTextField("Color Cycles", LabeledTextField.IS_DOUBLE, LabeledTextField.VERTICAL);
    row2.add(ColorCyclesLTF);
    panelsLTF = 
      new LabeledTextField("Panels", LabeledTextField.IS_INT, LabeledTextField.VERTICAL);
    row2.add(panelsLTF);
    vPanelLTF = 
      new LabeledTextField("Y Panel", LabeledTextField.IS_INT, LabeledTextField.VERTICAL);
    row2.add(vPanelLTF);
    hPanelLTF = 
      new LabeledTextField("X Panel", LabeledTextField.IS_INT, LabeledTextField.VERTICAL);
    row2.add(hPanelLTF);
    smallAlpha.addElement(viewLTF);
    smallAlpha.addElement(widthLTF);
    smallAlpha.addElement(heightLTF);
    smallAlpha.addElement(depthLTF);
    smallAlpha.addElement(ColorCyclesLTF);
    smallAlpha.addElement(panelsLTF);
    smallAlpha.addElement(hPanelLTF);
    smallAlpha.addElement(vPanelLTF);
    
   
    // midGroup
    Panel midGroup = new Panel();
    add(midGroup);
    midGroup.setLayout(new GridLayout(4, 1, 0, 0));
    formula_ = new Label("*", Label.CENTER);
    midGroup.add(formula_);
//    Panel row3 = new Panel();
//    midGroup.add(row3);
//    row3.setLayout(new GridLayout(1, 5, 0, 0));
    Panel row4 = new Panel();
    midGroup.add(row4);
    row4.setLayout(new GridLayout(1, 5, 0, 0));
    Panel row5 = new Panel();
    midGroup.add(row5);
    row5.setLayout(new GridLayout(1, 5, 0, 0));
    Panel row6 = new Panel();
    midGroup.add(row6);
    row6.setLayout(new GridLayout(1, 5, 0, 0));
       
    // 
//    row3.add(temp = new Label(" "));
//    smallAlpha.addElement(temp);
    row4.add(labelQ1_ = new Label("Q1", Label.CENTER));
//    smallAlpha.addElement(labelQ1_);
    row5.add(labelQ2_ = new Label("Q2", Label.CENTER));
//    smallAlpha.addElement(labelQ2_);
    row6.add(labelQ3_ = new Label("Q3", Label.CENTER));
//    smallAlpha.addElement(labelQ3_);
    //topLeft.setSize(leftWidth, QsHeight);
    
    // 
//    row3.add(labelR_ = new Label("R", Label.CENTER));
//    smallAlpha.addElement(temp);
//    row3.add(labelI_ = new Label("i", Label.CENTER));
//    smallAlpha.addElement(temp);
//    row3.add(labelJ_ = new Label("j", Label.CENTER));
//    smallAlpha.addElement(temp);
//    row3.add(labelK_ = new Label("k", Label.CENTER));
//    smallAlpha.addElement(temp);
    Q1R = new LabeledTextField("", LabeledTextField.IS_BIG, LabeledTextField.NO_LABEL);
    Q1i = new LabeledTextField("", LabeledTextField.IS_BIG, LabeledTextField.NO_LABEL);
    Q1j = new LabeledTextField("", LabeledTextField.IS_BIG, LabeledTextField.NO_LABEL);
    Q1k = new LabeledTextField("", LabeledTextField.IS_BIG, LabeledTextField.NO_LABEL);
    Q2R = new LabeledTextField("", LabeledTextField.IS_BIG, LabeledTextField.NO_LABEL);
    Q2i = new LabeledTextField("", LabeledTextField.IS_BIG, LabeledTextField.NO_LABEL);
    Q2j = new LabeledTextField("", LabeledTextField.IS_BIG, LabeledTextField.NO_LABEL);
    Q2k = new LabeledTextField("", LabeledTextField.IS_BIG, LabeledTextField.NO_LABEL);
    Q3R = new LabeledTextField("", LabeledTextField.IS_BIG, LabeledTextField.NO_LABEL);
    Q3i = new LabeledTextField("", LabeledTextField.IS_BIG, LabeledTextField.NO_LABEL);
    Q3j = new LabeledTextField("", LabeledTextField.IS_BIG, LabeledTextField.NO_LABEL);
    Q3k = new LabeledTextField("", LabeledTextField.IS_BIG, LabeledTextField.NO_LABEL);
    row4.add(Q1R);
    row4.add(Q1i);
    row4.add(Q1j);
    row4.add(Q1k);
    row5.add(Q2R);
    row5.add(Q2i);
    row5.add(Q2j);
    row5.add(Q2k);
    row6.add(Q3R);
    row6.add(Q3i);
    row6.add(Q3j);
    row6.add(Q3k);
    smallAlpha.addElement(Q1R);
    smallAlpha.addElement(Q1i);
    smallAlpha.addElement(Q1j);
    smallAlpha.addElement(Q1k);
    smallAlpha.addElement(Q2R);
    smallAlpha.addElement(Q2i);
    smallAlpha.addElement(Q2j);
    smallAlpha.addElement(Q2k);
    smallAlpha.addElement(Q3R);
    smallAlpha.addElement(Q3i);
    smallAlpha.addElement(Q3j);
    smallAlpha.addElement(Q3k);
    //topMatrix.setSize(rightWidth, QsHeight);
    

    // botGroup
    Panel botGroup = new Panel();
    add(botGroup);
    botGroup.setLayout(new GridLayout(4, 1, 0, 0));
    
    Label temp;
    Panel row65 = new Panel();
    botGroup.add(row65);
    row65.setLayout(new BorderLayout(0, 3));
    row65.add("West", (temp = new Label("Space Name", Label.CENTER)));
    smallAlpha.addElement(temp);
    looperText_ = new WatchedText("Loop22", 40, "looperText_");
    row65.add("Center", looperText_);
    smallAlpha.addElement(looperText_);
    
    
    Panel row7 = new Panel();
    botGroup.add(row7);
    row7.setLayout(new GridLayout(1, 5, 0, 0));
    Panel row8 = new Panel();
    botGroup.add(row8);
    row8.setLayout(new GridLayout(1, 5, 0, 0));
    Panel row9 = new Panel();
    botGroup.add(row9);
    row9.setLayout(new GridLayout(1, 5, 0, 0));
       
     // 
    row7.add(temp = new Label("H Axis", Label.CENTER));
    smallAlpha.addElement(temp);
    row8.add(temp = new Label("V Axis", Label.CENTER));
    smallAlpha.addElement(temp);
    row9.add(temp = new Label("D Axis", Label.CENTER));
    smallAlpha.addElement(temp);
    
    
    // matrixPanel.bodyMatrix.bottomMatrix
    HR = new LabeledTextField("", LabeledTextField.IS_DOUBLE, LabeledTextField.NO_LABEL);
    Hi = new LabeledTextField("", LabeledTextField.IS_DOUBLE, LabeledTextField.NO_LABEL);
    Hj = new LabeledTextField("", LabeledTextField.IS_DOUBLE, LabeledTextField.NO_LABEL);
    Hk = new LabeledTextField("", LabeledTextField.IS_DOUBLE, LabeledTextField.NO_LABEL);
    VR = new LabeledTextField("", LabeledTextField.IS_DOUBLE, LabeledTextField.NO_LABEL);
    Vi = new LabeledTextField("", LabeledTextField.IS_DOUBLE, LabeledTextField.NO_LABEL);
    Vj = new LabeledTextField("", LabeledTextField.IS_DOUBLE, LabeledTextField.NO_LABEL);
    Vk = new LabeledTextField("", LabeledTextField.IS_DOUBLE, LabeledTextField.NO_LABEL);
    DR = new LabeledTextField("", LabeledTextField.IS_DOUBLE, LabeledTextField.NO_LABEL);
    Di = new LabeledTextField("", LabeledTextField.IS_DOUBLE, LabeledTextField.NO_LABEL);
    Dj = new LabeledTextField("", LabeledTextField.IS_DOUBLE, LabeledTextField.NO_LABEL);
    Dk = new LabeledTextField("", LabeledTextField.IS_DOUBLE, LabeledTextField.NO_LABEL);
    row7.add(HR);
    row7.add(Hi);
    row7.add(Hj);
    row7.add(Hk);
    row8.add(VR);
    row8.add(Vi);
    row8.add(Vj);
    row8.add(Vk);
    row9.add(DR);
    row9.add(Di);
    row9.add(Dj);
    row9.add(Dk);
    smallAlpha.addElement(HR);
    smallAlpha.addElement(Hi);
    smallAlpha.addElement(Hj);
    smallAlpha.addElement(Hk);
    smallAlpha.addElement(VR);
    smallAlpha.addElement(Vi);
    smallAlpha.addElement(Vj);
    smallAlpha.addElement(Vk);
    smallAlpha.addElement(DR);
    smallAlpha.addElement(Di);
    smallAlpha.addElement(Dj);
    smallAlpha.addElement(Dk);
    HVTextLNR hVAxisListener_ = new HVTextLNR();
    listenToHAndVAxes(true);    
    
    // subBotGroup
    Panel subbotGroup = new Panel();
    add(subbotGroup);
    subbotGroup.setLayout(new GridLayout(4, 1, 0, 0));

    // row11
    Panel row11 = new Panel();
    subbotGroup.add(row11);
    row11.setLayout(new BorderLayout(0, 3));
    row11.add("West", (temp = new Label(" Set D Axis  ", Label.CENTER)));
    smallAlpha.addElement(temp);
    dScrollbar_ = new Scrollbar(Scrollbar.HORIZONTAL, 0, 10, 0, 100);
    dScrollbar_.addAdjustmentListener(new ScrollLNR());
    dText_ = new WatchedText("0", 3, "dText_");
    dText_.addTextListener(new DTextLNR());
    smallAlpha.addElement(dText_);
    row11.add("East", dText_);
    row11.add("Center", dScrollbar_);
    
    Panel row12 = new Panel();
    subbotGroup.add(row12);
    row12.setLayout(new GridLayout(1, 5, 0, 0));
    row12.add(temp = new Label("W", Label.CENTER));
    smallAlpha.addElement(temp);
    WR = new LabeledTextField("", LabeledTextField.IS_DOUBLE, LabeledTextField.NO_LABEL);
    Wi = new LabeledTextField("", LabeledTextField.IS_DOUBLE, LabeledTextField.NO_LABEL);
    Wj = new LabeledTextField("", LabeledTextField.IS_DOUBLE, LabeledTextField.NO_LABEL);
    Wk = new LabeledTextField("", LabeledTextField.IS_DOUBLE, LabeledTextField.NO_LABEL);
    row12.add(WR);
    row12.add(Wi);
    row12.add(Wj);
    row12.add(Wk);
    smallAlpha.addElement(WR);
    smallAlpha.addElement(Wi);
    smallAlpha.addElement(Wj);
    smallAlpha.addElement(Wk);    
    
    // row13
    Panel row14 = new Panel();
    subbotGroup.add(row14);
    row14.setLayout(new BorderLayout(0, 3));
    row14.add("West", (temp = new Label(" Set W Axis  ", Label.CENTER)));
    smallAlpha.addElement(temp);
    wScrollbar_ = new Scrollbar(Scrollbar.HORIZONTAL, 0, 10, 0, 100);
    wScrollbar_.addAdjustmentListener(new WScrollLNR());
    wText_ = new WatchedText("0", 3, "wText_");
    wText_.addTextListener(new WTextLNR());
    smallAlpha.addElement(wText_);
    row14.add("East", wText_);
    row14.add("Center", wScrollbar_);
    
    Panel row13 = new Panel();
    subbotGroup.add(row13);
    row13.setLayout(new GridLayout(1, 4, 0, 0));
    wLeft_ = new Choice();
    wRight_ = new Choice();
    smallAlpha.addElement(wLeft_);
    smallAlpha.addElement(wRight_);
    wLeft_.add(strH);
    wRight_.add(strH);
    wLeft_.add(strV);
    wRight_.add(strV);
    wLeft_.add(strD);
    wRight_.add(strD);
    wLeft_.add(strMemH);
    wRight_.add(strMemH);
    wLeft_.add(strMemV);
    wRight_.add(strMemV);
    wLeft_.add(strP1);
    wRight_.add(strP1);
    wLeft_.add(strP2);
    wRight_.add(strP2);
    wLeft_.select(2);
    wRight_.select(0);
    ChoiceLNR chListener = new ChoiceLNR();
    wLeft_.addItemListener(chListener);
    wRight_.addItemListener(chListener);
    row13.add(temp = new Label("W at 0", Label.CENTER));
    smallAlpha.addElement(temp);
    row13.add(wLeft_);
    row13.add(temp = new Label("W at 90", Label.CENTER));
    smallAlpha.addElement(temp);
    row13.add(wRight_);
    
    
    String [] preferredFonts = {"Courier", "courier", 
                                  "Dialog", "dialog", 
                                  "Times", "times"};
    FontSetter setter = new FontSetter(preferredFonts, Font.BOLD, 10);
    setter.setComponentFonts(smallAlpha);
    
    firstPerp_ = new FastQuaternion();
    secondPerp_ = new FastQuaternion();
    memH_  = new FastQuaternion();
    memV_  = new FastQuaternion();
    setFirstAndSecondPerpendiculars();
    hVRatio_ = new Dimension(-1, -1); // Which is off.;

    setSize(400, 355);
    setResizable(false);
    
//    jQCentral_.message("*** ParmFrame Created.***", false);
    //show();
  }
  
  /* ----------------------- Misc functionality ------------------------- */
  
  public void setDAndWUpdating (boolean value)
  {
    dAndWUpdating_p_ = value;
  }
  
  private void listenToHAndVAxes (boolean arg)
  {
    if (arg) {
      //try {
      //  // Let other threads issue their events and bypass us before we start listening. 
      //  Thread.sleep(1000); // One seconds;
      //} catch (Throwable exception1) {}
      
      //System.out.println("ParmFrame.listenToHAndVAxes turned ON");

      /* HR.enableEvents(AWTEvent.TEXT_EVENT_MASK);
      Hi.enableEvents(AWTEvent.TEXT_EVENT_MASK);
      Hj.enableEvents(AWTEvent.TEXT_EVENT_MASK);
      Hk.enableEvents(AWTEvent.TEXT_EVENT_MASK);
      VR.enableEvents(AWTEvent.TEXT_EVENT_MASK);
      Vi.enableEvents(AWTEvent.TEXT_EVENT_MASK);
      Vj.enableEvents(AWTEvent.TEXT_EVENT_MASK);
      Vk.enableEvents(AWTEvent.TEXT_EVENT_MASK); */

      HR.addTextListener(hVAxisListener_);
      Hi.addTextListener(hVAxisListener_);
      Hj.addTextListener(hVAxisListener_);
      Hk.addTextListener(hVAxisListener_);
      VR.addTextListener(hVAxisListener_);
      Vi.addTextListener(hVAxisListener_);
      Vj.addTextListener(hVAxisListener_);
      Vk.addTextListener(hVAxisListener_);
    } else {
      //System.out.println("ParmFrame.listenToHAndVAxes turned OFF");
      /* HR.disableEvents(AWTEvent.TEXT_EVENT_MASK);
      Hi.disableEvents(AWTEvent.TEXT_EVENT_MASK);
      Hj.disableEvents(AWTEvent.TEXT_EVENT_MASK);
      Hk.disableEvents(AWTEvent.TEXT_EVENT_MASK);
      VR.disableEvents(AWTEvent.TEXT_EVENT_MASK);
      Vi.disableEvents(AWTEvent.TEXT_EVENT_MASK);
      Vj.disableEvents(AWTEvent.TEXT_EVENT_MASK);
      Vk.disableEvents(AWTEvent.TEXT_EVENT_MASK); */
    
      HR.removeTextListener(hVAxisListener_);
      Hi.removeTextListener(hVAxisListener_);
      Hj.removeTextListener(hVAxisListener_);
      Hk.removeTextListener(hVAxisListener_);
      VR.removeTextListener(hVAxisListener_);
      Vi.removeTextListener(hVAxisListener_);
      Vj.removeTextListener(hVAxisListener_);
      Vk.removeTextListener(hVAxisListener_);
    }
  }
  
  private void setScanOnFalse ()
  {
//    jQCentral_.message("ParmFrame.setScanOnFalse scanOn_ = " + scanOn_, false);
    Q1MI_.setState(false);
    Q2MI_.setState(false);
    Q3MI_.setState(false);
  } 
  
  private void setPPPFalse ()
  {
//    jQCentral_.message("ParmFrame.setPPPFalse ppp_ = " + ppp_, false);
    if (ppp_ != 1 && ppp1MI_.getState())
      ppp1MI_.setState(false);
    if (ppp_ != 2 && ppp2MI_.getState())
      ppp2MI_.setState(false);
    if (ppp_ != 4 && ppp4MI_.getState())
      ppp4MI_.setState(false);
    if (ppp_ != 9 && ppp9MI_.getState())
      ppp9MI_.setState(false);
  }

  public void setHVRatio (Dimension ratio1)
  {
    hVRatio_ = new Dimension(ratio1);
  }
  
  public Dimension getHVRatio ()
    // This is called by new JQCanvases as they start up.
  {
    return hVRatio_;
  }
  
  public void setLooper (String arg)
  {
//    boolean argsTooP = !arg.equals(looperText_.getText()); - Messed up on reading image.
    looperText_.setText(arg);
    JQLooper looper = jQCentral_.findLoopObject(arg);
    if (looper != null) {
      setLoopersLabels(looper);
//      if (argsTooP) {
//        setLooperDefaults(looper);
//      }
    }
  }

  public void takeValuesFrom (JQCanvas canvas1)
  {
    takeValuesFrom(canvas1.spec());
  }
  
  public void setPanelFields (int num_panels, int h_panel, int v_panel)
  {
    panelsLTF.setText(String.valueOf(num_panels));
    hPanelLTF.setText(String.valueOf(h_panel));
    vPanelLTF.setText(String.valueOf(v_panel));
  }
  
  public void setRange (double newRange)
  {
    viewLTF.setText(String.valueOf(newRange));
  }
  
  public int numberOfPanels ()
  {
    if (panelsLTF.valueOk_p()) {
      return panelsLTF.intValue();
    }
    return 0; // A signal of goofy data, which 0 is.
  }
  
  public int pixelsWide ()
  {
    if (widthLTF.valueOk_p()) {
      return widthLTF.intValue();
    }
    return 0; // A signal of goofy data, which 0 is.
  }
  
  public int pixelsHigh ()
  {
    if (heightLTF.valueOk_p()) {
      return heightLTF.intValue();
    }
    return 0; // A signal of goofy data, which 0 is.
  }
  
  
  
  public void scaleVAxis (double scale_factor)
  {
    if (vAxesOkp() && scale_factor != 0) {
      FastQuaternion vax = vAxis();
      vax.times_scalar_n(scale_factor);
      displayAsVAxis(vax);
    }
  }
  
  public void setLoopersLabels (JQLooper looper)
    // This initializes the middle area where Q1, Q2, and Q3 exist.
  {
    //System.out.println("setLoopersLabels pt 1");
    labelQ1_.setText(looper.q1String());
    labelQ2_.setText(looper.q2String());
    labelQ3_.setText(looper.q3String());
    //System.out.println("setLoopersLabels pt 2 " + formula_);
    formula_.setText(looper.formulaString());
  }
  
  private void setLooperDefaults (JQLooper looper)
    // This initializes the middle area where Q1, Q2, and Q3 exist.
  {
    FastQuaternion init = looper.q1Init();
    //System.out.println("setLoopersLabels pt 3 init=" + init + " Q1R " + Q1R);
    Q1R.setText(String.valueOf(init.r));
    Q1i.setText(String.valueOf(init.i));
    Q1j.setText(String.valueOf(init.j));
    Q1k.setText(String.valueOf(init.k));
    init = looper.q2Init();
    //System.out.println("setLoopersLabels pt 4 " + init);
    Q2R.setText(String.valueOf(init.r));
    Q2i.setText(String.valueOf(init.i));
    Q2j.setText(String.valueOf(init.j));
    Q2k.setText(String.valueOf(init.k));
    init = looper.q3Init();
    //System.out.println("setLoopersLabels pt 5 " + init);
    Q3R.setText(String.valueOf(init.r));
    Q3i.setText(String.valueOf(init.i));
    Q3j.setText(String.valueOf(init.j));
    Q3k.setText(String.valueOf(init.k));
  }
  
  public void takeValuesFrom (FractalSpec specArg)
    // This displays the appropriate values from specArg in this ParmFrame.
  {
//    jQCentral_.message("ParmFrame.takeValuesFrom entry", false);
    listenToHAndVAxes(false);
    viewLTF.setText(String.valueOf(specArg.range));
    widthLTF.setText(String.valueOf(specArg.pix_width));
    heightLTF.setText(String.valueOf(specArg.pix_height));
    depthLTF.setText(String.valueOf(specArg.depth));
    ColorCyclesLTF.setText(String.valueOf(specArg.color_cycles));
    panelsLTF.setText(String.valueOf(specArg.panels));
    hPanelLTF.setText(String.valueOf(specArg.panel_x));
    vPanelLTF.setText(String.valueOf(specArg.panel_y));
    Q1R.setText(specArg.center.rToString());
    Q1i.setText(specArg.center.iToString());
    Q1j.setText(specArg.center.jToString());
    Q1k.setText(specArg.center.kToString());
    Q2R.setText(specArg.coeff.rToString());
    Q2i.setText(specArg.coeff.iToString());
    Q2j.setText(specArg.coeff.jToString());
    Q2k.setText(specArg.coeff.kToString());
    Q3R.setText(specArg.trans.rToString());
    Q3i.setText(specArg.trans.iToString());
    Q3j.setText(specArg.trans.jToString());
    Q3k.setText(specArg.trans.kToString());
    HR.setText(specArg.vx.rToString());
    Hi.setText(specArg.vx.iToString());
    Hj.setText(specArg.vx.jToString());
    Hk.setText(specArg.vx.kToString());
    VR.setText(specArg.vy.rToString());
    Vi.setText(specArg.vy.iToString());
    Vj.setText(specArg.vy.jToString());
    Vk.setText(specArg.vy.kToString());
    DR.setText(specArg.vz.rToString());
    Di.setText(specArg.vz.iToString());
    Dj.setText(specArg.vz.jToString());
    Dk.setText(specArg.vz.kToString());
    setHifi_p(specArg.hifi_p);
    setColorsIs256_p(specArg.colorsIs256_p);
    setRangeOver(specArg.rangeOver);
    setPtsPerPixel(specArg.pts_per_pixel);
    setLooper(specArg.which);
    listenToHAndVAxes(true);
    
//    jQCentral_.message("ParmFrame.takeValuesFrom about to update axes", false);
    if (dAndWUpdating_p_) {
      boolean temp = setFirstAndSecondPerpendiculars() || setWDisplay(null);
    }
  }
  
  private boolean valuesOk_p ()
  {
    return
    (viewLTF.valueOk_p() &&
    widthLTF.valueOk_p() &&
    heightLTF.valueOk_p() &&
    depthLTF.valueOk_p() &&
    ColorCyclesLTF.valueOk_p() &&
    panelsLTF.valueOk_p() &&
    hPanelLTF.valueOk_p() &&
    vPanelLTF.valueOk_p() &&
    Q1R.valueOk_p() &&
    Q1i.valueOk_p() &&
    Q1j.valueOk_p() &&
    Q1k.valueOk_p() &&
    Q2R.valueOk_p() &&
    Q2i.valueOk_p() &&
    Q2j.valueOk_p() &&
    Q2k.valueOk_p() &&
    Q3R.valueOk_p() &&
    Q3i.valueOk_p() &&
    Q3j.valueOk_p() &&
    Q3k.valueOk_p() &&
    HR.valueOk_p() &&
    Hi.valueOk_p() &&
    Hj.valueOk_p() &&
    Hk.valueOk_p() &&
    VR.valueOk_p() &&
    Vi.valueOk_p() &&
    Vj.valueOk_p() &&
    Vk.valueOk_p() &&
    DR.valueOk_p() &&
    Di.valueOk_p() &&
    Dj.valueOk_p() &&
    Dk.valueOk_p() );
  }
  
  private boolean hAndVAxesOkp ()
  {
    return
    (HR.valueOk_p() &&
     Hi.valueOk_p() &&
     Hj.valueOk_p() &&
     Hk.valueOk_p() &&
     VR.valueOk_p() &&
     Vi.valueOk_p() &&
     Vj.valueOk_p() &&
     Vk.valueOk_p() );
  }
  
  private boolean vAxesOkp ()
  {
    return
    (VR.valueOk_p() &&
     Vi.valueOk_p() &&
     Vj.valueOk_p() &&
     Vk.valueOk_p() );
  }
  
  public void getCheckBoxValues (FractalSpec spec)
  // This copies the CheckboxesMenuItems etc. to the argument spec.
  {
    if (Q1MI_.getState()) {
      spec.rangeOver = FractalSpec.CENTER;
    } else if (Q2MI_.getState()) {
      spec.rangeOver = FractalSpec.COEFF;
    } else if (Q3MI_.getState()) {
      spec.rangeOver = FractalSpec.TRANS;
    }
    
    if (ppp1MI_.getState()) {
      spec.pts_per_pixel = 1;
    } else if (ppp2MI_.getState()) {
      spec.pts_per_pixel = 2;
    } else if (ppp4MI_.getState()) {
      spec.pts_per_pixel = 4;
    } else if (ppp9MI_.getState()) {
      spec.pts_per_pixel = 9;
    } 
      
    spec.hifi_p = !fastMI_.getState();   
    spec.colorsIs256_p = c256MI_.getState();
    String looper1 = looperText_.getText();
    if (looper1 != null && looper1.length() >= 1)
      spec.which = looper1;
    else
      looperText_.setText(spec.which);
  }
  
  public void setCheckBoxValues (FractalSpec spec, boolean pass2Central_p)
  // This sets the CheckboxesMenuItems etc. to the proper values for this frame.
  {
    setScanOnFalse();
    if (spec.rangeOver == FractalSpec.CENTER)
      Q1MI_.setState(true);
    else if (spec.rangeOver == FractalSpec.COEFF)
      Q2MI_.setState(true);
    else if (spec.rangeOver == FractalSpec.TRANS)
      Q3MI_.setState(true);
    scanOn_ = spec.rangeOver;
      
    setPPPFalse();
    if (spec.pts_per_pixel == 1)
      ppp1MI_.setState(true);
    else if (spec.pts_per_pixel == 2)
      ppp2MI_.setState(true);
    else if (spec.pts_per_pixel == 4)
      ppp4MI_.setState(true);
    else if (spec.pts_per_pixel == 9)
      ppp9MI_.setState(true);
      
    fastMI_.setState(!spec.hifi_p);
//    System.out.println("ParmFrame.setCheckBoxValues fastMI_ = " + fastMI_.getState());
    c256MI_.setState(spec.colorsIs256_p);
    setLooper(spec.which);
    if (pass2Central_p) {
//      System.out.println("ParmFrame.setCheckBoxValues branch TRUE");
      jQCentral_.setCheckBoxValues4Frame(spec);
    }
  }

  
  public boolean copyToSpec (FractalSpec specArg)
  {
    if (valuesOk_p()) {
      double parmWidth = widthLTF.intValue(); //Get area user entered in case of change.
      double parmHeight = heightLTF.intValue();
      if (!RatioDialog.offP(hVRatio_)) {
        // Fixed ratio is on.
        // Round the multiple, we want the ratio between h_new_size and v_new_size in the final numbers.
        double inflationD = Math.sqrt((parmWidth * parmHeight)/(hVRatio_.width * (float)hVRatio_.height));
        specArg.pix_width = hVRatio_.width * (int)Math.round(inflationD);
        specArg.pix_height = hVRatio_.height * (int)Math.round(inflationD);
        widthLTF.setText(String.valueOf(specArg.pix_width));
        heightLTF.setText(String.valueOf(specArg.pix_height));
      } else {
        specArg.pix_width = widthLTF.intValue();
        specArg.pix_height = heightLTF.intValue();
      }
      specArg.range = viewLTF.doubleValue();
      specArg.depth = depthLTF.intValue();
      specArg.color_cycles = ColorCyclesLTF.doubleValue();
      specArg.panels = panelsLTF.intValue();
      specArg.panel_x = hPanelLTF.intValue();
      specArg.panel_y = vPanelLTF.intValue();
      specArg.center.setR(Q1R.bigdecimalValue());
      specArg.center.setI(Q1i.bigdecimalValue());
      specArg.center.setJ(Q1j.bigdecimalValue());
      specArg.center.setK(Q1k.bigdecimalValue());
      specArg.coeff.setR(Q2R.bigdecimalValue());
      specArg.coeff.setI(Q2i.bigdecimalValue());
      specArg.coeff.setJ(Q2j.bigdecimalValue());
      specArg.coeff.setK(Q2k.bigdecimalValue());
      specArg.trans.setR(Q3R.bigdecimalValue());
      specArg.trans.setI(Q3i.bigdecimalValue());
      specArg.trans.setJ(Q3j.bigdecimalValue());
      specArg.trans.setK(Q3k.bigdecimalValue());
      specArg.vx.setR(HR.doubleValue());
      specArg.vx.setI(Hi.doubleValue());
      specArg.vx.setJ(Hj.doubleValue());
      specArg.vx.setK(Hk.doubleValue());
      specArg.vy.setR(VR.doubleValue());
      specArg.vy.setI(Vi.doubleValue());
      specArg.vy.setJ(Vj.doubleValue());
      specArg.vy.setK(Vk.doubleValue());
      specArg.vz.setR(DR.doubleValue());
      specArg.vz.setI(Di.doubleValue());
      specArg.vz.setJ(Dj.doubleValue());
      specArg.vz.setK(Dk.doubleValue());
      getCheckBoxValues(specArg);
      return true;
    }
    return false;
  }
  
  public void setLogging (boolean newValue)
  {
    loggingMI_.setState(newValue);
  }
  
  
  /* ---------------------------------  AXES -------------------------------- */
  
  
  private FastQuaternion hAxis ()
  // You should call hAndVAxesOkp and have it return true before calling this.
  {
    return new FastQuaternion(HR.doubleValue(), Hi.doubleValue(), Hj.doubleValue(), Hk.doubleValue());
  }
  
  private FastQuaternion vAxis ()
  // You should call hAndVAxesOkp and have it return true before calling this.
  {
    return new FastQuaternion(VR.doubleValue(), Vi.doubleValue(), Vj.doubleValue(), Vk.doubleValue());
  }
  
  private void displayAsHAxis (FastQuaternion point)
  {
    listenToHAndVAxes(false);
//    jQCentral_.message("ParmFrame.displayAsHAxis", false);
    HR.setText(String.valueOf(point.r));
    Hi.setText(String.valueOf(point.i));
    Hj.setText(String.valueOf(point.j));
    Hk.setText(String.valueOf(point.k));
    listenToHAndVAxes(true);
  }
  
  private void displayAsVAxis (FastQuaternion point)
  {
    listenToHAndVAxes(false);
//    jQCentral_.message("ParmFrame.displayAsVAxis", false);
    VR.setText(String.valueOf(point.r));
    Vi.setText(String.valueOf(point.i));
    Vj.setText(String.valueOf(point.j));
    Vk.setText(String.valueOf(point.k));
    listenToHAndVAxes(true);
  }
  
  
  public void setHandVAxes (FastQuaternion newH, FastQuaternion newV)
    // this is good for rotation the axes.  D and W axes are not affected.
  {
    listenToHAndVAxes(false);
    HR.setText(String.valueOf(newH.r));
    Hi.setText(String.valueOf(newH.i));
    Hj.setText(String.valueOf(newH.j));
    Hk.setText(String.valueOf(newH.k));
    VR.setText(String.valueOf(newV.r));
    Vi.setText(String.valueOf(newV.i));
    Vj.setText(String.valueOf(newV.j));
    Vk.setText(String.valueOf(newV.k));
    listenToHAndVAxes(true);
    boolean btemp = setFirstAndSecondPerpendiculars() || setWDisplay(strH) || setWDisplay(strV);
  }    
  
  
 /* -------------- Daxis methods ------------------ */

  
  
  private boolean setFirstAndSecondPerpendiculars ()
    // This sets the two perpendiculars to the H and V axes,
    //  then using the double value (in text) next to the scroll bar
    //  computes the D axis and displays it as text values for R, i, j, and k.
    // Returns false if the W axis needs to be updated.
  {
//    jQCentral_.message("ParmFrame.setFirstAndSecondPerpendiculars", false);
    FastQuaternion hAxis1;
    FastQuaternion vAxis1;
    if (hAndVAxesOkp()) {
      hAxis1 = hAxis();
      vAxis1 = vAxis();
    } else {
      return true;
    }
    if (((firstPerp_.assign_from(unitR).normalizePerpendicularTo(vAxis1) &&
          firstPerp_.normalizePerpendicularTo(hAxis1) ) ||
         (firstPerp_.assign_from(unitI).normalizePerpendicularTo(vAxis1) &&
          firstPerp_.normalizePerpendicularTo(hAxis1) ) ||
         (firstPerp_.assign_from(unitJ).normalizePerpendicularTo(vAxis1) &&
          firstPerp_.normalizePerpendicularTo(hAxis1) ) ||
         (firstPerp_.assign_from(unitK).normalizePerpendicularTo(vAxis1) &&
          firstPerp_.normalizePerpendicularTo(hAxis1) )) &&
        setSecondPerpendicular() ) {
      //System.out.println("ParmFrame.setFirstAndSecondPerpendiculars firstPerp_=" + firstPerp_ +
      //                   "  secondPerp_ = " + secondPerp_);
      
      return rotateBetweenPerpendiculars() || setWDisplay(strP1) || setWDisplay(strP2);
    }
    return true;
  }
  
  private boolean rotateBetweenPerpendiculars ()
    // Given the two perpendiculars, set dAxis to the vector obtained from
    // the rotation "degrees between".
    // Retruns true is there is no need to update the W axis.
  {
    //jQCentral_.message("ParmFrame.rotateBetweenPerpendiculars", false);
//    System.out.println("ParmFrame.rotateBetweenPerpendiculars" + firstPerp_ + " * " + secondPerp_);
    
    if (setDAxisDegrees()) {
//      FastQuaternion temp = FastQuaternion.rotate(dAxisDegrees_, firstPerp_, secondPerp_);
//      System.out.println("ParmFrame.rotateBetweenPerpendiculars" + dAxisDegrees_ + " * " + temp);
      displayAsDAxis(FastQuaternion.rotate(dAxisDegrees_, firstPerp_, secondPerp_));
      return setWDisplay(strD);
    }
    return true;
  }
  
  private boolean setDAxisDegrees ()
  {
    try {
      Double value = new Double(dText_.getText());
      dAxisDegrees_ = value.doubleValue();
    } catch (Throwable except) {
      dText_.setForeground(Color.red);
      return false;
    }
    return true;
  }

  private boolean setSecondPerpendicular ()
    // This is called from setFirstAndSecondPerpendiculars which has 
    // checked that hAndVAxesOkp.
  {
    FastQuaternion vAxis1 = vAxis();
    FastQuaternion hAxis1 = hAxis();
    return (secondPerp_.assign_from(unitK).normalizePerpendicularTo(vAxis1) &&
            secondPerp_.normalizePerpendicularTo(hAxis1) &&
            secondPerp_.normalizePerpendicularTo(firstPerp_) ) ||
           (secondPerp_.assign_from(unitJ).normalizePerpendicularTo(vAxis1) &&
            secondPerp_.normalizePerpendicularTo(hAxis1) &&
            secondPerp_.normalizePerpendicularTo(firstPerp_) ) ||
           (secondPerp_.assign_from(unitI).normalizePerpendicularTo(vAxis1) &&
            secondPerp_.normalizePerpendicularTo(hAxis1) &&
            secondPerp_.normalizePerpendicularTo(firstPerp_) ) ||
           (secondPerp_.assign_from(unitR).normalizePerpendicularTo(vAxis1) &&
            secondPerp_.normalizePerpendicularTo(hAxis1) &&
            secondPerp_.normalizePerpendicularTo(firstPerp_) );
  }
  
  private void displayAsDAxis (FastQuaternion point)
  {
    DR.setText(String.valueOf(point.r));
    Di.setText(String.valueOf(point.i));
    Dj.setText(String.valueOf(point.j));
    Dk.setText(String.valueOf(point.k));
  }
  
  private boolean dTextOkp ()
  {
    return (DR.valueOk_p() &&
            Di.valueOk_p() &&
            Dj.valueOk_p() &&
            Dk.valueOk_p() );
  }
  
  public FastQuaternion dAxis ()
  {
    if (dTextOkp())
      return new FastQuaternion(DR.doubleValue(),
                                Di.doubleValue(),
                                Dj.doubleValue(),
                                Dk.doubleValue() );
    return new FastQuaternion();
  }


 /* -------------- W axis methods ------------------ */
  
  private void displayAsWAxis (FastQuaternion point)
  {
    WR.setText(String.valueOf(point.r));
    Wi.setText(String.valueOf(point.i));
    Wj.setText(String.valueOf(point.j));
    Wk.setText(String.valueOf(point.k));
  }
  
  private boolean setWAxisDegrees ()
  {
    try {
      Double value = new Double(wText_.getText());
      wAxisDegrees_ = value.doubleValue();
    } catch (Throwable except) {
      wText_.setForeground(Color.red);
      return false;
    }
    return true;
  }

  private boolean wTextOkp ()
  {
    return (WR.valueOk_p() &&
            Wi.valueOk_p() &&
            Wj.valueOk_p() &&
            Wk.valueOk_p() );
  }
  
  public FastQuaternion wAxis ()
  {
    if (wTextOkp())
      return new FastQuaternion(WR.doubleValue(),
                                Wi.doubleValue(),
                                Wj.doubleValue(),
                                Wk.doubleValue() );
    return new FastQuaternion();
  }
  
  private FastQuaternion getAxis (String whichAxis)
  {
    if (whichAxis.equals(strH)) {
      if (hAndVAxesOkp())
        return hAxis();
    } else if (whichAxis.equals(strV)) {
      if (hAndVAxesOkp())
        return vAxis();
    } else if (whichAxis.equals(strD)) {
      if (dTextOkp())
        return dAxis();
    } else if (whichAxis.equals(strMemH)) {
      return memH_;
    } else if (whichAxis.equals(strMemV)) {
      return memV_;
    } else if (whichAxis.equals(strP1)) {
      return firstPerp_;
    } else if (whichAxis.equals(strP2)) {
      return secondPerp_;
    }
    return null;
  }

  private boolean setWDisplay (String changedAxis)
    // Sets the display of the W (work) axis provided changeAxis matches wLeft_ or wRight_'s choice
    // or is it is null;
  {
//    jQCentral_.message("ParmFrame.setWDisplay entry", false);
    boolean proceed = (changedAxis == null || 
                       changedAxis.equals(wLeft_.getSelectedItem()) ||
                       changedAxis.equals(wRight_.getSelectedItem()) );
    if (!proceed)
      return false;
    FastQuaternion leftAxis = getAxis(wLeft_.getSelectedItem());
    FastQuaternion rightAxis = getAxis(wRight_.getSelectedItem());
    if (leftAxis == null || rightAxis == null)
      return false;
    if (setWAxisDegrees()) {
      displayAsWAxis(FastQuaternion.rotate(wAxisDegrees_, leftAxis, rightAxis));
      return true;
    }
    return false;
  }
  

//  private boolean normalizedVectorOK_p ()
//    // Normalizes vector if possible and returns boolean to indicate success.
//    // Updates the value of rotateAxis and updates the display.
//  {
//    if (!(setDAxisDegrees() && degreesRotationText.valueOk_p()))
//      return false;
//    FastQuaternion vector = rotation_text_to_point();
//    double degrees = degreesRotationText.doubleValue();
//    if (vector.normalizePerpendicularTo(vAxis) &&
//        vector.normalizePerpendicularTo(hAxis) ) {
//      rotateAxis.assign_from(vector);
//      rotation_point_to_text(rotateAxis);
//      return true;
//    }
//    return false;
//  } 

 
  /* ---------------- Listeners -------------------- */

  class MyWindowLNR implements WindowListener
  {
    public void windowOpened (WindowEvent e)
    {
//      jQCentral_.message("ParmFrame$MyWindowLNR.windowOpened", false);
    }

    public void windowClosing (WindowEvent e)
    {
//      jQCentral_.message("ParmFrame$MyWindowLNR.windowClosing", false);
      self_.setVisible(false);
    }

    public void windowClosed (WindowEvent e)
    {
//      jQCentral_.message("ParmFrame$MyWindowLNR.windowClosed", false);
    }

    public void windowIconified (WindowEvent e)
    {
//      jQCentral_.message("ParmFrame$MyWindowLNR.windowIconified", false);
    }

    public void windowDeiconified (WindowEvent e)
    {
      
    }

    public void windowActivated (WindowEvent e)
    {
       jQCentral_.activateParmFrame();
    }

    public void windowDeactivated (WindowEvent e)
    {
      
    }
  }
  
   /* ------------ File Menu ---------------- */
   
  class newFrameLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      jQCentral_.makeNewFrame(null);
    }
  }

  class openFileLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      jQCentral_.openImage();
    }
  }

  class openParmLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      //lastCommandWasAdjust_ = false;
      jQCentral_.readParms(jQCentral_.write2URLP(), -1);
    }
  }
  
  class openLogLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent event)
    {
      //lastCommandWasAdjust_ = false;
      IntDialog numberBox = new IntDialog("Enter log entry number", self_, "-1");
      try {
        int entry = numberBox.getValue();
        jQCentral_.readParms(jQCentral_.write2URLP(), entry);
      } catch (NumberFormatException exc) {
        jQCentral_.message("Error in reading entry number.",true);
        jQCentral_.message(exc.getMessage() == null ? exc.toString() : exc.getMessage(), true);
      }
    }
  }
  
  class trapFileLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      jQCentral_.openTrapImage();
    }
  }
  
  class saveAsFileLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      jQCentral_.saveImage();
    }
  }

  class write2URLLNR implements ItemListener 
  {
    public void itemStateChanged(ItemEvent event)
    {
      //lastCommandWasAdjust_ = false;
      if (event.getStateChange() == ItemEvent.DESELECTED)
        jQCentral_.setWrite2URLP(false);
      else if (event.getStateChange() == ItemEvent.SELECTED)
        jQCentral_.setWrite2URLP(true);
      else 
        jQCentral_.message("ParmFrame.write2URLLNR logging unknown state.", false);
    }
  }
  
  class ClrFmTrap implements ItemListener 
  {
    public void itemStateChanged(ItemEvent event)
    {
      if (event.getStateChange() == ItemEvent.DESELECTED) {
        //colorMapFromTrapP_.setState(false);
        jQCentral_.setColorMapFromTrap(false);
      } else if (event.getStateChange() == ItemEvent.SELECTED) {
        //colorMapFromTrapP_.setState(true);
        jQCentral_.setColorMapFromTrap(true);
      } else {
        jQCentral_.message("ParmFrame.soQ1LNR unknown state.", false);
      }
    }
  }
  

  class loggingLNR implements ItemListener 
  {
    public void itemStateChanged(ItemEvent event)
    {
      if (event.getStateChange() == ItemEvent.DESELECTED)
        jQCentral_.toggleLogging(false);
      else if (event.getStateChange() == ItemEvent.SELECTED)
        jQCentral_.toggleLogging(true);
      else 
        jQCentral_.message("JQFrame.loggingLNR logging unknown state.", false);
    }
  }
  
  class saveArgsFLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      //lastCommandWasAdjust_ = false;
      jQCentral_.writeParms(jQCentral_.write2URLP(), null);
    }
  }
  
  class usrComLNR implements ItemListener 
  {
    public void itemStateChanged(ItemEvent event)
    {
      //lastCommandWasAdjust_ = false;
      if (event.getStateChange() == ItemEvent.DESELECTED)
        jQCentral_.setUserWantsToAddCOmmentP(false);
      else if (event.getStateChange() == ItemEvent.SELECTED)
        jQCentral_.setUserWantsToAddCOmmentP(true);
      else 
        jQCentral_.message("JQFrame.usrComLNR logging unknown state.", false);
    }
  }
  
  class quitLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      jQCentral_.timeToQuit();
    }
  }

  class closeLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      self_.setVisible(false);
      ;;jQCentral_.removeFrame(self_);
    }
  }

  // -------------- Draw Menu ---------------- startDrawLNR stopDrawLNR

  class startDrawLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      FractalSpec spec = new FractalSpec();
      getCheckBoxValues(spec);
      jQCentral_.setCheckBoxValues4Frame(spec);
      jQCentral_.drawActiveCanvas();
    }
  }
  
  class stopDrawLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      jQCentral_.pauseActiveCanvas();
    }
  }

  // --------------- Settings Menu ------------------ fastLNR c256LNR
  
  private void setHifi_p (boolean hifi_p)
  {
    //jQCentral_.message("ParmFrame.setHifi_p hifi_p=" + hifi_p, false);
    fastMI_.setState(!hifi_p);
  }
  
  private void setColorsIs256_p (boolean arg)
  {
//    jQCentral_.message("ParmFrame.setColorsIs256_p ", false);
    c256MI_.setState(arg);
  }
  
  private void setRangeOver (int arg)
  {
//    jQCentral_.message("ParmFrame.setRangeOver ", false);
    if (scanOn_ == arg)
      return;
    scanOn_ = arg;
    setScanOnFalse();
    if (arg == FractalSpec.CENTER && !Q1MI_.getState())
      Q1MI_.setState(true);
    else if (arg == FractalSpec.COEFF && !Q2MI_.getState())
      Q2MI_.setState(true);
    else if (arg == FractalSpec.TRANS && !Q3MI_.getState())
      Q3MI_.setState(true);
  }
  
  private void setPtsPerPixel (int arg)
  {
//    jQCentral_.message("ParmFrame.setPtsPerPixel ", false);
    if (ppp_ == arg)
      return;
    ppp_ = arg;
    setPPPFalse();
    if (arg == 1 && !ppp1MI_.getState())
      ppp1MI_.setState(true);
    else if (arg == 2 && !ppp2MI_.getState())
      ppp2MI_.setState(true);
    else if (arg == 4 && !ppp4MI_.getState())
      ppp4MI_.setState(true);
    else if (arg == 9 && !ppp9MI_.getState())
      ppp9MI_.setState(true);
    else
      jQCentral_.message("ParmFrame.setPtsPerPixel received arg = " + arg, false);
  }
  
  class soQ1LNR implements ItemListener 
  {
    public void itemStateChanged(ItemEvent event)
    {
//      jQCentral_.message("ParmFrame$soQ1LNR ", false);
      if (event.getStateChange() == ItemEvent.DESELECTED) {
        Q1MI_.setState(true);
      } else if (event.getStateChange() == ItemEvent.SELECTED) {
        setRangeOver(FractalSpec.CENTER);
      } else {
        jQCentral_.message("ParmFrame.soQ1LNR unknown state.", false);
      }
    }
  }
  
  class soQ2LNR implements ItemListener 
  {
    public void itemStateChanged(ItemEvent event)
    {
//      jQCentral_.message("ParmFrame$soQ2LNR ", false);
      if (event.getStateChange() == ItemEvent.DESELECTED) {
        Q2MI_.setState(true);
      } else if (event.getStateChange() == ItemEvent.SELECTED) {
        setRangeOver(FractalSpec.COEFF);
      } else {
        jQCentral_.message("ParmFrame.soQ2LNR unknown state.", false);
      }
    }
  }
  
  class soQ3LNR implements ItemListener 
  {
    public void itemStateChanged(ItemEvent event)
    {
//      jQCentral_.message("ParmFrame$soQ3LNR ", false);
      if (event.getStateChange() == ItemEvent.DESELECTED) {
        Q3MI_.setState(true);
      } else if (event.getStateChange() == ItemEvent.SELECTED) {
        setRangeOver(FractalSpec.TRANS);
      } else {
        jQCentral_.message("ParmFrame.soQ3LNR unknown state.", false);
      }
    }
  }
  
  class ppp1LNR implements ItemListener 
  {
    public void itemStateChanged(ItemEvent event)
    {
//      jQCentral_.message("ParmFrame$ppp1LNR ", false);
      if (event.getStateChange() == ItemEvent.DESELECTED) {
        ppp1MI_.setState(true);
      } else if (event.getStateChange() == ItemEvent.SELECTED) {
        setPtsPerPixel(1);
      } else {
        jQCentral_.message("ParmFrame.ppp1LNR  unknown state.", false);
      }
    }
  }
  
  class ppp2LNR implements ItemListener 
  {
    public void itemStateChanged(ItemEvent event)
    {
//      jQCentral_.message("ParmFrame$ppp2LNR ", false);
      if (event.getStateChange() == ItemEvent.DESELECTED) {
        ppp2MI_.setState(true);
      } else if (event.getStateChange() == ItemEvent.SELECTED) {
        setPtsPerPixel(2);
      } else { 
        jQCentral_.message("ParmFrame.ppp2LNR  unknown state.", false);
      }
    }
  }
  
  class ppp4LNR implements ItemListener 
  {
    public void itemStateChanged(ItemEvent event)
    {
//      jQCentral_.message("ParmFrame$ppp4LNR ", false);
      if (event.getStateChange() == ItemEvent.DESELECTED) {
        ppp4MI_.setState(true);
      } else if (event.getStateChange() == ItemEvent.SELECTED) {
        setPtsPerPixel(4);
      } else {
        jQCentral_.message("ParmFrame.ppp4LNR  unknown state.", false);
      }
    }
  }
  
  class ppp9LNR implements ItemListener 
  {
    public void itemStateChanged(ItemEvent event)
    {
//      jQCentral_.message("ParmFrame$ppp9LNR ", false);
      if (event.getStateChange() == ItemEvent.DESELECTED) {
        ppp9MI_.setState(true);
      } else if (event.getStateChange() == ItemEvent.SELECTED) {
        setPtsPerPixel(9);
      } else { 
        jQCentral_.message("ParmFrame.ppp9LNR  unknown state.", false);
      }
    }
  }

  class HVRatioLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
//      jQCentral_.message("ParmFrame$HVRatioLNR ", false);
      RatioDialog dialog = new RatioDialog("Width/Height Ratio", jQCentral_, hVRatio_);
      hVRatio_ = dialog.getDimension();
    }
  }
  
  class dsplyParmsLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      //lastCommandWasAdjust_ = false;
      jQCentral_.setParameters(null);
    }
  }
      
   /* ------------ Settings Add On ---------------- */
   
  class docLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      String arg = looperText_.getText();
      JQLooper looper = jQCentral_.findLoopObject(arg);
      //System.out.println("ParmFrame.docLNR");
      if (looper != null) {
        jQCentral_.message(looper.docString(), true);
      }
    }
  }

  class defaultLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      String arg = looperText_.getText();
      JQLooper looper = jQCentral_.findLoopObject(arg);
      //System.out.println("ParmFrame.docLNR");
      if (looper != null) {
        self_.setLooperDefaults(looper);
      }
    }
  }

     /* --------------- Adjust Menu ---------------- */
  
  class EnlargeLNR  implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      //lastCommandWasAdjustCREDIT_ = 1; // So frame activation after dialog removal 
                                       // doesn't set lastCommandWasAdjust_ false
      IntDialog dialog = new IntDialog("Zoom Percentage", self_, 
                                       String.valueOf(jQCentral_.enlargePixels()) );
      try {
        jQCentral_.setEnlargePixels(dialog.getValue());
        jQCentral_.adjustEnlarge(jQCentral_.enlargePixels());
      } catch (NumberFormatException except) {
        jQCentral_.message("Illegal percentage entered: " + except,true);
        jQCentral_.message(except.getMessage() == null ? 
                           except.toString() : except.getMessage(), true);
      }
    }
  }
    
  class EnlrgAgnLNR  implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      jQCentral_.adjustEnlarge(jQCentral_.enlargePixels());
    }
  }
  
  class RightLNR  implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      //lastCommandWasAdjustCREDIT_ = 1; // So frame activation after dialog removal 
                                       // doesn't set lastCommandWasAdjust_ false
      IntDialog dialog = new IntDialog("Shift Right pixels", self_, 
                                       String.valueOf(jQCentral_.rightPixels()) );
      try {
        jQCentral_.setRightPixels(dialog.getValue());
        jQCentral_.adjustCenterRight(-jQCentral_.rightPixels());
      } catch (NumberFormatException except) {
        jQCentral_.message("Illegal # of pixels: " + except,true);
        jQCentral_.message(except.getMessage() == null ? 
                           except.toString() : except.getMessage(), true);
      }
    }
  }
    
  class RightAgnLNR  implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      jQCentral_.adjustCenterRight(jQCentral_.rightPixels());
    }
  }
  
  class DownLNR  implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      //lastCommandWasAdjustCREDIT_ = 1; // So frame activation after dialog removal 
                                       // doesn't set lastCommandWasAdjust_ false
      IntDialog dialog = new IntDialog("Shift Down pixels", self_, 
                                       String.valueOf(jQCentral_.downPixels()) );
      try {
        jQCentral_.setDownPixels(dialog.getValue());
        jQCentral_.adjustCenterUp(jQCentral_.downPixels());
      } catch (NumberFormatException except) {
        jQCentral_.message("Illegal # of pixels: " + except,true);
        jQCentral_.message(except.getMessage() == null ?
                           except.toString() : except.getMessage(), true);
      }
    }
  }
    
  class DownAgnLNR  implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      jQCentral_.adjustCenterUp(jQCentral_.downPixels());
    }
  }    
     
  class OnWLNR  implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      //lastCommandWasAdjustCREDIT_ = 1; // So frame activation after dialog removal 
                                       // doesn't set lastCommandWasAdjust_ false
      IntDialog dialog = new IntDialog("Shift pixels on W", self_, 
                                       String.valueOf(jQCentral_.onWPixels()));
      try {
        jQCentral_.setOnWPixels(dialog.getValue());
        jQCentral_.adjustCenterOnW(jQCentral_.onWPixels());
      } catch (NumberFormatException except) {
        jQCentral_.message("Illegal # of pixels: " + except,true);
        jQCentral_.message(except.getMessage() == null ?
                           except.toString() : except.getMessage(), true);
      }
    }
  }
    
  class OnWAgnLNR  implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      jQCentral_.adjustCenterOnW(jQCentral_.onWPixels());
    }
  }    
     
   /* ------------ Axis Menu ---------------- */
   
  void setView4HVReversal ()
  {
    if (viewLTF.valueOk_p() &&
        widthLTF.valueOk_p() &&
        heightLTF.valueOk_p() ) {
      double range = viewLTF.doubleValue();
      int width = widthLTF.intValue();
      int height = heightLTF.intValue();
      double newRange = (range * height) / width;
      viewLTF.setText(String.valueOf(newRange));
    }
  }
  
  public void swapHV ()
  {
    listenToHAndVAxes(false);
    String temp;
    temp = HR.getText();
    HR.setText(VR.getText());
    VR.setText(temp);
      
    temp = Hi.getText();
    Hi.setText(Vi.getText());
    Vi.setText(temp);
      
    temp = Hj.getText();
    Hj.setText(Vj.getText());
    Vj.setText(temp);
      
    temp = Hk.getText();
    Hk.setText(Vk.getText());
    Vk.setText(temp);
    listenToHAndVAxes(true);
      
    // Swap height and width
    setView4HVReversal();
    temp = widthLTF.getText();
    widthLTF.setText(heightLTF.getText());
    heightLTF.setText(temp); 
    //boolean btemp = setFirstAndSecondPerpendiculars() || setWDisplay(strH) || setWDisplay(strV);
  }
  
  String negateNumberString (String number1)
  {
    if (number1.charAt(0) == '-') {
      return number1.substring(1);
    }
    // Check that we don't have 0.  If so return it unchanged.
    try {
      double val = Double.valueOf(number1).doubleValue();
      if (val == 0.0)
        return number1;
    } catch (Throwable e) {
      return number1;
    }
    return ("-" + number1);
  }
  
  public void rotate90R ()
  {
    listenToHAndVAxes(false);
    String temp;
    temp = HR.getText();
    HR.setText(VR.getText());
    VR.setText(negateNumberString(temp)); //Negate
    
    temp = Hi.getText();
    Hi.setText(Vi.getText());
    Vi.setText(negateNumberString(temp));
      
    temp = Hj.getText();
    Hj.setText(Vj.getText());
    Vj.setText(negateNumberString(temp));
      
    temp = Hk.getText();
    Hk.setText(Vk.getText());
    Vk.setText(negateNumberString(temp));
    listenToHAndVAxes(true);
      
      // Swap height and width
    setView4HVReversal();
    temp = widthLTF.getText();
    widthLTF.setText(heightLTF.getText());
    heightLTF.setText(temp);   
      
    //boolean btemp = setFirstAndSecondPerpendiculars() || setWDisplay(strH) || setWDisplay(strV);
  }
  
  public void rotate90L ()
  {
    listenToHAndVAxes(false);
    String temp;
    temp = HR.getText();
    HR.setText(negateNumberString(VR.getText())); // Negate
    VR.setText(temp);
      
    temp = Hi.getText();
    Hi.setText(negateNumberString(Vi.getText()));
    Vi.setText(temp);
      
    temp = Hj.getText();
    Hj.setText(negateNumberString(Vj.getText()));
    Vj.setText(temp);
      
    temp = Hk.getText();
    Hk.setText(negateNumberString(Vk.getText()));
    Vk.setText(temp);
    listenToHAndVAxes(true);
      
    // Swap height and width
    setView4HVReversal();
    temp = widthLTF.getText();
    widthLTF.setText(heightLTF.getText());
    heightLTF.setText(temp);
      
    //boolean btemp = setFirstAndSecondPerpendiculars() || setWDisplay(strH) || setWDisplay(strV);
  }
  
  public void w2H ()
  {
    if (wTextOkp()) {
      displayAsHAxis(wAxis());
      boolean btemp = setFirstAndSecondPerpendiculars() || setWDisplay(strH);
    }
  }
  
  public void w2V ()
  {
    if (wTextOkp()) {
      displayAsVAxis(wAxis());
      boolean btemp = setFirstAndSecondPerpendiculars() || setWDisplay(strV);
    }
  }
  
  public void h2MemH ()
  {
    if (hAndVAxesOkp()) {
      memH_ = hAxis();
      boolean btemp = setFirstAndSecondPerpendiculars() || setWDisplay(strMemH);
    }
   }
  
  public void v2MemV ()
  {
    if (hAndVAxesOkp()) {
      memV_ = vAxis();
      setWDisplay(strMemV);
    }
  }
  
  public void memH2H ()
  {
    displayAsHAxis(memH_);
    boolean btemp = setFirstAndSecondPerpendiculars() || setWDisplay(strH);
  }
  
  public void memV2V ()
  {
    displayAsVAxis(memV_);
    boolean btemp = setFirstAndSecondPerpendiculars() || setWDisplay(strV);
  }
  
  /* ----- Listeners ---- */

  class swapHVLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      swapHV();  
    }
  }
  
  class Rotate90RLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      rotate90R();
    }
  }

  class Rotate90LLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      rotate90L();
    }
  }
  
  class ScaleVLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      IntDialog dialog = new IntDialog("Scale V Axis by...", self_, "-1" );
      try {
        scaleVAxis(dialog.getDoubleValue());
      } catch (NumberFormatException except) {
        jQCentral_.message("Illegal V scale factor: " + except,true);
        jQCentral_.message(except.getMessage() == null ? 
                           except.toString() : except.getMessage(), true);
      }
    }
  }

  class W2HLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      w2H();
    }
  }
  
  class W2VLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      w2V();
    }
  }

  class H2MemHLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      h2MemH();
    }
  }

  class V2MemVLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      v2MemV();
    }
  }
  
  class MemH2HLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      memH2H();
    }
  }

  class MemV2VLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      memV2V();
    }
  }

  class mouseH2LNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      jQCentral_.mouseNewHAxis();
      //System.out.println("ParmFrame.mouseH2LNR");
    }
  }

  class mouseV2LNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      jQCentral_.mouseNewVAxis();
      //System.out.println("ParmFrame.mouseV2LNR");
    }
  }
  
   /* ------------ Windows Menu ---------------- */
   
    // ColorMapLNR TrapLNR
 
  class ColorMapLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      jQCentral_.updateColorMapEd(true, null);
      //System.out.println("ParmFrame.ColorMapLNR");
    }
  }
  
  class MsgLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      jQCentral_.setMessagesVisible(true);
      //System.out.println("ParmFrame.ColorMapLNR");
    }
  }
  
  class TrapLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      jQCentral_.showTrapFrame();
      //System.out.println("ParmFrame.TrapLNR");
    }
  }
  

   /* ------------ Setting the D Axis ---------------- */
   
  class ScrollLNR implements AdjustmentListener
  {
    public void adjustmentValueChanged(AdjustmentEvent event)
    {
//      jQCentral_.message("ParmFrame$ScrollLNR ", false);
      if (!disableDMutualUpdating_p_) {
        int eventValue = event.getValue();
        int currentValue = dScrollbar_.getValue();
        if (eventValue == currentValue) {
//          disableDMutualUpdating_p_ = true;
          setFirstAndSecondPerpendiculars();
          dText_.setText(String.valueOf(eventValue));
        }
      } else {
        disableDMutualUpdating_p_ = false;
      }
    }
  }
  
  class DTextLNR implements TextListener
  {
    public void textValueChanged(TextEvent event)
    {
//      jQCentral_.message("ParmFrame$DTextLNR ", false);
      //if (!disableDMutualUpdating_p_) {
        disableDMutualUpdating_p_ = true;
        setFirstAndSecondPerpendiculars();
        try {
          Double Value = new Double(dText_.getText());
          dText_.setForeground(Color.black);
          dScrollbar_.setValue((int)Value.doubleValue());
          rotateBetweenPerpendiculars();
        } catch (Throwable except) {
          dText_.setForeground(Color.red);
        }
      //} else {
      //  disableDMutualUpdating_p_ = false;
      //}
    }
  }
  
  /* ------------- W Axis Listeners --------------- */
  
  class WScrollLNR implements AdjustmentListener
  {
    public void adjustmentValueChanged(AdjustmentEvent event)
    {
//      jQCentral_.message("ParmFrame$WScrollLNR ", false);
      if (!disableWMutualUpdating_p_) {
        int eventValue = event.getValue();
        int currentValue = wScrollbar_.getValue();
        if (eventValue == currentValue) {
//          disableWMutualUpdating_p_ = true;
          setFirstAndSecondPerpendiculars();
          wText_.setText(String.valueOf(eventValue));
        }
      } else {
        disableWMutualUpdating_p_ = false;
      }
    }
  }
  
  class WTextLNR implements TextListener
  {
    public void textValueChanged(TextEvent event)
    {
//      jQCentral_.message("ParmFrame$WTextLNR ", false);
      //if (!disableWMutualUpdating_p_) {
        disableWMutualUpdating_p_ = true;
        setFirstAndSecondPerpendiculars();
        try {
          Double Value = new Double(wText_.getText());
          wText_.setForeground(Color.black);
          wScrollbar_.setValue((int)Value.doubleValue());
          // Set the value in W
          setWDisplay(null);
        } catch (Throwable except) {
          wText_.setForeground(Color.red);
        }
      //} else {
      //  disableWMutualUpdating_p_ = false;
      //}
    }
  }
  
  class ChoiceLNR implements ItemListener
  {
     public void itemStateChanged(ItemEvent e)
     {
       setWDisplay(null);
     }
  }
  
  class HVTextLNR implements TextListener
  {
    public void textValueChanged(TextEvent e)
    {
//      jQCentral_.message("ParmFrame.HVTextLNR", false);
      self_.setFirstAndSecondPerpendiculars();
    }
  }

  class LooperLNR implements TextListener
  {
//    String lastValue = "Looper22";
    public void textValueChanged(TextEvent event)
    {
      System.out.println("ParmFrame$LooperLNR looper changed.");
//      if (!lastValue.equals(looperText_.getText()))
//        jQCentral_.setLooper4JQFrame(looperText_.getText());
//      lastValue = looperText_.getText();
    }
  }

  private boolean valuesOK_p ()
  {
//    if (!rotation_text_ok_p() || !degreesRotationText.valueOk_p())
//      return false; // Meaning we handled the event.
//    FastQuaternion vector = rotation_text_to_point();
//    if (vector.normalizePerpendicularTo(vAxis) &&
//        vector.normalizePerpendicularTo(hAxis) ) {
//      dAxis.assign_from(vector);
//      return true;
//    }
    return false;
  }


  class WatchedText extends TextField implements ActionListener
    // With the new AWT this class is superfluous.  So REMOVE THIS.
  {
    String id_;
    
    WatchedText (String initialValue, int cols, String id)
    {
      super(initialValue, cols);
      id_ = id;
      addActionListener(this);
    }
 
    public void actionPerformed(ActionEvent event) 
    {
      if (id_.equals("looperText_")) {
        String which = looperText_.getText();
        jQCentral_.setLoooper4ParmFrame(which);
        setLooper(which);
      } else {
        boolean temp = setFirstAndSecondPerpendiculars() || setWDisplay(null);
      }
    }
  } 
}
 


