package JavaQuat20;

import java.awt.*;
import java.awt.event.*;
import java.util.*;


public class RatioDialog extends Dialog
 // This is a stub
{
  private LabeledTextField widthField_;
  private LabeledTextField heightField_;
  private Dimension answer_;
  private static Dimension oldValue_ = new Dimension(1, 1);
  private Button offButton_;
  private boolean enabled_p_ = false;
  private boolean cancelled_p_ = false;

  public RatioDialog (String title, Frame jQFrame, Dimension inputValue)
  {
    super(jQFrame, title, true);
    Vector smallAlpha = new Vector(10);

    setLayout(new GridLayout(2, 1, 0, 10));
    widthField_ =  new LabeledTextField("Width", LabeledTextField.IS_INT,
                                                 LabeledTextField.SIDE_BY_SIDE_2);
    smallAlpha.addElement(widthField_);
    heightField_ = new LabeledTextField("Height", LabeledTextField.IS_INT,
                                                  LabeledTextField.SIDE_BY_SIDE_2);
    smallAlpha.addElement(heightField_);
    Panel textBox = new Panel();
    textBox.setLayout(new GridLayout(1, 2, 4, 4));
    textBox.add(heightField_);
    textBox.add(widthField_);
    
    Panel buttonBox = new Panel();
    buttonBox.setLayout(new GridLayout(1, 4, 4, 4));
    offButton_ = new Button();
    smallAlpha.addElement(offButton_);
    offButton_.addActionListener(new OffLNR());
    buttonBox.add(offButton_);
    buttonBox.add(new Label());
    Button oK = new Button("OK");
    smallAlpha.addElement(oK);
    oK.addActionListener(new OKLNR());
    buttonBox.add(oK);
    Button cancel = new Button("CANCEL");
    smallAlpha.addElement(cancel);
    cancel.addActionListener(new CancelLNR());
    buttonBox.add(cancel);

    add(textBox);
    add(buttonBox);
    setSize(240, 50);
    
    String [] preferredFonts = {"Courier", "courier", 
                                  "Dialog", "dialog", 
                                  "Times", "times"};
    FontSetter setter = new FontSetter(preferredFonts, Font.BOLD, 9);
    setter.setComponentFonts(smallAlpha);

    loadValues(inputValue);
    show();
  }
  
  public Dimension getDimension ()
  {
    if (cancelled_p_) {
      // System.out.println("RatioDialog.getDimension returning old value =" + oldValue_);
      return oldValue_;
    }
    if (enabled_p_ && widthField_.valueOk_p() && heightField_ .valueOk_p())
    {
      int width = widthField_.intValue();
      if (width == 0)
        width = -1;
       else if (!enabled_p_ && width > 0)
        width *= -1;
      int height = heightField_.intValue();
      if (height == 0)
        height = -1;
      // System.out.println("RatioDialog.getDimension returning " + width + " " + height);
      return new Dimension(width, height);
    }
    //System.out.println("RatioDialog.getDimension returning -1s " + enabled_p_ + " " +
    //  widthField_.valueOk_p() + " " + heightField_ .valueOk_p());
    return new Dimension(-1, -1); // Negatives mean DISABLED.
  }
  
  private void loadValues (Dimension valuesIn)
  {
    // System.out.println("RatioDialog.loadValues valuesIn=" + valuesIn);
    oldValue_ = new Dimension(valuesIn);
    cancelled_p_ = false;
    enabled_p_ = !offP(valuesIn);
    offButton_.setLabel(enabled_p_ ? "Enabled" : "Disabled");
    offButton_.setBackground(enabled_p_ ? Color.green : Color.red);
    int width;
    if (valuesIn.width < 0)
      width = -(valuesIn.width);
    else if (valuesIn.width == 0)
      width = 1;
    else 
      width = valuesIn.width;
    int height;
    if (valuesIn.height < 0)
      height = -(valuesIn.height);
    else if (valuesIn.height == 0)
      height = 1;
    else 
      height = valuesIn.height;
    widthField_.setText(Integer.toString(width));
    heightField_.setText(Integer.toString(height));
  }
  
  static public boolean offP (Dimension values)
  {
    return (values.width <= 0 || values.height <= 0);
  }
  
  /* -------------- Listeners ------------------ */
  
  class OffLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      enabled_p_ = !enabled_p_;
      offButton_.setLabel(!enabled_p_ ? "Disabled" : "Enabled");
      offButton_.setBackground(enabled_p_ ? Color.green : Color.red);
    } 
  }
  
  class OKLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      setVisible(false);
    } 
  }
  
  class CancelLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      setVisible(false);
      cancelled_p_ = true;
    }  
  }

}
