package JavaQuat20;

import java.awt.*;
import java.awt.event.*;
import java.util.*;


public class SeqDialog extends Dialog
 // This is the Zoom, Pivot, and Shift dialog.
{
  private Choice savePauseButton_;  // ********** CHOICE
  private final String saveImageString_ = "save image and continue. ";
  private final String pauseSeqString_ =  "pause for screen capture.";
  private final String zoomString_ =  "Zoom";
  private final String pivotString_ = "Pivot";
  private final String shiftString_ = "Shift";
  private TextField pathnameText_;
  private TextField framesText_;
  private Choice choicesMenuButton_ = null;  // ********** CHOICE
  private Label degreesIncLabel_;
  private TextField degreesIncText_;
  private Button setFinalFrameButton_;
  private boolean setFinalFrameArmedp_ = false;
  private final String finalFrameString_ = "Final Frame:";
  private final String finalFrameIsString_ = "is Set.";
  private final String finalFrameNeedesString_ = "Click to Set";
  private CardLayout cardLayout_; // To switch with choicesMenuButton_.
  private CardLayout cardLayout2_; // To switch with choicesMenuButton_.
  private Panel buttonTextSwap_;
  private Button finalFrameButton_;
  private Panel labelButtonSwap_;
  private Button vertPivotButton_;
  
  //private int sequenceChoice_ = SeqSpec.ZOOM;
  private Messenger jQCentral_;
  private SeqDialog self_ = null;
  private SeqSpec spec_;
  private JQFrame frame_;
  
  private int tempInt_;
  private float tempFloat_;
  private boolean finalFrameButtonArmedP_ = true;
  private final String pivotHString = "Pivot -";
  private final String pivotVString = "Pivot |";

  public SeqDialog (String title, JQFrame jQFrame, SeqSpec spec, Messenger jQCentral)
  {
    super(jQFrame, title, true);
    self_ = this;
    jQCentral_ = jQCentral;
    Vector smallAlpha = new Vector(10);
    spec_ = new SeqSpec(spec, true, true);  // We don't share with frame so cancel really does.
    frame_ = jQFrame;
    spec_.enabled_p = true;


    setLayout(new GridLayout(2, 1, 0, 15));
    Panel topHalf = new Panel();
    Panel botHalf = new Panel();
    add(topHalf);
    add(botHalf);
    
    // topHalf
    topHalf.setLayout(new GridLayout(3, 1, 0, 5));
    
    Panel line1 = new Panel();
    topHalf.add(line1);
    line1.setLayout(new BorderLayout(0, 0));
    savePauseButton_ = new Choice(); //new Button(saveImageString_);
    savePauseButton_.add(saveImageString_);
    savePauseButton_.add(pauseSeqString_);
    savePauseButton_.select(0);
    savePauseButton_.addItemListener(new PauseLNR());
    smallAlpha.addElement(savePauseButton_);
    line1.add("East", savePauseButton_);
    Label line1Label = new Label("After each drawing ", Label.RIGHT);
    line1.add("Center", line1Label);
    smallAlpha.addElement(line1Label);
    
    Panel line2 = new Panel();
    topHalf.add(line2);
    line2.setLayout(new BorderLayout(0, 0));
    Label line2Label = new Label("Folder/prefix for save", Label.LEFT);
    smallAlpha.addElement(line2Label);
    Button browsebutton = new Button("Browse...");
    browsebutton.addActionListener(new BrowseLNR());
    smallAlpha.addElement(browsebutton);
    line2.add("East", browsebutton);
    line2.add("Center", line2Label);
    
    // Line 3
    pathnameText_ = new TextField();
    topHalf.add(pathnameText_);
    smallAlpha.addElement(pathnameText_);
    
    
    // botHalf
    botHalf.setLayout(new GridLayout(3, 1, 0, 5));
    Panel line4 = new Panel();
    botHalf.add(line4);
    line4.setLayout(new GridLayout(1, 3, 5, 0));
    Label label4a = new Label("Choose", Label.CENTER);
    Label label4b = new Label("No. of Frames", Label.CENTER);
    degreesIncLabel_ = new Label(finalFrameString_, Label.CENTER);
    line4.add(label4a);
    line4.add(label4b);
    line4.add(degreesIncLabel_);
    smallAlpha.addElement(label4a);
    smallAlpha.addElement(label4b);
    smallAlpha.addElement(degreesIncLabel_);
    
    Panel line5 = new Panel();
    botHalf.add(line5);
    line5.setLayout(new GridLayout(1, 3, 5, 0));
    choicesMenuButton_ = new Choice();
    choicesMenuButton_.add(zoomString_);
    choicesMenuButton_.add(pivotString_);
    choicesMenuButton_.add(shiftString_);
    choicesMenuButton_.select(0);
    line5.add(choicesMenuButton_);
    smallAlpha.addElement(choicesMenuButton_);
    choicesMenuButton_.addItemListener(new MenuLNR());
    
    framesText_ = new TextField();
    framesText_.addTextListener(new framesLNR());
    line5.add(framesText_);
    smallAlpha.addElement(framesText_);
    
    buttonTextSwap_ = new Panel();
    cardLayout_ = new CardLayout();
    buttonTextSwap_.setLayout(cardLayout_);

    degreesIncText_ = new TextField();
    degreesIncText_.addTextListener(new degreesLNR());
    buttonTextSwap_.add("float Text", degreesIncText_);
    smallAlpha.addElement(degreesIncText_);
    
    finalFrameButton_ = new Button(finalFrameNeedesString_);
    finalFrameButton_.addActionListener(new ffbLNR());
    buttonTextSwap_.add("final Frame Button", finalFrameButton_);
    smallAlpha.addElement(finalFrameButton_);

    cardLayout_.show(buttonTextSwap_, "final Frame Button"); //"float Text"
    line5.add(buttonTextSwap_);
    
    
    Panel line6 = new Panel();
    botHalf.add(line6);
    line6.setLayout(new GridLayout(1, 3, 5, 0));
    Button oK = new Button("OK");
    smallAlpha.addElement(oK);
    oK.addActionListener(new OKLNR());
    Button cancel = new Button("CANCEL");
    smallAlpha.addElement(cancel);
    cancel.addActionListener(new CancelLNR());
    line6.add(cancel);
    line6.add(oK);

    labelButtonSwap_ = new Panel();
    cardLayout2_ = new CardLayout();
    labelButtonSwap_.setLayout(cardLayout2_);
    labelButtonSwap_.add("blank", new Label()); // Spacer
    vertPivotButton_ = new Button(" - ");
    vertPivotButton_.addActionListener(new VPivotLNR());
    labelButtonSwap_.add("pivot button", vertPivotButton_);
    smallAlpha.addElement(vertPivotButton_);
    line6.add(labelButtonSwap_);

    setSize(300, 150);
    
    String [] preferredFonts = {"Courier", "courier", 
                                "Dialog", "dialog", 
                                "Times", "times"};
    FontSetter setter = new FontSetter(preferredFonts, Font.BOLD, 9);
    setter.setComponentFonts(smallAlpha);
    setDisplay();
    show();
  }
  
  public String floatStringTrim(String stringValue, int digits)
    // stringValue must be a string representing a float, possibly in scientific notation.
    // digits is how long the result will be, including the Exponent if any.
  {
    try {
      if (stringValue.indexOf('E') < 0 && stringValue.indexOf('e') < 0) {
        // Not scientific notation.
        int longness = Math.min(digits, stringValue.length());
//        System.out.println("SeqDialog.floatStringTrim A longness=" + longness + " answ="
//                            + stringValue.substring(0, longness));
        return stringValue.substring(0, longness);
      }
      int eIndex = Math.max(stringValue.indexOf('E'), stringValue.indexOf('e'));
      int mantissaLength = Math.min(digits - (stringValue.length() - eIndex), eIndex);
//      System.out.println("SeqDialog.floatStringTrim B eIndex=" + eIndex +
//                         " mlength=" + mantissaLength);
      return (stringValue.substring(0, mantissaLength) + 
              stringValue.substring(eIndex, stringValue.length()) );
    } catch (Throwable except) {}
    return null;
  }
  
  public void prepForDisplay ()
  {
    spec_.setStartSpec(frame_.canvas().spec());
    spec_.setEndSpec(null);
    if (spec_.choice == SeqSpec.PIVOT) {
      degreesIncLabel_.setForeground(Color.black);
      spec_.startSpec().vz = jQCentral_.parmsDAxis();
    } else if (spec_.choice == SeqSpec.SHIFT) {
      degreesIncLabel_.setForeground(Color.black);
      spec_.startSpec().vz = jQCentral_.parmsWAxis();
    } else {
      degreesIncLabel_.setForeground(Color.red);
      finalFrameButton_.setLabel(finalFrameNeedesString_);
    }
    finalFrameButtonArmedP_ = true;  
  }
  
  public void setSpec (SeqSpec arg)
  {
    spec_.assignFrom(arg, true, true);
    setDisplay();
  }
  
  private void setDisplay ()
  {
    pathnameText_.setText(spec_.destination);
    framesText_.setText(String.valueOf(spec_.frames));
    
    if (spec_.choice == SeqSpec.ZOOM) {
      if (spec_.endSpec() == null) {
        degreesIncLabel_.setForeground(Color.red);
      } else {
        degreesIncLabel_.setForeground(Color.green);
      }
      cardLayout_.show(buttonTextSwap_, "final Frame Button");
      cardLayout2_.show(labelButtonSwap_, "blank");
      if (spec_.endSpec() == null) {
        degreesIncLabel_.setText("Final Image:");
        degreesIncLabel_.setAlignment(Label.CENTER);
      } else {
        degreesIncLabel_.setText("Final Image is set");
        degreesIncLabel_.setAlignment(Label.CENTER);
      }
    } else if (spec_.choice == SeqSpec.PIVOT) {
      String stringValue = String.valueOf(spec_.degrees);
      degreesIncText_.setText(floatStringTrim(stringValue, 12));
      degreesIncLabel_.setForeground(Color.black);
      
      vertPivotButton_.setLabel(spec_.horizontalPivotP() ? pivotHString : pivotVString);// ? "Pivot -" : "Pivot |");
      
      cardLayout_.show(buttonTextSwap_, "float Text");
      cardLayout2_.show(labelButtonSwap_, "pivot button");
      degreesIncLabel_.setText("Degrees");
      degreesIncLabel_.setAlignment(Label.CENTER);
    } else if (spec_.choice == SeqSpec.SHIFT) {
      if (spec_.shift == 0) {
        spec_.shift = frame_.canvas().spec().range / frame_.canvas().spec().pix_width;
      }
      String stringValue = String.valueOf(spec_.shift);
      degreesIncText_.setText(floatStringTrim(stringValue, 12));
      degreesIncLabel_.setForeground(Color.black);
      
      cardLayout_.show(buttonTextSwap_, "float Text");
      cardLayout2_.show(labelButtonSwap_, "blank");
      degreesIncLabel_.setText("Increment");
      degreesIncLabel_.setAlignment(Label.CENTER);
    } else {
      jQCentral_.message("Error in choice in SeqDialog.setDisplay", true);
    }
  }
  
  public String pathFromDialog ()
  {
     FileDialog fd = new FileDialog(frame_, null, FileDialog.SAVE);
     try {
       fd.show();
     } catch (Throwable e) {
       return null;
     }
     //Allow for variation in Java implementations
     String dir = fd.getDirectory();
     if (dir == null) {
       // User hit cancel probably.
       return null;
     }
     boolean haslash = dir.charAt(dir.length() - 1) == '/';
     String pathname_ = (dir + (haslash ? "" : "/") + fd.getFile());
     return pathname_;
  }
  
  private boolean setTempInt (String arg)
  {
    try {
      tempInt_ = Integer.valueOf(arg).intValue();
    } catch (Throwable except) {
      return false;
    }
    return true;
  }
  
  private boolean setTempFloat (String arg)
  {
    try {
      tempFloat_ = Float.valueOf(arg).floatValue();
    } catch (Throwable except) {
      return false;
    }
    return true;
  }
  
  /* -------------- Listeners ------------------ */
  
  // PauseLNR ZoomLNR PivotLNR ShiftLNR
  
  class PauseLNR implements ItemListener
  {
     public void itemStateChanged(ItemEvent e)
     {
       if (savePauseButton_.getSelectedItem().equals(saveImageString_)) {
         spec_.pause_p = false;
       } else if (savePauseButton_.getSelectedItem().equals(pauseSeqString_)) {
         spec_.pause_p = true;
       } else {
         System.err.println("SeqDialog$PauseLNR received illegal value: " +
                            savePauseButton_.getSelectedItem() );
       }
     }
  }
    
  class BrowseLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
       String pathname = pathFromDialog();
       if (pathname != null) {
         pathnameText_.setText(pathname);
         spec_.destination = pathname;
       }
    } 
  }
  
  class MenuLNR implements ItemListener
  {
    public void itemStateChanged(ItemEvent e)
    {
    
      if (choicesMenuButton_.getSelectedItem().equals(zoomString_)) {
        spec_.choice = SeqSpec.ZOOM;
      } else if (choicesMenuButton_.getSelectedItem().equals(pivotString_)) {
        spec_.choice = SeqSpec.PIVOT;
        prepForDisplay();
        finalFrameButton_.setLabel(finalFrameNeedesString_);
        degreesIncLabel_.setForeground(Color.red);
        finalFrameButtonArmedP_ = true;
      } else if (choicesMenuButton_.getSelectedItem().equals(shiftString_)) {
        spec_.choice = SeqSpec.SHIFT;
        prepForDisplay();
        finalFrameButton_.setLabel(finalFrameNeedesString_);
        degreesIncLabel_.setForeground(Color.red);
        finalFrameButtonArmedP_ = true;
      } else {
        jQCentral_.message("Error in choice in SeqDialog$MenuLNR.actionPerformed", true);
        choicesMenuButton_.select(0);
        spec_.choice = SeqSpec.ZOOM;
      }
      setDisplay();
    } 
  }  
  
  // framesLNR degreesLNR
  
  class framesLNR implements TextListener
  {
    public void textValueChanged(TextEvent e)
    {
      if (setTempInt(framesText_.getText())) {
        framesText_.setForeground(Color.black);
        spec_.frames = tempInt_;
      } else {
        framesText_.setForeground(Color.red);
      }
    }
  }
  
  class degreesLNR implements TextListener
  {
    public void textValueChanged(TextEvent e)
    {
      if (spec_.choice == SeqSpec.SHIFT && degreesIncText_.getText().equals("*")) {
       	spec_.shift = frame_.canvas().spec().range / frame_.canvas().spec().pix_width;
       	degreesIncText_.setText(String.valueOf(spec_.shift));
       	jQCentral_.message("Shift increment set to one pixel", false);
       	return;
      }
      if (setTempFloat(degreesIncText_.getText())) {
        degreesIncText_.setForeground(Color.black);
        if (spec_.choice == SeqSpec.PIVOT) {
          spec_.degrees = tempFloat_;
        } else if (spec_.choice == SeqSpec.SHIFT) {
          spec_.shift = tempFloat_;
        }
      } else {
        degreesIncText_.setForeground(Color.red);
      }
    }
  }
  
  class ffbLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      if (finalFrameButtonArmedP_) {
        spec_.setEndSpec(frame_.canvas().spec());
        finalFrameButton_.setLabel("Set");
        degreesIncLabel_.setForeground(Color.green);
        degreesIncLabel_.repaint();
        finalFrameButtonArmedP_ = false;
      }
    } 
  }
  
  class OKLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      setVisible(false);
      spec_.destination = pathnameText_.getText();
      if (spec_.destination != null && spec_.destination.length() == 0) {
        spec_.destination = null;
      }
      if (choicesMenuButton_.getSelectedItem().equals(pivotString_)) {
        if (setTempFloat(degreesIncText_.getText())) {
          spec_.degrees = tempFloat_;
        }
      } else if (choicesMenuButton_.getSelectedItem().equals(shiftString_)) {
        if (setTempFloat(degreesIncText_.getText())) {
          spec_.shift = tempFloat_;
        }
      }
      if (spec_.startSpec() != null &&
          spec_.endSpec() != null && // Only true is zoom and end button was clicked.
          spec_.startSpec().equal_p(spec_.endSpec()) ) {
        spec_.setStartSpec(null);
      }
      spec_.enabled_p = true;
      
      frame_.setSeqSpec(spec_, (spec_.startSpec() != null), (spec_.endSpec() != null));
    } 
  }
  
  class CancelLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      spec_.enabled_p = false;
      spec_.setStartSpec(null);
      setVisible(false);
    }
  }
  
  
  class VPivotLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      spec_.setHorizontalPivotP(!spec_.horizontalPivotP());
      vertPivotButton_.setLabel(spec_.horizontalPivotP() ? pivotHString : pivotVString);
    }  
  }
    
}
